OCaml 5.3.0 (8 January 2025)
----------------------------

(Changes that can break existing programs are marked with a "*")

### Restored backend:

- #12954: Restore the MSVC port
  (David Allsopp, Antonin Décimo, Samuel Hym, and Miod Vallat, review by Nicolás
   Ojeda Bär)

- #13093: Allow building the MSVC port with clang-cl.
  (Antonin Décimo, review by Nicolás Ojeda Bär, Samuel Hym,
   David Allsopp and Sébastien Hinderer)

### Language features:

- #12828, #13283: Add short syntax for dependent functor types `(X:A) -> ...`
  (Jeremy Yallop, review by Nicolás Ojeda Bär and Gabriel Scherer)

- #12309, #13158: Add syntax support for deep effect handlers
  (Leo White, Tom Kelly, Anil Madhavapeddy, KC Sivaramakrishnan, Xavier Leroy
   and Florian Angeletti, review by the same, Hugo Heuzard, and Ulysse Gérard)

- #11736, #12664, #13628: Support utf-8 encoded source files and latin-9
  compatible identifiers.
  (Xavier Leroy and Florian Angeletti, review by Daniel Bünzli and
   Jules Aguillon)

### Type system

- #11891, #12507: Allow to name new locally abstract types in constructor type
  annotations.
  (Jacques Garrigue, report and review by Gabriel Scherer and Florian Angeletti)

### Runtime system:

- #13419: Fix memory bugs in runtime events system.
  (B. Szilvasy and Nick Barnes, review by Miod Vallat, Nick Barnes,
   Tim McGilchrist, and Gabriel Scherer)

- #13364: Emit major slice counters in the runtime events.
  (KC Sivaramakrishnan and Sadiq Jaffer, review by Gabriel Scherer)

- #13382: Add more documentation for Runtime_events types
  (Sadiq Jaffer, review by Tim McGilchrist, Miod Vallat and KC Sivaramakrishnan)

- #13370: Fix a low-probability crash when calling Gc.counters.
  (Demi Marie Obenour, review by Gabriel Scherer)

- #13272: Allow maximum number of domains to be specified as a OCAMLRUNPARAM
  parameter.
  (KC Sivaramakrishnan, review by Guillaume Munch-Maccagnoni, Miod Vallat,
   Gabriel Scherer, David Allsopp, request by Zachary Yedidia).

- #11911, #12923: Multicore statistical memory profiling.
  This restores a notable OCaml 4 feature that was missing
  in OCaml 5.
  (Nick Barnes, review by Stephen Dolan, Jacques-Henri Jourdan
   and Guillaume Munch-Maccagnoni).

- #12579: OS-based Synchronisation for Stop-the-World Sections
  (B. Szilvasy, review by Miod Vallat, Nick Barnes, Olivier Nicole,
   Gabriel Scherer and Damien Doligez)

- #12789: Restore caml_unregister_frametable from OCaml 4
  (Frédéric Recoules, review by Gabriel Scherer)

- #13003: new, more consistent names for array-creation C functions
  (Gabriel Scherer, review by Olivier Nicole)

- #13013: introduce a `caml_result` type to supersede the
  use of 'encoded exception values' in the FFI.
  (Gabriel Scherer, review by Damien Doligez,
   Guillaume Munch-Maccagnoni and Xavier Leroy,
   suggested by Guillaume Munch-Maccagnoni)

- #12407, #13226: Resource-handling improvements: add
  exception-returning variants for all exception-raising functions in
  `caml/fail.h`, for the purpose of cleaning-up state and resources
  before raising.
  (Guillaume Munch-Maccagnoni, review by Damien Doligez, Xavier Leroy
   and Gabriel Scherer)

- #13086: Avoid spurious major GC slices.
  (Damien Doligez, report by Stephen Dolan, review by Gabriel Scherer
   and Stephen Dolan)

- #11779, #13117: Improve logic for fiber stack alignment.
  (Miod Vallat, report by Damien Doligez, review by Gabriel Scherer)

- #12839: Remove ATOMIC_UINTNAT_INIT from camlatomic.h (as part of a larger
  cleanup of camlatomic.h)
  (David Allsopp, review by Antonin Décimo, Sébastien Hinderer, Samuel Hym,
   Guillaume Munch-Maccagnoni and Miod Vallat)

- #13163: Enable frame pointers on macOS x86_64
  (Tim McGilchrist, review by Sébastien Hinderer and Fabrice Buoro)

- #12951: Constify constructors and flags tables in C code (take 2).
  Now these tables will go in the readonly segment, where they belong.
  (Antonin Décimo, review by David Allsopp)

- #10696: Introduce __has_attribute and __has_c_attributes in
  <caml/misc.h> to test the support of specific atributes in C
  code. Introduce fallthrough as a wrapper around the fallthrough
  attribute.
  (Antonin Décimo, review by Nicolás Ojeda Bär, Xavier Leroy, and
   Gabriel Scherer)

- #13083: Use macros from limits.h to avoid signed-integer wrap-around.
  Introduce CAML_{U,}INTNAT_{MIN,MAX} macros to expose {u,}intnat limits.
  (Antonin Décimo, review by Nick Barnes, Xavier Leroy, Gabriel Scherer,
   and Miod Vallat)

- #13239: Check whether the compiler supports the labels as values
  extension to enable threaded code interpretation.
  (Antonin Décimo, review by Miod Vallat)

- #13238: Enable software prefetching on x86 and x86_64 when building
  with MSVC or clang-cl.
  (Antonin Décimo, review by Miod Vallat)

- #13241, #13261, #13271: Add CFI_SIGNAL_FRAME to ARM64 and RiscV runtimes,
  for the purpose of displaying backtraces correctly in GDB.
  (Tim McGilchrist, review by Miod Vallat, Gabriel Scherer and
   KC Sivaramakrishnan)

- #13139: Simplify CAMLalign to always use C23/C++11 alignas or C11
  _Alignas. Ensures that stat data is always aligned to the best
  boundary.
  (Antonin Décimo, review by Miod Vallat and Xavier Leroy)

- #13280: Check for support of compiler attributes. Allows using
  compiler attributes with clang-cl.
  (Antonin Décimo, review by Miod Vallat)

- #13243: Enable C compiler warnings internally when building with
  clang-cl or MSVC. Provide fixes too.
  (Antonin Décimo, review by Miod Vallat and Xavier Leroy)

- #13242: Define and use unreachable and trap annotation, and clean-up some
  runtime assertions.
  (Antonin Décimo, review by Miod Vallat, Gabriel Scherer, and David Allsopp)

- #13402, #13512, #13549, #13553: Revise bytecode implementation of callbacks
  so that it no longer produces dangling registered bytecode fragments.
  (Xavier Leroy, report by Jan Midtgaard, analysis by Stephen Dolan,
   review by Miod Vallat)

- #13407: Add Runtime_events.EV_EMPTY_MINOR
  (Thomas Leonard)

- #13522: Confirm runtime events ring is still active after callback.
  (KC Sivaramakrishnan, review by Sadiq Jaffer and Miod Vallat)

- #13529: Do not write to event ring after going out of stw participant set.
  (KC Sivaramakrishnan, review by Sadiq Jaffer)

### Code generation and optimizations:

- #13014: Enable compile-time option -function-sections on all previously
  unsupported native backends (POWER, riscv64 and s390x)
  (Miod Vallat, review by Nicolás Ojeda Bär)

- #7241, #12555, #13076, #13138, #13338, #13152, #13153, #13154:
  fix a soundness bug in the pattern-matching compiler
  when side-effects mutate the scrutinee during matching.
  (Gabriel Scherer, review by Nick Roberts)

- #13341: a warning when the pattern-matching compiler pessimizes code
  because side-effects may mutate the scrutinee during
  matching. (This warning is disabled by default, as this rarely
  happens and its performance impact is typically not noticeable.)
  (Gabriel Scherer, review by Nick Roberts, Florian Angeletti
   and David Allsopp)

- #13179: Fix evaluation of toplevel lets in classes containing
  local opens
  (Vincent Laviron, review by Hugo Heuzard, Nathanaëlle Courant
   and Gabriel Scherer)

- #13543: Remove some String-Bytes conversion from the stdlib to behave better
  with js_of_ocaml
  (Hugo Heuzard, review by Gabriel Scherer)

### Standard library:

- #12884: Add `Queue.drop`
  (Léo Andrès, review by Nicolás Ojeda Bär and Gabriel Scherer)

- #13168: In Array.shuffle, clarify the code that validates the
  result of the user-supplied function `rand`, and improve the
  error message that is produced when this result is invalid.
  (François Pottier, review by Florian Angeletti, Daniel Bünzli
   and Gabriel Scherer)

- #12133: Expose support for printing substrings in Format
  (Florian Angeletti, review by Daniel Bünzli, Gabriel Scherer
   and Nicolás Ojeda Bär)

- #12869: Add List.take, List.drop, List.take_while and List.drop_while
  (Kate Deplaix and Oscar Butler-Aldridge, review by Nicolás Ojeda Bär,
   Craig Ferguson and Gabriel Scherer)

- #12885: move Dynarray to an unboxed representation
  (Gabriel Scherer, suggestions by Vincent Laviron,
   review by Olivier Nicole and Simon Cruanes, Yann Leray, Alain Frisch)

- #13047: Add Sys.poll_actions to (only) run pending runtime actions.
  (Nick Barnes, review by Gabriel Scherer, Guillaume Munch-Maccagnoni, and
  Vincent Laviron)

- #13144: Dynarray.{equal, compare}
  (Gabriel Scherer,
   review by Jeremy Yallop, Daniel Bünzli and Olivier Nicole,
   request by Olivier Nicole)

- #13171: expose `Domain.self_index : unit -> int` (a somewhat-dense
  indexing of currently-running domains) for advanced use-cases of
  domain-indexed concurrent data structures.
  (Gabriel Scherer,
   review by KC Sivaramakrishnan, Miod Vallat and Nicolás Ojeda Bär,
   report by Vesa Karvonen)

- #13197: Dynarray.blit, which allows to extend the destination
  dynarray (0 <= dst_pos <= dst_length).
  (Gabriel Scherer, report by Hazem Elmasry,
   review by Olivier Nicole, Hazem Elmasry and Nicolás Ojeda Bär)

* #13240: Add Uchar.seeded_hash, Change Uchar.hash implementation.
  Previously, Uchar.hash was aliased to Uchar.to_int. If you need that behavior,
  change your module instantiation from eg `module HT = Hashtbl.Make(Uchar)` to
  ```
    module HT = Hashtbl.Make(struct
      ...
      let hash = Uchar.to_int
    end)
  ```
  If the current implementation is desired, and you have a hashtable module `HT`
  (produced with the `Make` functor) in persistent storage, use `HT.rebuild` to
  ensure it doesn't break when reading from or writing to buckets.
  (Hazem ElMasry, review by Gabriel Scherer and Nicolás Ojeda Bär)

- #13318: Fix regression in GC alarms, and fix them for flambda.
  (Guillaume Munch-Maccagnoni, report by Benjamin Monate, review by
   Vincent Laviron and Gabriel Scherer)

- #13296: Add mem, memq, find_opt, find_index, find_map and find_mapi
  to Dynarray.
  (Jake H, review by Gabriel Scherer and Florian Angeletti)

### Other libraries:

- #11996: release the dependency of dynlink on compilerlibs.
  (Sébastien Hinderer and Stephen Dolan, review by Damien Doligez and
  Hugo Heuzard)

- #13326: Implement Unix.O_APPEND on windows.
  (Romain Beauxis, review by Miod Vallat, Gabriel Scherer and Antonin Décimo)

### Tools:

- #11716: ocamllex: mismatched parentheses and curly brackets are now caught
  by ocamllex, instead of causing invalid OCaml code to be generated.
  (Demi Marie Obenour, review by Damien Doligez and Xavier Leroy)

- #12904: Run the testsuite with ThreadSanitizer on a PR when label
  `run-thread-sanitizer` is added
  (Olivier Nicole, suggested by Sébastien Hinderer and David Allsopp, review by
   Gabriel Scherer)

* #13114: Support ocamldebug remote debugging over IPv6 on all
  platforms, and over Unix domain sockets on Windows.
  (Antonin Décimo, review by Gabriel Scherer and Miod Vallat)

- #13136: Rewrite GDB extensions and macros in debugger-agnostic Python, and add
  LLDB support for them.
  (Nick Barnes, review by Tim McGilchrist and Gabriel Scherer)

### Toplevel:

- #12891: Improved styling for initial prompt
  (Florian Angeletti, review by Gabriel Scherer)

- #13053: Improved display of builtin types such as `_ list` when aliased.
  (Samuel Vivien, review by Florian Angeletti)

### Manual and documentation:

- #13370: Document that that temporary variables holding GCd pointers must
  not be live across a GC.
  (Demi Marie Obenour)

- #12298: Manual: emphasize that Bigarray.int refers to an OCaml integer,
  which does not match the C int type.
  (Edwin Török, review by Florian Angeletti)

- #12868: Manual: simplify style colours of the post-processed manual and API
  HTML pages, and fix the search button icon
  (Yawar Amin, review by Simon Grondin, Gabriel Scherer, and Florian Angeletti)

- #12949: document OCaml release cycles and version strings in
   `release-info/introduction.md`.
  (Florian Angeletti, review by Fabrice Buoro, Kate Deplaix, Damien Doligez, and
   Gabriel Scherer)

- #12976: Manual: use webman/<version>/*.html and
  webman/<version>/api/ for OCaml.org HTML manual generation
  (Shakthi Kannan, review by Hannes Mehnert, and Florian Angeletti)

- #13045: Emphasize caution about behaviour of custom block finalizers.
  (Nick Barnes)

- #13216: document the new `caml_result` type in the FFI chapter of the manual.
  (Gabriel Scherer, review by Miod Vallat, Daniel Bünzli, Nick Barnes,
   Guillaume Munch-Maccagnoni and Antonin Décimo)

- #13287: stdlib/sys.mli: Update documentation on Sys.opaque_identity
  following #9412.
  (Matt Walker, review by Guillaume Munch-Maccagnoni and Vincent Laviron)

- #13295: Use syntax for deep effect handlers in the effect handlers manual
  page.
  (KC Sivaramakrishnan, review by Anil Madhavapeddy, Florian Angeletti and Miod
   Vallat)

- #13424: Fix `Gc.quick_stat` documentation to clarify that returned fields
  `live_words`, `live_blocks`, `free_words`, and `fragments` are not zero.
  (Jan Midtgaard, review by Damien Doligez and KC Sivaramakrishnan)

- #13440: Update documentation of `Gc.{control,get,set}` to reflect fields
  not currently supported on OCaml 5.
  (Jan Midtgaard, review by Gabriel Scherer)

- #13469, #13474, #13535: Document that [Hashtbl.create n] creates a hash table
  with a default minimal size, even if [n] is very small or negative.
  (Antonin Décimo, Nick Bares, report by Nikolaus Huber and Jan Midtgaard,
   review by Florian Angeletti, Anil Madhavapeddy, Gabriel Scherer,
   and Miod Vallat)

- #13666: Rewrite parts of the example code around nested lists in Chapter 6
  (Polymorphism and its limitations -> Polymorphic recursion) giving the
  "depth" function [in the non-polymorphically-recursive part of the example]
  a much more sensible behavior; also fix a typo and some formatting.
  (Frank Steffahn, review by Florian Angeletti)

- #13668: Document the basic support for unicode identifiers and the switch to
   UTF-8 encoded Unicode text for OCaml source file
  (Florian Angeletti, review by Nicolás Ojeda Bär and Daniel Bünzli)

### Compiler user-interface and warnings:

* #12084, #13669, #13673: Check link order when creating archive and when using
   ocamlopt.
  (Hugo Heuzard, review by Stefan Muenzel and Sébastien Hinderer)

- #12980: Explain type mismatch involving first-class modules by including
  the module level error message
  (Florian Angeletti, review by Vincent Laviron)

- #12985, #12988: Better error messages for partially applied functors.
  (Florian Angeletti, report by Arthur Wendling, review by Gabriel Scherer)

- #13034, #13260: Better error messages for mismatched function labels
  (Florian Angeletti, report by Daniel Bünzli, review by Gabriel Scherer and
   Samuel Vivien)

- #13051: Add a "Syntax error" to error messages for invalid package signatures.
  (Samuel Vivien, review by Gabriel Scherer)

- #13099: Fix erroneous loading of cmis for some module type errors.
  (Nick Roberts, review by Florian Angeletti)

- #13151, name conflicts explanation as a footnote
  (Florian Angeletti, review by Gabriel Scherer)

- #13228: Re-export Cmt2annot.{iterator,binary_part} which had become hidden
  since #11288 and broke ocamlbrowser.
  (David Allsopp, report by Jacques Garrigue, review by Sébastien Hinderer)

- #13251: Register printer for errors in Emitaux
  (Vincent Laviron, review by Miod Vallat and Florian Angeletti)

- #13255: Re-enable warning 34 for unused locally abstract types
  (Nick Roberts, review by Chris Casinghino and Florian Angeletti)

- #12182: Improve the type clash error message.
  For example, this message:
    This expression has type ...
  is changed into:
    The constant "42" has type ...
  (Jules Aguillon, review by Gabriel Scherer and Florian Angeletti)

- #13471: add `-keywords <version?+list>` flag to define the list of keywords
  recognized by the lexer, for instance `-keywords 5.2` disable the `effect`
  keyword.
  (Florian Angeletti, review by Gabriel Scherer)

### Internal/compiler-libs changes:

- #11129, #11148: enforce that ppxs do not produce `parsetree`s with
  an empty list of universally quantified type variables
  (`. int -> int` instead of `'a . int -> int'`)
  (Florian Angeletti, report by Simmo Saan, review by Gabriel Scherer)

- #12534: document and refactor Matching.mk_failaction_pos
  (Gabriel Scherer, review by Vincent Laviron and Nick Roberts)

- #13076: change the handling of Match_failure exits in the pattern-matching
  compiler, to prepare for a complete fix for #7241
  (Gabriel Scherer, review by Thomas Refis and Nick Roberts)

- #12896: Simplify the compilation of custom bytecode runtimes by explicitly
  compiling the primitives file before calling the linker. Tidy-up both the
  generating code and the output itself for C code being generated by the
  bytecode linker in `-custom` and `-output-*` modes.
  (David Allsopp, Antonin Décimo and Samuel Hym, review by Vincent Laviron)

- #12932: Remove useless code in Typecore.type_label_exp (was a fix for #4862)
  (Jacques Garrigue, review by Gabriel Scherer)

- #12943: Make transient_expr.scope a bitfield, and use it to store marks.
  Marks are automatically allocated, and removed when leaving their scope.
  Falls back to using TransientTypeSet when marks are exhausted.
  (Jacques Garrigue and Takafumi Saikawa, review by Basile Clément)

- #12946: Make generalization automatic when leaving scope.
  As a result, the `Ctype.generalize*` and `Ctype.correct_levels` functions
  were removed. The latter is now called `Ctype.duplicate_type`.
  (Jacques Garrigue and Takafumi Saikawa, review by Richard Eisenberg)

- #12968: Attach location to constants in the parsetree
  (Jules Aguillon, review by Gabriel Scherer)

- #12959, #13055: Avoid an internal error on recursive module type inconsistency
  (Florian Angeletti, review by Jacques Garrigue and Gabriel Scherer)

- #13049: graphical debugging printer for types
  (Florian Angeletti, review by Gabriel Scherer)

- #13074, #13082, #13084: refactoring in the pattern-matching compiler
  (Gabriel Scherer, review by Thomas Refis, Vincent Laviron and Nick Roberts)

- #13067: rework volatile memory access rules under TSan to consider properly
  aligned smaller-than-register read operations as atomic, which gets rid of
  false positives on s390x
  (Miod Vallat, review by Fabien Buoro)

- #13162: Use quoted strings to clarify code being generated.
  (Antonin Décimo, review by Miod Vallat and Gabriel Scherer)

- #13015: Emit floating-point literals in .rodata section on ELF arm64
  platforms (Linux, *BSD).
  (Miod Vallat, review by Nicolás Ojeda Bär)

- #13169, #13311: Introduce a document data type for compiler messages
  rather than relying on `Format.formatter -> unit` closures.
  (Florian Angeletti, review by Gabriel Scherer)

- #13193: Remove the unused env_init field from class blocks
  (Vincent Laviron, review by Jacques Garrigue)

- #13257: integrate MetaOCaml in the Menhir grammar to ease MetaOCaml
  maintenance. This is a purely internal change: there is no support
  in the lexer, so no change to the surface OCaml grammar.
  (Oleg Kiselyov, Gabriel Scherer and Florian Angeletti,
   review by Jeremy Yallop)

- #13286: Distinguish unique identifiers `Shape.Uid.t` according to their
  provenance: either an implementation or an interface.
  (Ulysse Gérard, review by Florian Angeletti and Leo White)

- #13289: Use C99 for loop to reduce the scope of the for loop iterator.
  (Antonin Décimo, review by Miod Vallat and Gabriel Scherer)

- #13308: keep track of relations between declaration in the cmt files. This is
  useful information for external tools for navigation and analysis purposis.
  (Ulysse Gérard, Florian Angeletti, review by Florian Angeletti and Gabriel
  Scherer)

- #13336: compiler-libs, split the `Printtyp` in three to only keep
  "user-friendly" functions in the `Printtyp` module.
  (Florian Angeletti, review by Gabriel Scherer)

- #13361: split runtime/array.c functions to consistently expose
  uniform_array and floatarray versions, use floatarray versions
  in Float.Array.
  (Gabriel Scherer, review by Nicolás Ojeda Bär)

- #13507: A small refactoring to [free_vars] to make it a bit faster
  by not allocating a list when the list is not necessary.
  (Richard Eisenberg, review by Jacques Garrigue)

### Build system:

- #12909: Reorganise how MKEXE_VIA_CC is built to make it correct for MSVC by
  grouping all the linker flags at the end of the C compiler commandline
  (David Allsopp and Samuel Hym, review by Nicolás Ojeda Bär)

- #12992, #13009: Check that flexlink can be executed only when building in a
  native windows environment.
  (Romain Beauxis, review by David Allsopp and Sébastien Hinderer)

- #12996: Only link with -lgcc_eh when available.
  (Romain Beauxis, review by David Allsopp and Miod Vallat)

* #13200: Do not use CFLAGS for linking.
  (Sébastien Hinderer, review by Gabriel Scherer, Antonin Décimo,
  Miod Vallat and Samuel Hym)

- #13201, #13244: Fix and speedup builds with TSan.
  (Sébastien Hinderer, review by Miod Vallat, Gabriel Scherer and
  Olivier Nicole)

* #12578, #12589, #13322, #13519: Use configured CFLAGS and CPPFLAGS *only*
  during the build of the compiler itself. Do not use them when
  compiling third-party C sources through the compiler. Flags for
  compiling third-party C sources can still be specified at configure
  time in the COMPILER_{BYTECODE,NATIVE}_{CFLAGS,CPPFLAGS}
  configuration variables.
  (Sébastien Hinderer, report by William Hu, review by David Allsopp)

- #13285: continue the merge of the sub-makefiles into the root
  Makefile started with #11243, #11248, #11268, #11420, #11675,
  #12198, #12321, #12586, #12616, #12706 and #13048.
  (Sébastien Hinderer, review by David Allsopp and Florian Angeletti)

### Bug fixes:

- #12854: Add a test in the regression suite that flags the bug #12825.
  (Luc Maranget)

- #12888: fix printing of uncaught exceptions in `.cmo` files passed on the
  command-line of the toplevel.
  (Nicolás Ojeda Bär, review by Florian Angeletti, report by Daniel Bünzli)

- #12910, #12920: Fix an unsound interaction between first-class modules
  and polymorphic records by saving and restoring univar_pairs.
  (Stephen Dolan, review by Gabriel Scherer, report by Jeremy Yallop)

- #12994: Remove un-used and unsafe caml_drop_continuation
  (Tim McGilchrist, reviewed by Gabriel Scherer and Miod Vallat)

- #12963: Restore caml_runtime_parameters implementation. This primitive allows
  programs to query the runtime parameters supplied to an OCaml program.
  Implementation missing since OCaml 5.0.
  (Tim McGilchrist, reviewed by David Allsopp and Miod Vallat)

- #13012: parsing: Fix dropped attributes after a '-' or '+'
  The syntax '-(1 [@foo])' was incorrectly parsed as '-1'.
  (Jules Aguillon, reviewed by Gabriel Scherer, report by Gabriel Scherer)

* #13070: On Windows, when configured with bootstrapped flexdll, don't add
  +flexdll to the search path when -nostdlib is specified (which then means
  -L <path-to-flexdll> no longer gets passed to the system linker).
  (David Allsopp, review by Florian Angeletti)

- #13089: Fix bug in `runtime_events` library which could result in garbled
  output under Windows.
  (B. Szilvasy, review by Nicolás Ojeda Bär and Miod Vallat)

- #13088: A few type-checker behaviors look at a type to see if there are
  any labeled arguments in it. This sometimes required expansion, which
  could, in obscure scenarios, result in superfluous type errors.
  (Richard Eisenberg, review by Gabriel Scherer and Jacques Garrigue)

- #13103: FreeBSD/amd64: properly annotate .o files with non-executable stack
  notes (Konstantin Belousov, review by Nicolás Ojeda Bär)

- #13150: improve a transitive-closure computation algorithm in the flambda
  middle-end to avoid a compilation time blowup on Menhir-generated code
  (Florian Weimer, review by Gabriel Scherer and Pierre Chambart,
   report by Richard Jones)

- #13166: Fix a MinGW/MSVC Sys.rename regression on renaming a parent directory
  to an empty child directory.
  (Jan Midtgaard, review by Antonin Décimo, Sébastien Hinderer, and
   David Allsopp)

- #13185, #13192: Reject type-level module aliases on functor parameter
  inside signatures.
  (Jacques Garrigue, report by Richard Eisenberg, review by Florian Angeletti)

- #13170: Fix a bug that would result in some floating alerts `[@@@alert ...]`
  incorrectly triggering Warning 53.
  (Nicolás Ojeda Bär, review by Chris Casinghino and Florian Angeletti)

- #13203: Do not issue warning 53 if the compiler is stopping before attributes
  have been accurately marked.
  (Chris Casinghino, review by Florian Angeletti)

- #13207: Be sure to reload the register caching the exception handler in
  caml_c_call and caml_c_call_stack_args, as its value may have been changed
  if the OCaml stack is expanded during a callback.
  (Miod Vallat, report by Vesa Karvonen, review by Gabriel Scherer and
   Xavier Leroy)

- #13209: Fix configure test that checks whether `ar` supports `@FILE`
  arguments.
  (Nicolás Ojeda Bär, report by Boris D.)

- #13221: Compute more accurate instruction sizes for branch relocation on
  POWER.
  (Miod Vallat, review by Gabriel Scherer)

- #13252: Rework register assignment in the interpreter code on m68k on Linux,
  due to the %a5 register being used by Glibc.
  (Miod Vallat, report by Stéphane Glondu, review by Gabriel Scherer and
   Xavier Leroy)

- #13247: Disable lib_unix/kill test for MacOS AMD64 with TSan, linking
  to llvm bug report causing infinite signal loops.
  (Tim McGilchrist, review by Olivier Nicole, Miod Vallat, Sébastien Hinderer
  and Gabriel Scherer)

- #13234, #13267: Open runtime events file in read-write mode on armel
  (armv5) systems due to atomic operations limitations on that
  platform.
  (Stéphane Glondu, review by Miod Vallat and Vincent Laviron)

- #13273: Fix a call to test in configure.ac that was causing errors when
  LDFLAGS contains several words.
  (Stéphane Glondu, review by Miod Vallat)

- #13290: Fix uninitialized and out of bounds reads in runtime_events_consumer.c
  (Edwin Török, review by Miod Vallat and Antonin Décimo)

- #13306: An algorithm in the type-checker that checks two types for equality
  could sometimes, in theory, return the wrong answer. This patch fixes the
  oversight. No known program triggers the bug.
  (Richard Eisenberg, review by Florian Angeletti)

- #13400: Initialize th->signal_stack to avoid free of uninitialized data
  if the user calls caml_c_thread_unregister on the main thread.
  (Richard W.M. Jones, review by Guillaume Munch-Maccagnoni and
  Gabriel Scherer)

- #13140: POWER back-end: fix issue with call to `caml_call_realloc_stack`
  from a DLL
  (Xavier Leroy, review by Miod Vallat)

- #13263, #13560: fix printing true and false in toplevel and error
  messages (no more unexpected \#true)
  (Florian Angeletti, report by Samuel Vivien, review by Gabriel Scherer)

- #13388, #13540: raises an error message (and not an internal compiler error)
  when two local substitutions are incompatible (for instance `module type
  S:=sig end type t:=(module S)`)
  (Florian Angeletti, report by Nailen Matschke, review by Gabriel Scherer, and
  Leo White)

- #13408: Fix misplaced debug runtime assertion triggerable by a race
  between domain exit and backup thread
  (Miod Vallat and Gabriel Scherer, report by Jan Midtgaard)

- #13417: `Filename.quote_command`: fix handling of forward slashes in program
  path under Win32.
  (Nicolás Ojeda Bär, review by David Allsopp and Damien Doligez)

- #13501: Regression on mutually recursive types caused by #12180.
  Resuscitate Typedecl.update_type.
  (Jacques Garrigue and Takafumi Saikawa, review by Florian Angeletti, Richard
  Eisenberg and Gabriel Scherer)

- #13502: Fix misindexing related to `Gc.finalise_last` that could prevent
  finalisers from being run.
  (Nick Roberts, review by Mark Shinwell)

- #13495, #13514: Fix typechecker crash while typing objects
  (Jacques Garrigue, report by Nicolás Ojeda Bär, review by
   Nicolas Ojeda Bär, Gabriel Scherer, Stephen Dolan, Florian Angeletti)

- #13391, #13551: fix a printing bug with `-dsource` when using
  raw literal inside a locally abstract type constraint
  (i.e. `let f: type \#for. ... `)
  (Florian Angeletti, report by Nick Roberts, review by Richard Eisenberg)

- #13520: Fix compilation of native-code version of systhreads. Bytecode fields
  were being included in the thread descriptors.
  (David Allsopp, review by Sébastien Hinderer and Miod Vallat)

- #13541, #13591: Fix headers for C++ inclusion.
  (Antonin Décimo, review by Nick Barnes, report by Kate Deplaix)

- #13579, #13583: Unsoundness involving non-injective types + gadts
  (Jacques Garrigue, report by @v-gb,
   review by Richard Eisenberg and Florian Angeletti)

- #13598: Falsely triggered warning 56 [unreachable-case]
  This was caused by unproper protection of the retyping function.
  (Jacques Garrigue, report by Tõivo Leedjärv, review by Florian Angeletti)

- #13603, #13604: fix source printing in the presence of the escaped raw
  identifier `\#mod`.
  (Florian Angeletti, report by Chris Casinghino, review by Gabriel Scherer)

OCaml 5.2.0 (13 May 2024)
-------------------------

(Changes that can break existing programs are marked with a "*")

### Restored and new backends:

- #12276, #12601: native-code compilation for POWER (64 bits, little-endian)
  (Xavier Leroy, review by KC Sivaramakrishnan, Anil Madhavapeddy,
   and Stephen Dolan)

- #12667: extend the latter to POWER 64 bits, big-endian, ELFv2 ABI
  (A. Wilcox, review by Xavier Leroy)

### Language features:

- #12295, #12568: Give `while true' a polymorphic type, similarly to
  `assert false'
  (Jeremy Yallop, review by Nicolás Ojeda Bär and Gabriel Scherer,
  suggestion by Rodolphe Lepigre and John Whitington)

- #12315: Use type annotations from arguments in let rec
  (Stephen Dolan, review by Gabriel Scherer)

- #11252, RFC 27: Support raw identifier syntax \#foo
  (Stephen Dolan, review by David Allsopp, Gabriel Scherer and Olivier Nicole)

- #12044: Add local module open syntax for types.
  ```
    module A = struct
      type t = int
      type r = unit
      type s = string
    end

    type example = A.(t * r * s)
  ```
  (Alistair O'Brien, review by Gabriel Scherer, Nicolás Ojeda Bär
   and Florian Angeletti)

- #12456: Document the incompatibility between effects on the one
  hand, and `caml_callback` and asynchronous callbacks (signal
  handlers, finalisers, memprof callbacks...) on the other hand.
  (Guillaume Munch-Maccagnoni, review by KC Sivaramakrishnan)

- #12375: allow use of [@untagged] for all immediate types like char, bool,
  and variant with only constant constructors.
  (Christophe Raffalli, review by Gabriel Scherer)

* #12502: the compiler now normalizes the newline sequence \r\n to
  a single \n character during lexing, to guarantee that the semantics
  of newlines in string literals is not modified by Windows tools
  transforming \n into \r\n in source files.
  Warning 29 [eol-in-string] is not emitted anymore, as the normalization
  gives a more robust semantics to newlines in string literals.
  (Gabriel Scherer and Damien Doligez, review by Daniel Bünzli, David
   Allsopp, Andreas Rossberg, Xavier Leroy, report by Andreas Rossberg)

- #13130: minor fixes to pprintast for raw identifiers and local module open
  syntax for types.
  (Chet Murthy, review by Gabriel Scherer)

### Type system:

- #12313, #11799: Do not re-build as-pattern type when a ground type annotation
  is given. This allows to work around problems with GADTs in as-patterns.
  (Jacques Garrigue, report by Leo White, review by Gabriel Scherer)

### Runtime system:

- #12193: Re-introduce GC compaction for shared pools
  Adds a parallel compactor for the shared pools (which contain major heap
  blocks sized less than 128 words). Explicit only for now, on calls to
  `Gc.compact`.
  (Sadiq Jaffer, Nick Barnes, review by Anil Madhavapeddy, Damien Doligez,
   David Allsopp, Miod Vallat, Artem Pianykh, Stephen Dolan, Mark Shinwell
   and KC Sivaramakrishnan)

- #12850: Update Gc.quick_stat data at the end of major cycles and compaction
  This PR adds an additional caml_collect_gc_stats_sample_stw to the major heap
  cycling stw. This means that Gc.quick_stat now actually reflects the state of
  the heap after a major cycle or compaction.
  (Sadiq Jaffer, review by Miod Vallat and Gabriel Scherer)

- #12859: Ensure Gc.compact does a full major before the compactor runs
  (Sadiq Jaffer, review by Leo White, Mark Shinwell, Gabriel Scherer,
   Josh Berdine, David Allsopp and KC Sivaramakrishnan)

- #10111: Increase the detail of location information for debugging events to
  allow the end line number and character offset to be reported.
  (David Allsopp, review by Nick Barnes, Enguerrand Decorne and Stephen Dolan)

- #10403, #12202: introduce `caml_ext_table_add_noexc` that does not
  raise `Out_of_memory` exceptions and use it inside the blocking sections
  of `caml_read_directory`.  Also, check for overflows in ext table sizes.
  (Xavier Leroy, report by Arseniy Alekseyev, review by Gabriel Scherer)

- #11332, #12702: make sure `Bool_val(v)` has type `bool` in C++
  (Xavier Leroy, report by ygrek, review by Gabriel Scherer)

- #12772, #12787: Avoid using _Bool in public headers for the sake of C++
  compatibility
  (Guillaume Munch-Maccagnoni, report by KC Sivaramakrishnan, review
  by Xavier Leroy and KC Sivaramakrishnan)

- #12223: Constify constructors and flags tables in C code. Now these
  tables will go in the readonly segment, where they belong.
  (Antonin Décimo, review by Gabriel Scherer and Xavier Leroy)

- #12234: make instrumented time calculation more thread-safe on macOS.
  (Anil Madhavapeddy, review by Daniel Bünzli and Xavier Leroy)

- #12235, #12468: introduce and use the `CAMLnoret` macro as
  a lighter alternative to `CAMLnoreturn_start` / `CAMLnoreturn_end`.
  Implement it so as to conform with C11, C23, C++11, C++17.
  (Xavier Leroy and Dhruv Maroo, with help from Antonin Décimo, review by
   Gabriel Scherer and David Allsopp)

- #12275: caml/stack.h: more abstract macros to describe OCaml stacks and
  how to traverse them, supporting more stack layouts.
  (Xavier Leroy, review by KC Sivaramakrishnan and Fabrice Buoro)

- #12268: deliver `Out_of_memory` exception if domain creation fails
  due to memory resource exhaustion.  It was previous always a `Failure`.
  (Anil Madhavapeddy, review by David Allsopp)

- #12300, #12314: Discard out_channel buffered data on permanent I/O error
  (Xavier Leroy, report by Török Edwin, review by Anil Madhavapeddy
  and Nicolás Ojeda Bär)

- #11386: Simplifications and fixes to multicore systhreads implementation.
  (Guillaume Munch-Maccagnoni, review by Anil Madhavapeddy and KC
   Sivaramakrishnan)

- #12875, #12879, #12882: Execute preemptive systhread switching as a
  delayed pending action. This ensures that one can reason within the
  FFI that no mutation happens on the same domain when allocating on
  the OCaml heap from C, consistently with OCaml 4. This also fixes
  further bugs with the multicore systhreads implementation.
  (Guillaume Munch-Maccagnoni, bug reports and suggestion by Mark
   Shinwell, review by Nick Barnes and Stephen Dolan)

- #12408: `Domain.spawn` no longer leaks its functional argument for
  the whole duration of the children domain lifetime.
  (Guillaume Munch-Maccagnoni, review by Gabriel Scherer)

- #12409: Fix unsafety and deadlocks should an asynchronous exception
  arise at specific locations during domain creation and shutdown.
  (Guillaume Munch-Maccagnoni, review by Gabriel Scherer)

- #12114: Add ThreadSanitizer support
  (Fabrice Buoro and Olivier Nicole, based on an initial work by Anmol Sahoo,
   review by Damien Doligez, Sébastien Hinderer, Jacques-Henri Jourdan, Luc
   Maranget, Guillaume Munch-Maccagnoni, Gabriel Scherer)

- #11911, #12381: Restore statmemprof functionality in part, with
  some API changes in Gc.Memprof.
  (Nick Barnes, review by Jacques-Henri Jourdan
   and Guillaume Munch-Maccagnoni).

- #12430: Simplify dynamic bytecode loading in Meta.reify_bytecode
  (Stephen Dolan, review by Sébastien Hinderer, Vincent Laviron and Xavier
   Leroy)

- #12489: Fix an error-handling bug in caml_alloc_sprintf
  (Stephen Dolan, report by Chris Casinghino, review by Jeremy Yallop
   and Xavier Leroy)

- #11307: Finish adapting the implementation of asynchronous actions for
  multicore: soundness, liveness, and performance issues.
  Do not crash if a signal handler is called from an unregistered C
  thread, and other possible soundness issues. Prevent issues where join
  on other domains could make the toplevel unresponsible to Ctrl-C. Avoid
  needless repeated polling in C code when callbacks cannot run
  immediately.
  (Guillaume Munch-Maccagnoni, review by Enguerrand Decorne, Xavier
  Leroy, and KC Sivaramakrishnan)

- #12634: Simplify TSan backtrace bookkeeping upon raise
  (Olivier Nicole and Fabrice Buoro, review by Gabriel Scherer)

* #12686: Some primitives had the wrong types to be callable from the bytecode
  interpreter.  Either fix their types, mark them as `CAMLexport` instead of
  `CAMLprim`, or remove them entirely if no longer used.
  (Xavier Leroy, review by David Allsopp)

- #12700, continuing #11763 and trying to address #12660:
  Use the correct types for primitives when generating the table of primitives
  used by ocamlrun.
  (Xavier Leroy, motivation, review and improvements by Antonin Décimo)

- #12345, #12710: Fix issues with finaliser orphaning at domain termination
  (KC Sivaramakrishnan, report by Gabriel Scherer, review by Gabriel Scherer,
  Sadiq Jaffer and Fabrice Buoro)

- #12599: Refactor Dynlink startup to avoid parsing bytecode sections twice
  (Stephen Dolan, review by David Allsopp, Hugo Heuzard, Damien Doligez and
   Xavier Leroy)

- #12678, #12898: free channel buffers on close rather than on finalization
  (Damien Doligez, review by Jan Midtgaard and Gabriel Scherer, report
   by Jan Midtgaard)

- #12681: Fix TSan false positives due to volatile write handling
  (Olivier Nicole, Fabrice Buoro and Anmol Sahoo, review by Luc Maranget,
   Gabriel Scherer, Hernan Ponce de Leon and Xavier Leroy)

- #12743: Use pthread_sigmask instead of sigprocmask
  Updates usage of sigprocmask to pthread_sigmask in otherlibs/unix.
  (Max Slater, review by Miod Vallat and Xavier Leroy)

- #12769: Unify MSVC and MinGW-w64 code paths, by always using WinAPI
  directly.
  (David Allsopp, Antonin Décimo, and Samuel Hym, review by Nicolas
   Ojeda Bar)

- #11911, #12382, #12383: Restore statmemprof functionality in part
  (backtrace buffers, per-thread and per-domain data structures,
  GC/allocation interface). (Nick Barnes, review by Gabriel Scherer,
  Fabrice Buoro, Sadiq Jaffer, Guillaume Munch-Maccagnoni, and
  Jacques-Henri Jourdan).

- #12735: Store both ends of the stack chain in continuations
  (Leo White, review by Miod Vallat and KC Sivaramakrishnan)

- #12746: Simplify and clean up TSan annotations
  (Olivier Nicole, review by Miod Vallat and Fabrice Buoro)

- #12809: Add ThreadSanitizer support to FreeBSD/amd64
  (Miod Vallat, review by Gabriel Scherer)

- #12810: Port ThreadSanitizer support to Linux and macOS on arm64
  (Miod Vallat, review by Tim McGilchrist)

- #12811: Define and use the CAMLthread_local macro for TLS variables.
  (Antonin Décimo and Samuel Hym, review by Miod Vallat and Xavier Leroy)

- #12814: More detailed failure messages from `input_value` and `Marshal.from_*`
  (Xavier Leroy, review by Stephen Dolan and Anil Madhavapeddy)

- #12815: Correctly format multi-line locations in exception backtraces, in the
  style that the compiler driver uses.
  (David Allsopp, review by Gabriel Scherer)

- #12773, #12830, #12834: Rewrite `caml_c_thread_(un)register` to fix
  various bugs.
  (Guillaume Munch-Maccagnoni, reported by Miod Vallat, suggested by
   Hari Hara Naveen S, reviewed by Fabrice Buoro, Gabriel Scherer and
   Miod Vallat)

- #12876: Port ThreadSanitizer support to Linux on POWER
  (Miod Vallat, review by Tim McGilchrist)

- #12886: Reinitialize IO mutexes after fork
  (Max Slater, review by Guillaume Munch-Maccagnoni and Xavier Leroy)

- #12907: Port ThreadSanitizer support to Linux on RiscV
  (Miod Vallat, review by Nicolás Ojeda Bär and Fabrice Buoro)

- #12915: Port ThreadSanitizer support to Linux on s390x
  (Miod Vallat, review by Tim McGilchrist)

- #12934: Fix data races between marking and sweeping functions
  (Olivier Nicole, suggested by Stephen Dolan, review by Gabriel Scherer,
   Miod Vallat and Damien Doligez)

### Code generation and optimizations:

- #11239: on x86-64 and RISC-V, reduce alignment of OCaml stacks from 16 to 8.
  This reduces stack usage.  It's only C stacks that require 16-alignment.
  (Xavier Leroy, review by Gabriel Scherer and Stephen Dolan)

- #12311: on POWER, 32-bit FP numbers stored in memory (e.g. in bigarrays)
  were not correctly rounded sometimes.
  (Xavier Leroy, review by Anil Madhavapeddy and Tim McGilchrist)

- #12551, #12608, #12782, #12596: Overhaul of recursive value compilation.
  Non-function recursive bindings are now forbidden from Lambda onwards,
  and compiled using a new Value_rec_compiler module.
  (Vincent Laviron and Lunia Ayanides, review by Gabriel Scherer,
   Stefan Muenzel and Nathanaëlle Courant)

- #1809, #12181: rewrite `compare x y op 0` to `x op y` when values are integers
  (Xavier Clerc, Stefan Muenzel, review by Gabriel Scherer and Vincent Laviron)

- #12825: disable common subexpression elimination for atomic loads... again.
  (Gabriel Scherer, review by KC Sivaramakrishnan, Xavier Leroy
   and Vincent Laviron, report by Vesa Karvonen)

### Standard library:

- #12716: Add `Format.pp_print_nothing` function.
  (Léo Andrès, review by Gabriel Scherer and Nicolás Ojeda Bär)

- #11563: Add the Dynarray module to the stdlib. Dynamic arrays are
  arrays whose length can be changed by adding or removing elements at
  the end, similar to 'vectors' in C++ or Rust.
  (Gabriel Scherer, Simon Cruanes and Florian Angeletti, review by
   Daniel Bünzli, Guillaume Munch-Maccagnoni, Clément Allain,
   Damien Doligez, Wiktor Kuchta and Pieter Goetschalckx)

* #6732, #12423: Make Buffer.add_substitute surjective and fix its
  documentation.
  (Damien Doligez, review by Antonin Décimo)

* #10775, #12499: Half-precision floating-point elements in Bigarray.
  (Anton Yabchinskiy, review by Xavier Leroy and Nicolás Ojeda Bär)

- #11517, #12477: Expose pp_infinity in interface of the format module, and
  check that margin is less than pp_infinity when setting or checking geometry.
  (Janith Petangoda, reported by Simmo Saan, reviewed by Florian Angeletti,
  Simmo Saan, Josh Berdine and Gabriel Scherer)

- #12217: Add `Array.shuffle`.
  (Daniel Bünzli, review by Nicolás Ojeda Bär, David Allsopp and Alain Frisch)

- #12212: Add cache-aligned constructor for atomics. The patch ensures that
  all allocations (of the right size) in the shared heap are aligned.
  (Bartosz Modelski with Gabriel Scherer, Guillaume Munch-Maccagnoni,
   Xavier Leroy, review by Alain Frisch, Anil Madhavapeddy, Gabriel Scherer,
   Guillaume Munch-Maccagnoni, KC Sivaramakrishnan, Stefan Muenzel,
   Xavier Leroy)

- #12307: Add BLAKE2b hashing and an MD5 submodule to the Digest module.
  (Xavier Leroy, review by Olivier Nicole, Gabriel Scherer, Wiktor Kuchta,
   Daniel Bünzli, David Allsopp)

- #12365: Add In_channel.input_bigarray, In_channel.really_input_bigarray,
  Out_channel.output_bigarray, Unix.read_bigarray, Unix.write_bigarray,
  Unix.single_write_bigarray.
  (Nicolás Ojeda Bär, review by Jeremy Yallop, Xavier Leroy, Gabriel Scherer,
   David Allsopp)

- #12455: Add `Array.init_matrix`, `Float.Array.make_matrix`,
  `Float.Array.init_matrix`.
  (Glen Mével, review by Xavier Leroy, Gabriel Scherer, Jeremy Yallop,
  Nicolas Ojeda Bar)

* #12455: `Array.make_matrix dimx dimy f` now raises `Invalid_argument`
  when `dimx = 0 && dimy < 0` This was already specified but not enforced.
  (Glen Mével, report by Jeremy Yallop, review by Nicolas Ojeda Bar)

- #12459: Add `Random.int_in_range`, `Random.int32_in_range`,
  `Random.int64_in_range`, `Random.nativeint_in_range`,
  and their counterpart in `Random.State`.
  (Glen Mével and Xavier Leroy, review by Gabriel Scherer, Xavier Leroy,
   Florian Angeletti)

- #12459: `Random`: restore compatibility between 32-bit integers (JavaScript)
  and 63-bit integers (64-bit OCaml).
  For `Random.full_int` this was guaranteed in 4.14 but wrongly removed in 5.0.
  (Xavier Leroy, review by Glen Mével)

- #12511: Minor performance improvements and cleanups in the implementation
  of modules Int32, Int64, and Nativeint
  (Xavier Leroy, review by Gabriel Scherer and Daniel Bünzli)

- #12558: Adapt GC alarms for multicore and fix their documentation.
  (Guillaume Munch-Maccagnoni, review by KC Sivaramakrishnan
   and Gabriel Scherer)

- #12625: Remove the Closure module from Obj
  (Vincent Laviron, review by Xavier Leroy)

- #12758, #12998: Remove the `Marshal.Compression` flag to the
  `Marshal.to_*` functions.  The compilers are still able to use
  ZSTD compression for compilation artefacts.
  This is a forward port and clean-up of the emergency fix that was introduced
  in OCaml 5.1.1 by #12734.
  (Xavier Leroy, review by Damien Doligez)

- #12784: Fix computation of minor-heap allocation in Gc.counters()
  and Gc.allocated_bytes(). (Nick Barnes, review by Gabriel Scherer)

- #12770: Add `Fun.compose`.
  (Justin Frank, review by Nicolás Ojeda Bär, Daniel Bünzli and Jeremy Yallop)

- #12845: Add `{In,Out}_channel.is_binary_mode` as the dual of
  `set_binary_mode`. This function was previously only available in the internal
  C API.
  (David Allsopp, review by Nicolás Ojeda Bär and Xavier Leroy)

### Other libraries:

- #12213: Dynlink library, improve legibility of error messages
  (Samuel Hym, review by Gabriel Scherer and Nicolás Ojeda Bär)

* #12686: Runtime_events library, C API: define
  `caml_runtime_events_{start,pause,resume}` as returning `void`
  instead of `value`.
  (Xavier Leroy, review by David Allsopp)

### Tools:

- #12340: testsuite: collect known issues with current -short-paths
  implementation for existential types
  (Florian Angeletti, Samuel Hym, review by Florian Angeletti and Thomas Refis)

- #12147: ocamllex: Allow carriage returns at the end of line directives.
  (SeungCheol Jung, review by Nicolás Ojeda Bär)

- #12260: Fix invalid_argument on some external or module aliases in ocamlnat
  (Fabian Hemmer, review by Vincent Laviron)

- #12185: New script language for ocamltest.
  (Damien Doligez with Florian Angeletti, Sébastien Hinderer, Gabriel Scherer,
   review by Sébastien Hinderer and Gabriel Scherer)

- #12371: ocamltest: fix recursive expansion of variables.
  (Antonin Décimo, Damien Doligez, review by Sébastien Hinderer,
   Damien Doligez, Gabriel Scherer, and Xavier Leroy)

* #12497, #12613: Make ocamlc/ocamlopt fail with an error when no
  input files are specified to build an executable.
  (Antonin Décimo, review by Sébastien Hinderer)

- #12576: ocamldep: various refactors.
  (Antonin Décimo, review by Florian Angeletti, Gabriel Scherer, and Léo Andrès)

- #12615: ocamldoc: get rid of the odoc_literate and odoc_todo generators.
  (Sébastien Hinderer, review by Gabriel Scherer and Florian Angeletti)

- #12624: Use $XDG_CONFIG_DIRS in addition to $XDG_CONFIG_HOME when searching
  for init.ml and use this to extend init.ml support to the toplevel when
  running on Windows.
  (David Allsopp, report by Jonah Beckford, review by Nicolás Ojeda Bär and
   Antonin Décimo)

- #12688: Setting the env variable `NO_COLOR` with an empty value no longer
  has effects. Previously, setting `NO_COLOR` with any value, including
  the empty value, would disable colors (unless `OCAML_COLOR` is also set).
  After this change, the user must set `NO_COLOR` with an non-empty value
  to disable colors. This reflects a specification clarification/change
  from the upstream website at https://no-color.org.
  (Favonia, review by Gabriel Scherer)

- #12744: ocamltest: run tests in recursive subdirs more eagerly
  (Nick Roberts, review by Nicolás Ojeda Bär)

- #12901, 12908: ocamllex: add overflow checks to prevent generating incorrect
  lexers; use unsigned numbers in the table encoding when possible.
  (Vincent Laviron, report by Edwin Török, review by Xavier Leroy)

### Manual and documentation:

- #12338: clarification of the documentation of process related function in
  the unix module regarding the first element of args and shell's pid.
  (Christophe Raffalli, review by Florian Angeletti)

- #12473: Document in runtime/memory.c our current understanding of
  accesses to the OCaml heap from the C runtime code -- the problem
  of hybrid programs mixing two memory models.
  (Gabriel Scherer and Guillaume Munch-Maccagnoni, review by Olivier
   Nicole and Xavier Leroy)

- #12694: Document in runtime/tsan.c the TSan instrumentation choices and the
  consequences with regard to the memory model.
  (Olivier Nicole, review by Miod Vallat, Gabriel Scherer, Guillaume
   Munch-Maccagnoni and Fabrice Buoro)

- #12802: Add manual chapter about ThreadSanitizer support
  (Olivier Nicole, review by Miod Vallat, Sebastien Hinderer, Fabrice Buoro,
   Gabriel Scherer and KC Sivaramakrishnan)

- #12819: Clarify which runtime interactions are allowed in custom ops
  (Basile Clément, review by Guillaume Munch-Maccagnoni and Xavier Leroy)

- #12840: manual: update runtime tracing chapter for custom events (ex #12335)
  (Lucas Pluvinage, Sadiq Jaffer and Olivier Nicole, review by Gabriel Scherer,
   David Allsopp, Tim McGilchrist and Thomas Leonard)

- #13066, update OCAMLRUNPARAM documentation for the stack size parameter l
  (Florian Angeletti, review by Nicolás Ojeda Bär, Tim McGilchrist, and
   Miod Vallat)

- #13078: update Format tutorial on structural boxes to mention alignment
  questions.
  (Edwin Török, review by Florian Angeletti)

- #13092: document the existence of the `[@@poll error]` built-in attribute
  (Florian Angeletti, review by Gabriel Scherer)

### Compiler user-interface and warnings:

* #10613, #12405: Simplify the values used for the system variable (`system:` in
  `ocamlopt -config` or the `Config.system` constant). In particular, s390x and
  ppc64 now report "linux" instead of "elf"; all variants of 32-bit ARM on Linux
  now report "linux"; OpenBSD now reports "openbsd" instead of "bsd" for 32-bit
  ARM; FreeBSD, NetBSD and OpenBSD now report the same value for both x86_64 and
  x86_32; x86_32 systems matching *bsd but not freebsd*, netbsd* or openbsd*
  are no longer identified (as on x86_64); x86_32 Linux now reports "linux"
  instead of "linux_elf".
  (David Allsopp, request by Kate Deplaix, review by Sébastien Hinderer and
  Xavier Leroy)

- #11989, #12246, RFC 31: New flag, -H, to allow for transitive dependencies
  without including them in the initial environment.
  (Chris Casinghino, François Bobot, and Gabriel Scherer, review by Leo White
   and Stefan Muenzel, RFC by François Bobot)

- #12247: configure: --disable-ocamldebug can now be used instead
  of --disable-debugger (which remains available for compatibility)
  (Gabriel Scherer, review by Damien Doligez and Sébastien Hinderer)

- #12199: improve the error message for non-overriding `inherit!`
  (Florian Angeletti, review by Jules Aguillon)

- #12210: uniform style for inline code in compiler messages
  (Florian Angeletti, review by Gabriel Scherer)

* #12278, #:12325: Remove the OCAML_FLEXLINK environment variable from the
  compiler drivers. This environment variable was previously used as part of the
  FlexDLL bootstrap procedure and existed solely for that purpose. Its removal
  greatly simplifies both the build system and testsuite machinery.
  (David Allsopp, review by Sébastien Hinderer)

- #12347: error messages: always report missing polyvariant tags
  (Florian Angeletti, report by Tianbo Hao, review by Gabriel Scherer)

- #12224, specialized error message when trying to apply non-functor
  module (e.g `module M = Int(Int)`)
  (Florian Angeletti, review by Gabriel Scherer)

- #12451: Warning 53 (misplaced attributes) now works for all attributes.
  (Chris Casinghino, review by Florian Angeletti)

- #12622: Give hints about existential types appearing in error messages
  (Leo White, review by Gabriel Scherer and Florian Angeletti)

- #12671: When a class type parameter or class parameter does not match,
  identify which parameter in the error message, instead of saying
  "A type parameter" or "A parameter".
  (Stefan Muenzel, review by Gabriel Scherer)

- #12679: Add more detail to the error message and manual in case of
  invalid module type substitutions.
  (Stefan Muenzel, review by Gabriel Scherer and Florian Angeletti)

- #12750: Display the command executed to extract primitives in
  `ocamlc -verbose`.
  (David Allsopp, review by Nicolás Ojeda Bär)

- #12777: Add details about the actual and expected method types to the method
  mismatch error messages.
  (Javier Chávarri, review by Gabriel Scherer and Florian Angeletti)

* #12942: Fix an line ordering in some module inclusion error messages
  (Nick Roberts, review by Florian Angeletti, report by Carl Eastlund)

### Internal/compiler-libs changes:

- #12639: parsing: Attach a location to the RHS of Ptyp_alias
  and improve the 'alias type mismatch' error message.
  (Jules Aguillon, review by Florian Angeletti)

- #12447: Remove 32-bit targets from X86_proc.system
  (Masanori Ogino, review by David Allsopp)

- #12216, #12248: Prevent reordering of atomic loads during instruction
  scheduling.  This is for reference, as instruction scheduling is currently
  unused in OCaml 5.
  (Xavier Leroy, report by Luc Maranget and KC Sivaramakrishnan,
   review by Nicolás Ojeda Bär)

- #12025: Split Typecore.unify_pat_types into two
  to avoid unnecessary references to the environment in type_pat
  (Jacques Garrigue and Takafumi Saikawa, review by Gabriel Scherer)

- #12031: Use dedicated types to represent names of compilation units
  and predefined exceptions in CMO files.
  (Sébastien Hinderer, review by Florian Angeletti, Thomas Refis,
  Gabriel Scherer, Vincent Laviron, Pierre Chambart, Luke Maurer,
  Hugo Heuzard, Xavier Leroy and Damien Doligez)

- #12109: Pack parameters to unification in unification_environment
  (Takafumi Saikawa and Jacques Garrigue, review by Richard Eisenberg)

- #12331, #12361: Pack the unification data for pattern checking in Typecore
  (Takafumi Saikawa and Jacques Garrigue,
   review by Gabriel Scherer, Thomas Refis and Florian Angeletti)

- #12229: Remove global mutable state for typechecking patterns
  in Typecore in favor of local mutable state.
  (Nick Roberts, review by Takafumi Saikawa)

- #12236, #12386, #12391, #12496, #12673: Use syntax as sole determiner of arity
  This changes function arity to be based solely on the source program's
  parsetree. Previously, the heuristic for arity had more subtle heuristics
  that involved type information about patterns.  Function arity is important
  because it determines when a pattern match's effects run and is an input
  into the fast path for function application.

  This change affects tooling: it changes the function constructs in parsetree
  and typedtree.

  See https://github.com/ocaml/RFCs/pull/32 for the original RFC.

  (Nick Roberts; review by Richard Eisenberg, Leo White, and Gabriel Scherer;
  RFC by Stephen Dolan)

- #12542: Minor bugfix to #12236: restore dropped call to `instance`
  (Nick Roberts, review by Jacques Garrigue)

- #12242: Move the computation of stack frame parameters to a separate
  `Stackframe` module, and save the parameters in the results of the
  `Linearize` pass
  (Xavier Leroy, review by KC Sivaramakrishnan and Mark Shinwell)

- #12442: document jump summaries in the pattern-matching compiler
  (Gabriel Scherer and Thomas Refis, review by Florian Angeletti
   and Vincent Laviron)

- #12446, #12792: remove the hooks machinery around channel locking
  in runtime/io.c
  (Gabriel Scherer, review by Xavier Leroy)

- #12389, #12544, #12984, #12987: centralize the handling of metadata for
  compilation units and artifacts in preparation for better unicode support for
  OCaml source files.
  (Florian Angeletti, review by Vincent Laviron and Gabriel Scherer)

- #12532, #12553: improve readability of the pattern-matching debug output
  (Gabriel Scherer, review by Thomas Refis)

- #12537: Use C11/C++11 standard static assertion.
  (Antonin Décimo, review by Sebastien Hinderer, Xavier Leroy,
   and KC Sivaramakrishnan)

- #12169: runtime: document and enforce naming conventions around STW sections.
  (Gabriel Scherer, review by Enguerrand Decorne, Miod Vallat, B. Szilvasy
   and Nick Barnes, report by KC Sivaramakrishnan)

- #12669 : Clean up some global state handling in schedgen
  (Stefan Muenzel, review by Miod Vallat and Gabriel Scherer)

- #12640: Make the module separator used in symbol names configurable
  (Miod Vallat, review by Hugo Heuzard and Xavier Leroy)

- #12691 : Clean up Ctype.expand_abbrev_gen and
  rename Env.add_local_type to add_local_constraint
  (Takafumi Saikawa and Jacques Garrigue, review by Florian Angeletti)

- #12786 : Clean up the algorithm of Ctype.limited_generalize
  (Takafumi Saikawa and Jacques Garrigue, review by Gabriel Scherer)

- #10691: Ast_mapper, Ast_iterator: add functions directive_argument,
  toplevel_directive and toplevel_phrase.
  (Guillaume Petiot, review by Gabriel Scherer and Kate Deplaix)

- #12764: Move all installable headers in `caml/` sub-directories.
  (Antonin Décimo, review by Gabriel Scherer and David Allsopp)

- #12508 : Add compiler-side support for project-wide occurrences in Merlin, by
  generating index tables of all identifier occurrences. This extra data in .cmt
  files is only added when the new flag -bin-annot-occurrences is passed.
  (Ulysse Gérard, Nathanaëlle Courant, suggestions by Gabriel Scherer and Thomas
  Refis, review by Florian Angeletti, Gabriel Scherer and Thomas Refis)

- #12914: Slightly change the s390x assembly dialect in order to build with
  Clang's integrated assembler.
  (Miod Vallat, review by Gabriel Scherer)

- #13001: do not read_back entire shapes to get aliases' uids when building the
  usages index
  (Ulysse Gérard, review by Gabriel Scherer and Nathanaëlle Courant)

### Build system:

- #12198, #12321, #12586, #12616, #12706, #13048: continue the merge of the
  sub-makefiles into the root Makefile started with #11243, #11248,
  #11268, #11420 and #11675.
  (Sébastien Hinderer, review by David Allsopp and Florian Angeletti)

- #12569, #12570: remove 'otherlibraries' as a prerequisite for 'runtop';
  use 'runtop-with-otherlibs' to use a library from otherlibs/
  (Gabriel Scherer, review by Sébastien Hinderer, suggestion by David Allsopp)

- #12652: Make magic numbers easier to bump and duplicate.
  (Sébastien Hinderer, review by Antonin Décimo, David Allsopp and Florian
  Angeletti)

* #12751: --with-target-bindir configure option implemented. This option
  refers to the location of the runtime binaries on the target system for a
  cross-compiler and is embedded in executables produced by ocamlc. It does
  not affect the bytecode executables installed as part of the build. The old
  mechanism `make TARGET_BINDIR=..` no longer works.
  (David Allsopp, review by Damien Doligez, Xavier Leroy and Olivier Nicole)

- #12768, #13030: Detect mingw-w64 coupling with GCC or LLVM, detect clang-cl,
  and fix C compiler feature detection on macOS.
  (Antonin Décimo, review by Miod Vallat and Sébastien Hinderer)

### Bug fixes:

- #10652, #12720: fix evaluation order in presence of optional arguments
  (Jacques Garrigue, report by Leo White, review by Vincent Laviron)

- #12595, #12597: fix a race in `caml_clear_gc_stats_sample`
  (Gabriel Scherer, review by B. Szilvasy, report by B. Szilvasy)

- #12580: Fix location of alias pattern variables.
  (Chris Casinghino, review Gabriel Scherer, report by Milo Davis)

- #12583: Add a closing event for when `EV_MAJOR_EPHE_MARK` is complete
  (Sudha Parimala, review by Gabriel Scherer)

- #12566: caml_output_value_to_malloc wrongly uses `caml_stat_alloc`
  instead of `malloc` since 4.06, breaking (in pooled mode) user code
  that uses `free` on the result. Symmetrically,
  caml_input_value_from_malloc should use `free`.
  (Gabriel Scherer, review by Xavier Leroy and Enguerrand Decorne,
   report by Ido Yariv)

- #12490: Unix: protect the popen_processes hashtable with a mutex
  (Gabriel Scherer, report by Olivier Nicole, review by Xavier Leroy)

- #11931: Fix tricky typing bug with type substitutions
  (Stephen Dolan, review by Leo White and Jacques Garrigue)

- #12037, #12171: Fix get_extern_state potential NULL dereference.
  (Alexander Skvortsov, report by Török Edwin,
   design by Gabriel Scherer, Xavier Leroy)

- #12635: Fix get_intern_state potential NULL dereference.
  (Antonin Décimo, review by KC Sivaramakrishnan)

- #12032, #12059: Bug fixes related to compilation of recursive definitions
  (Vincent Laviron, report by Victoire Noizet, review by Gabriel Scherer)

* #12145: Loopy constraints cause ocamlc to loop.
  Fixed by completely removing the call to `update_type` in
  `Typedecl.transl_type_decl`, as the expansion is already checked by
  `check_regularity`. As a result, recursion is more polymorphic,
  which may cause some (essentially wrong) type declarations to have
  unbound type variables, and some constraints unrelated to the concrete
  type to be ignored (see tests/typing-misc/constraints.ml).
  (Jacques Garrigue, report by Richard Eisenberg, review by Leo White)

- #12207, #12222: Make closure computation linear in the number of recursive
  functions instead of quadratic
  (Vincent Laviron, report by François Pottier, review by Nathanaëlle Courant
  and Gabriel Scherer)

- #11040, #12591: fix a data race in major_gc.c
  (Gabriel Scherer, review by Guillaume Munch-Maccagnoni
   and KC Sivaramakrishnan, report by Sadiq Jaffer)

- #12238, #12403, #12698: read input files in one go to avoid source reprinting
  issues.
  (Gabriel Scherer, report by Mike Spivey and Vincent Laviron, review by
   Nicolás Ojeda Bär, Xavier Leroy and Jeremy Yallop)

- #12334, #12368: Bad error message with mutually recursive abbreviations
  (Jacques Garrigue, report by Richard Eisenberg, review by Gabriel Scherer
   and Richard Eisenberg)

- #12401: `seek_in` and `seek_out` sometimes returned normally when given
  negative offsets, instead of failing. Now both functions should consistently
  raise `Sys_error` in this case.
  (Nicolás Ojeda Bär, review by Gabriel Scherer)

- #12267: Fix stack alignment computation
  (Miod Vallat, report by Jan Midtgaard, review by Gabriel Scherer)

- #12395, #12404: Fix thread-unsafety in the fallback implementation of
  `Unix.create_process` (the one used when `posix_spawnp` is unavailable)
  (Xavier Leroy, report by Chris Vine, review by Nicolás Ojeda Bär)

- #12949: open shadowing mistriggers
  (Gabriel Scherer, review by Florian Angeletti, report by Andreas Rossberg)

- #12526: Honor `ocaml.inline always` attribute on functions with
  optional arguments and default values in the Closure backend
  (Alain Frisch, review by Vincent Laviron)

- #12677, #12889: make Domain.DLS thread-safe
  (Gabriel Scherer, review by Olivier Nicole and Damien Doligez,
   report by Vesa Karvonen)

- #12561: Fix crash when combining TSan and frame-pointers
  (Fabrice Buoro and Olivier Nicole, report by Jan Midtgaard, review by Miod
  Vallat and Gabriel Scherer)

- #12482: Rework bounds checking code in the POWER backend
  (Miod Vallat and Xavier Leroy, report by Jan Midtgaard, review by
   KC Sivaramakrishnan)

- #12528, #12703: Avoid pointer arithmetic overflow in Tag_val macro
  (very likely harmless, but can trigger alarms)
  (Xavier Leroy, report by Sam Goldman, review by Guillaume Munch-Maccagnoni)

- #12593: TSan should handle Effect.Unhandled correctly
  (Fabrice Buoro and Olivier Nicole, report by Jan Midtgaard and Miod Vallat,
   review by Gabriel Scherer)

- #12684: fix locations filename in AST produced by the `-pp` option
  (Gabriel Scherer, review by Florian Angeletti)

- #12714: check whether macros are defined before using them to ensure
  that the headers can always be used in code which turns on -Wundef
  (or equivalent).
  (Antonin Décimo, review by Miod Vallat, Gabriel Scherer,
   Xavier Leroy, and David Allsopp)

- #12726: fix segmentation fault under Windows when executing a bytecode file if
  the runtime (`ocamlrun.exe`) cannot be found.
  (Vadim Zborovskii, Nicolás Ojeda Bär, report by Vadim Zborovskii, review by
  David Allsopp)

- #12727, #12730: fix bug with value let-rec and labelled applications
  (Vincent Laviron, review by Gabriel Scherer)

* #12751: Always keep within the 128 character limit for shebang lines. Previous
  fix in #8622 handled building the compiler with a long prefix; this patch
  extends this to the bytecode executables emitted by that compiler.
  (David Allsopp, review by Damien Doligez, Xavier Leroy and Olivier Nicole)

- #12755: Fix data race on global pools arrays of pool_freelist
  (Fabrice Buoro and Olivier Nicole, review by Gabriel Scherer)

- #12796, #12801: Fix memory corruption in caml_unix_alloc_sockaddr
  (Thomas Leonard, review by Nicolás Ojeda Bär)

- #12737: Fix data races in minor_gc.c and caml_natdynlink_open
  (Olivier Nicole, review by Stefan Muenzel, Miod Vallat, Guillaume
   Munch-Maccagnoni, Gabriel Scherer and Xavier Leroy)

- #12831: Fix call to caml_call_realloc_stack for s390x in PIC mode
  (Vincent Laviron, report by Jerry James, review by Miod Vallat)

* #12837: Show non-generalizable type parameters in type definitions
  Changes type of type parameters in outcometree.mli.
  (Jacques Garrigue, review by Richard Eisenberg)

- #12897: fix locking bugs in Runtime_events
  (Gabriel Scherer and Thomas Leonard,
   review by Olivier Nicole, Vincent Laviron and Damien Doligez,
   report by Thomas Leonard)

- #12851: Fix race between runtime events teardown and event emission
  (Olivier Nicole, review by Miod Vallat and Gabriel Scherer)

- #12860: Fix an assertion that wasn't taking into account the possibility of an
  ephemeron pointing at static data.
  (Mark Shinwell, review by Gabriel Scherer and KC Sivaramakrishnan)

- #12861: Fix a possible crash in the `threads` library.
  (Mark Shinwell, review by Gabriel Scherer and KC Sivaramakrishnan)

- #11040, #12894: Silence false data race observed between caml_shared_try_alloc
  and oldify. Introduces macros to call tsan annotations which help annotate
  a ``happens before'' relationship.
  (Hari Hara Naveen S and Olivier Nicole,
   review by Gabriel Scherer and Miod Vallat)

- #12958: Fix tail-modulo-cons compilation of try-with, && and ||
  expressions.
  (Gabriel Scherer and Nicolás Ojeda Bär, report by Sylvain Boilard, review by
  Gabriel Scherer)

- #12919: Fix register corruption in caml_callback2_asm on s390x.
  (Miod Vallat, review by Gabriel Scherer)

- #12924, #12930: Rework package constraint checking to improve interaction with
  immediacy
  (Chris Casinghino and Florian Angeletti, review by Florian Angeletti and
   Richard Eisenberg)

- #12969: Fix a data race in caml_darken_cont
  (Fabrice Buoro and Olivier Nicole, review by Gabriel Scherer and Miod Vallat)

- #12971, #12974: fix an uncaught Ctype.Escape exception on some
  invalid programs forming recursive types.
  (Gabriel Scherer, review by Florian Angeletti, report by Neven Villani)

- #13019: Remove linking instructions for the Unix library from threads.cma
  (this was done for threads.cmxa in OCaml 3.11). Eliminates warnings from
  new lld when using threads.cma of duplicated libraries.
  (David Allsopp, review by Nicolás Ojeda Bär)

- #13058: Add TSan instrumentation to caml_call_gc(), since it may raise
  exceptions.
  (Fabrice Buoro, Olivier Nicole, Gabriel Scherer and Miod Vallat)

- #13079: Save and restore frame pointer across Iextcall on ARM64
  (Tim McGilchrist, review by KC Sivaramakrishnan and Miod Vallat)

- #13094: Fix undefined behavior of left-shifting a negative number.
  (Antonin Décimo, review by Miod Vallat and Nicolás Ojeda Bär)

OCaml 5.1.1 (8 December 2023)
----------------------------

### Standard library:

* #12562, #12734, #12783: Remove the `Marshal.Compression` flag to the
  `Marshal.to_*` functions introduced in 5.1 by #12006, as it cannot
  be implemented without risking to link -lzstd with all
  ocamlopt-generated executables.  The compilers are still able to use
  ZSTD compression for compilation artefacts.
  (Xavier Leroy and David Allsopp, report by Kate Deplaix, review by
   Nicolás Ojeda Bär, Kate Deplaix, and Damien Doligez).

### Bug fixes:

- #11800, #12707: fix an assertion race condition in `install_backup_thread`
  (Jan Midtgaard, review by Gabriel Scherer)

- #12318: GC: simplify the meaning of custom_minor_max_size: blocks with
  out-of-heap memory above this limit are now allocated directly in
  the major heap.
  (Damien Doligez, report by Stephen Dolan, review by Gabriel Scherer)

- #12439: Finalize and collect dead custom blocks during minor collection
  (Damien Doligez, review by Xavier Leroy, Gabriel Scherer and KC
  Sivaramakrishnan)

- #12486, #12535: Fix delivery of unhandled effect exceptions on amd64 with
  --enable-frame-pointers
  (Miod Vallat, report by Jan Midtgaard, review by Gabriel Scherer)

- #12581, #12609: Fix error on uses of packed modules outside their pack
  to correctly handle nested packs
  (Vincent Laviron, report by Javier Chávarri, review by Pierre Chambart)

- #12590, #12595: Move `caml_collect_gc_stats_sample` in
  `caml_empty_minor_heap_promote` before barrier arrival.
  (B. Szilvasy, review by Gabriel Scherer)

- #12623, fix the computation of variance composition
  (Florian Angeletti, report by Vesa Karvonen, review by Gabriel Scherer)

- #12645, #12649 fix error messages for cyclic type definitions in presence of
  the `-short-paths` flag.
  (Florian Angeletti, report by Vesa Karvonen, review by Gabriel Scherer)

- #12712, #12742: fix an assertion boundary case in `caml_reset_young_limit`
  (Jan Midtgaard, review by Guillaume Munch-Maccagnoni and KC Sivaramakrishnan)

- #12713, #12715: disable common subexpression elimination for atomic loads
  (Gabriel Scherer and Vincent Laviron,
   review by Vincent Laviron, KC Sivaramakrishnan and Xavier Leroy,
   report by Vesa Karvonen and Carine Morel)

- #12757: Fix ocamlnat (native toplevel) by registering frametables correctly
  (Stephen Dolan, Nick Barnes and Mark Shinwell,
   review by Vincent Laviron and Sébastien Hinderer)

- #12791: `extern` is applied to definitions of `caml_builtin_cprim`
  and `caml_names_of_builtin_cprim` when linking bytecode '-custom'
  executables with a C++ linker.
  (Shayne Fletcher, review by Antonin Décimo and Xavier Leroy)

- #12491, #12493, #12500, #12754: Do not change GC pace when creating
  sub-arrays of bigarrays
  (Xavier Leroy, report by Ido Yariv, analysis by Gabriel Scherer,
   review by Gabriel Scherer and Fabrice Buoro)

OCaml 5.1.0 (14 September 2023)
-------------------------------

### Restored backends

- #11418, #11708: RISC-V multicore support.
  (Nicolás Ojeda Bär, review by KC Sivaramakrishnan)

- #11712, #12258, #12261: s390x / IBM Z multicore support:
  OCaml & C stack separation; dynamic stack size checks; fiber and
  effects support.
  (Aleksei Nikiforov, with help from Vincent Laviron and Xavier Leroy,
   additional suggestions by Luc Maranget,
   review by the same and KC Sivaramakrishnan)

- #11642: Restore Cygwin port. Add GC messages for address space reservations
  when OCAMLRUNPARAM option v includes 0x1000.
  (David Allsopp, review by Xavier Leroy, Guillaume Munch-Maccagnoni
  and Gabriel Scherer)

### Standard library:

- #12006, #12064: Add `Marshal.Compression` flag to `Marshal.to_*` functions.
  When this flag is explicitly set, marshaled data is compressed using ZSTD.
  On some practical examples, the marshalled output became three times smaller
  at no noticeable cost on the marshalling time.
  (Xavier Leroy, review by Edwin Török and Gabriel Scherer, fix by Damien
   Doligez)

- #10464: Add List.is_empty.
  (Craig Ferguson, review by David Allsopp)

- #11848: Add `List.find_mapi`,
  `List.find_index: ('a -> bool) -> 'a list -> int option`,
  `Seq.find_mapi`, `Seq.find_index`, `Array.find_mapi`, `Array.find_index`,
  `Float.Array.find_opt`, `Float.Array.find_index`, `Float.Array.find_map`,
  `Float.Array.find_mapi`.
  (Tima Kinsart, review by Daniel Bünzli and Nicolás Ojeda Bär)

- #11410: Add Set.to_list, Map.to_list, Map.of_list,
  `Map.add_to_list: key -> 'a -> 'a list t -> 'a list t`.
  (Daniel Bünzli, review by Nicolás Ojeda Bär and Gabriel Scherer)

- #11836, #11837: Add `Array.map_inplace`, `Array.mapi_inplace`,
  `Float.Array.mapi_inplace` and `Float.Array.mapi_inplace`.
  (Léo Andrès, review by Gabriel Scherer, KC Sivaramakrishnan and
  Nicolás Ojeda Bär)

- #10967: Add Filename.temp_dir.
  (David Turner, review by Anil Madhavapeddy, Valentin Gatien-Baron, Nicolás
  Ojeda Bär, Gabriel Scherer, and Daniel Bünzli)

- #11246: Add "hash" and "seeded_hash" functions to Bool, Int, Char, Float,
  Int32, Int64, and Nativeint.
  (Nicolás Ojeda Bär, review by Xavier Leroy and Gabriel Scherer)

- #11488: Add `Mutex.protect: Mutex.t -> (unit -> 'a) -> 'a`
  for resource-safe critical sections protected by a mutex.
  (Simon Cruanes, review by Gabriel Scherer, Xavier Leroy,
   Guillaume Munch-Maccagnoni)

- #11581: Add type equality witness
    `type (_, _) eq = Equal: ('a, 'a) eq`
  in a new module Stdlib.Type.
  (Nicolás Ojeda Bär, review by Daniel Bünzli, Jacques Garrigue, Florian
  Angeletti, Alain Frisch, Gabriel Scherer, Jeremy Yallop and Xavier Leroy)

- #11843: Add `In_channel.input_lines` and `In_channel.fold_lines`.
  (Xavier Leroy, review by Nicolás Ojeda Bär and Wiktor Kuchta).

- #11856, #11859: Using TRMC, the following `Stdlib` functions are now
  tail-recursive:
    Stdlib.(@), List.append,
    List.concat_map.
  (Jeremy Yallop, review by Daniel Bünzli, Anil Madhavapeddy, Nicolás Ojeda Bär,
   Gabriel Scherer, and Bannerets)

- #11362, #11402: Using TRMC, the following `Stdlib` functions are now
  tail-recursive:
    List.map, List.mapi, List.map2,
    List.filter, List.filteri, List.filter_map,
    List.init,
    List.of_seq.
  (Nicolás Ojeda Bär, review by Xavier Leroy and Gabriel Scherer)


- #11878, #11965: Prevent seek_in from marking buffer data as valid after
  closing the channel. This could lead to inputting uninitialized bytes.
  (Samuel Hym, review by Xavier Leroy and Olivier Nicole)

- #11128: Add In_channel.isatty, Out_channel.isatty.
  (Nicolás Ojeda Bär, review by Gabriel Scherer and Florian Angeletti)

- #10859: Add `Format.pp_print_iter` and `Format.pp_print_array`.
  (Léo Andrès and Daniel Bünzli, review by David Allsopp and Hugo Heuzard)

- #10789: Add `Stack.drop`
  (Léo Andrès, review by Gabriel Scherer)

* #10899: Change Stdlib.nan from signaling NaN to quiet NaN.
  (Greta Yorsh, review by Xavier Leroy, Guillaume Melquiond and
  Gabriel Scherer)

- #11026, #11667, #11858: Rename the type of the accumulator
  of fold functions to 'acc:
  fold_left : ('acc -> 'a -> 'acc) -> 'acc -> 'a list -> 'acc
  fold_right : ('a -> 'acc -> 'acc) -> 'a list -> 'acc -> 'acc
  fold_left_map : ('acc -> 'a -> 'acc * 'b) -> 'acc -> 'a list -> 'acc * 'b list
  ...
  (Valentin Gatien-Baron and François Berenger,
  review by Gabriel Scherer and Nicolás Ojeda Bär)

- #11354: Hashtbl.find_all is now tail-recursive.
  (Fermín Reig, review by Gabriel Scherer)

- #11500: Make Hashtbl.mem non-allocating.
  (Simmo Saan, review by Nicolás Ojeda Bär)

- #11412: Add Sys.is_regular_file
  (Xavier Leroy, review by Anil Madhavapeddy, Nicolás Ojeda Bär, David Allsopp)

- #11322, #11329: serialization functions Random.State.{of,to}_binary_string
  between Random.State.t and string
  (Gabriel Scherer, report by Yotam Barnoy,
   review by Daniel Bünzli, Damien Doligez, Hugo Heuzard and Xavier Leroy)

- #11830: Add Type.Id with
  `val provably_equal : 'a Type.Id.t -> 'b Type.Id.t -> ('a, 'b) Type.eq option`
  (Daniel Bünzli, review by Jeremy Yallop, Gabriel Scherer, Wiktor Kuchta,
   Nicolás Ojeda Bär)

- #12184, #12320: Sys.rename Windows fixes on directory corner cases.
  (Jan Midtgaard, review by Anil Madhavapeddy)

* #11565: Enable -strict-formats by default. Some incorrect format
  specifications (for `printf`) where silently ignored and now fail.
  Those new failures occur at compile-time, except if you use advanced
  format features like `%(...%)` that parse format strings dynamically.
  Pass -no-strict-formats to revert to the previous lenient behavior.
  (Nicolás Ojeda Bär, review by David Allsopp)

### Installation size

  Specific efforts have been made during this release to reduce the filesystem
size of installed artifacts of the compiler distribution.
The installation size of 5.1 is 272 MiB compared to 521 MiB for 5.0.
Some of those changes will benefit all OCaml packages.

- ocaml/RFCs#23, #12006: use compressed marshaled format from #12006 for .cmi,
  .cmt, .cmti files, and for debug info in .cmo and .cma files, resulting in
  major reduction in size.
  (Xavier Leroy, review by Edwin Török and Gabriel Scherer,
   RFC by Simon Cruanes)

- #11981: Reduce size of OCaml installations by removing debugging information
  from installed bytecode executables.  It is no longer possible to
  run ocamldebug over these installed bytecode executables, nor to get
  exception backtraces for them.
  (Xavier Leroy, review by David Allsopp, report by Fabrice Le Fessant)

* #11993: install only bytecode executables for the `ocamlmklib`, `ocamlcmt`,
  `ocamlprof`, `ocamlcp`, `ocamloptp`, and `ocamlmktop` tools, but no
  native-code executables.  A tool like `ocamlmklib` for example is now
  installed directly to `$BINDIR/ocamlmklib`; `ocamlmklib.byte` and
  `ocamlmklib.opt` are no longer installed to `$BINDIR`.
  (Xavier Leroy, review by Gabriel Scherer)

### Runtime system:

- #11589, #11903: Modify the GC pacing code to make sure the GC keeps
   up with allocations in the presence of idle domains.
   (Damien Doligez and Stephen Dolan, report by Florian Angeletti,
   review by KC Sivaramakrishnan and Sadiq Jaffer)

- #11743: Speed up weak array operations
  (KC Sivaramakrishnan, review by François Bobot and Sadiq Jaffer)

- #12131: Simplify implementation of weak hash sets, fixing a
  performance regression. (Nick Barnes, review by François Bobot,
  Alain Frisch and Damien Doligez).

- #11474, #11998, #12065: Add support for user-defined events in the runtime
  event tracing system.
  (Lucas Pluvinage, review by Sadiq Jaffer, Guillaume Munch-Maccagnoni,
   Enguerrand Decorne, Gabriel Scherer and Anil Madhavapeddy)

- #11827, #12249: Restore prefetching for GC marking
  (Fabrice Buoro and Stephen Dolan, review by Gabriel Scherer and Sadiq Jaffer)

- #11144: Restore frame-pointers support for amd64
  (Fabrice Buoro, review by Frédéric Bour and KC Sivaramakrishnan)

- #11935: Load frametables of dynlink'd modules in batch
  (Stephen Dolan, review by David Allsopp and Guillaume Munch-Maccagnoni)

- #11284, #12525: Use compression of entries scheme when pruning mark stack.
  Can decrease memory usage for some workloads, otherwise should be
  unobservable.
  (Tom Kelly, review by Sabine Schmaltz, Sadiq Jaffer and Damien Doligez)

* #11865, #11868, #11876: Clarify that the operations of a custom
  block must never access the OCaml runtime. The previous
  documentation only mentioned the main illicit usages. In particular,
  since OCaml 5.0, it is no longer safe to call
  `caml_remove_global_root` or `caml_remove_generational_global_root`
  from within the C finalizer of a custom block, or within the
  finalization function passed to `caml_alloc_final`. As a workaround,
  such a finalization operation can be registered with `Gc.finalize`
  instead, which guarantees to run the finalizer at a safe point.
  (Report by Timothy Bourke, discussion by Yotam Barnoy, Timothy
  Bourke, Sadiq Jaffer, Xavier Leroy, Guillaume Munch-Maccagnoni, and
  Gabriel Scherer)

- #12130: Fix multicore crashes with weak hash sets. Fixes #11934.
  (Nick Barnes, review by François Bobot)

- #12099: Add ocamlrund option, -events, to produce a trace of
  debug events during bytecode interpretation. Fixes #12098.
  (Richard L Ford, review by Gabriel Scherer)

- #12001: Fix book keeping for last finalisers during the minor cycle
  (KC Sivaramakrishnan and Enguerrand Decorne, report by Guillaume Bury
   and Vincent Laviron, review by Sadiq Jaffer and KC Sivaramakrishnan)

- #11919: New runtime events counters for major heap stats and minor heap
  resizing.
  (Sadiq Jaffer, review by Gabriel Scherer and David Allsopp)

- #11287, #11872, #11955: Clean up reserved header bits (once used for
  Spacetime profiling).
  (Nick Barnes, review by Gabriel Scherer and Damien Doligez)

- #11750: Decouple major slice from minor GC.
  (KC Sivaramakrishnan, review by Sadiq Jaffer, Guillaume Munch-Maccagnoni and
  Damien Doligez)

- #11796: protect lazy computation of code fragment digest by a mutex.
  This makes the thread sanitizer happier, and avoids duplicating
  the hashing work.
  (Gabriel Scherer, review by Xavier Leroy, report by Olivier Nicole)

- #11137: new `Unsafe_store_tag(val, new_tag)` macro to stop using
  `Tag_val(val)` as lvalue.
  (Gabriel Scherer, review by Xavier Leroy, Guillaume Munch-Maccagnoni
   and Nicolás Ojeda Bär)

- #11880: Restore the correct sigmask in systhreads.
  (Christiano Haesbaert, review by Guillaume Munch-Maccagnoni and
   Sébastien Hinderer)

- #11881: Fix thread-unsafety of registration of operations for "custom"
   values.
  (Guillaume Munch-Maccagnoni, review by Gabriel Scherer and KC
   Sivaramakrishnan)

- #11980: fix quadratic behavior in natdynlink by using a STW section
  for frame-descriptor updates.
  (Gabriel Scherer, review by Sadiq Jaffer, report by André Maroneze
  for Frama-C and Guillaume Melquiond for Coq)

- #12121: unrooted implementations of caml_callback*_exn
  (Gabriel Scherer, review by KC Sivaramakrishnan and Xavier Leroy)

- #3921, #12039, #12128: poll for signals in long-running polymorphic
  comparisons.
  (B. Szilvasy, Gabriel Scherer and Xavier Leroy, review by
   Stefan Muenzel, Guillaume Munch-Maccagnoni and Damien Doligez)

- #12231: Support MinGW-w64 11.0 winpthreads library, where the macro
  to set up to get flexdll working changed
  (David Allsopp and Samuel Hym, light review by Xavier Leroy)

* #12512: Add volatile casts to FFI macros to enforce memory model (technically
  a breaking change although no opam package seemed broken by it.)
  (Olivier Nicole, suggested by Guillaume Munch-Maccagnoni, review by Gabriel
   Scherer and Xavier Leroy)

### Language features:

* #11694: Add short syntax for generative functor types `() -> ...`
  (Jeremy Yallop, review by Gabriel Scherer, Nicolás Ojeda Bär,
  Jacques Garrigue)


* #11457: Remove old polymorphic variant syntax.
  With ``type t = [ `A | `B ]``, one could use the syntax `#t` in types,
  where it means the same thing as `[< t]`, and in patterns, where it means
  ``(`A | `B)``. The use of `#t` in types for polymorphic variants
  was deprecated since 2001, and is now removed. The syntax remains available
  in patterns, or for objects -- when `t` is a class type.
  (Stefan Muenzel, review by Gabriel Scherer and Jacques Garrigue)

* #11984: Add dedicated syntax for generative functor application.
  Previously, OCaml did not distinguish between `F ()` and
  `F (struct end)`, even though the latter looks applicative. Instead,
  the decision between generative and applicative functor application
  was made based on the type of `F`. With this patch, we now distinguish
  these two application forms; writing `F (struct end)` for a generative
  functor leads to new warning 73.
  (Frédéric Bour and Richard Eisenberg, review by Florian Angeletti)


- #9975, #11365: Make empty types (`type t = |`) immediate.
  (Antal Spector-Zabusky, review by Gabriel Scherer)

### Type system:

* #6941, #11187, #12483: prohibit using classes through recursive modules
  inheriting or including a class belonging to a mutually-recursive module
  would previous behave incorrectly, and now results in a clean error.
  (Leo White, review by Gabriel Scherer and Florian Angeletti)

* #12189, #12211: anonymous row variables in explicitly polymorphic type
  annotation, e.g. `'a. [< X of 'a ] -> 'a`, are now implicitly
  universally quantified (in other words, the example above is now read
  as `'a 'r. ([< X of 'a ] as 'r) -> 'a`).
  (Florian Angeletti and Gabriel Scherer, review by Jacques Garrigue)

### Code generation and optimizations:

- #11967: Remove traces of Obj.truncate, which allows some mutable
  loads to become immutable.
  (Nick Barnes, review by Vincent Laviron and KC Sivaramakrishnan)

- #9945, #10883: Turn boolean-result float comparisons into primitive operations
  Uses the architecture's elementary operations for float comparisons,
  when available, rather than branching and then setting the return value.
  (Stefan Muenzel, review by Stephen Dolan, Alain Frisch and Vincent Laviron)

- #8998, #11321, #11430: change mangling of OCaml long identifiers
  from `camlModule__name_NNN` to `camlModule.name_NNN`.  The previous
  mangling schema, using `__`, was ambiguous.
  (Xavier Leroy, report by sliquister and Michael Bacarella,
   review by Gabriel Scherer)

- #10834: The -safer-matching option disables type-based optimizations of
  pattern-matching compilation. This allows to produce a match failure if
  a pattern-matching was wrongly assumed to be exhaustive. Since the
  exhaustiveness check for GADTs has had bugs in the past, it may be
  useful if you need extra security with GADTs.
  (Jacques Garrigue, review by Gabriel Scherer)

- #11102: Speed up register allocation by permanently spilling registers
  (Stephen Dolan, review by Xavier Leroy)

- #11383: Restrict the local function optimisation to forbid moving code
  inside a sub-function
  (Vincent Laviron, review by Gabriel Scherer)

- #11686: Better spilling heuristic for the Linear Scan allocator for more
  efficient stack usage.
  (Nicolás Ojeda Bär, Gabriel Scherer, Alain Frisch, review by Gabriel Scherer,
  Alain Frisch and Nathanaëlle Courant)

- #11904: Remove arm, i386 native-code backends that were already
  disabled at configuration time.
  (Nicolás Ojeda Bär, review by Stephen Dolan, Anil Madhavapeddy, and Xavier
  Leroy)

- #11134: Optimise 'include struct' in more cases
  (Stephen Dolan, review by Leo White and Vincent Laviron)

### Other libraries:

- #11374: Remove pointer cast to a type with stricter alignment requirements
  in Windows implementation of Unix.gettimeofday. Windows implementations of
  caml_unix_map_file, caml_unix_lseek and caml_unix_lseek_64 now release the
  runtime lock. Windows implementation of caml_unix_lockf modernised and
  simplified. Where possible, 64 bit integers are used instead of LARGE_INTEGER
  structs.
  (David Allsopp, review by Jonah Beckford and Xavier Leroy)

- #11475: Make Unix terminal interface bindings domain-safe
  (Olivier Nicole and Xavier Leroy, review by Xavier Leroy)

- #11775: Unix.write on a non-blocking socket under Windows will return normally
  if the write blocks after some data has already been written (as otherwise
  there is no way of knowing how much data has been written before
  blocking). The same behaviour was already present under Unix.
  (Nicolás Ojeda Bär, review by David Allsopp)

* #11991: Unix on Windows: map ERROR_TOO_MANY_LINKS to EMLINK.
  (Nicolás Ojeda Bär)

- #12067: Document Windows specific meanings of `Unix.process_status`
  type
  (Samuel Hym, review by David Allsopp)

- #12072: Document and test that Sys.rename works over directories too
  (Jan Midtgaard, review by Anil Madhavapeddy and Xavier Leroy)

### Tools:

- #11889, #11978: ocamldoc: handle injectivity annotations and wildcards in type
  parameters.
  (Florian Angeletti, report by Wiktor Kuchta, review by Jules Aguillon)

- #11787: Fix GDB scripts to work with OCaml 5's heap layout. (Nick
  Barnes)

- #11772: fix ocamlyacc's handling of raw string literals
  (Demi Marie Obenour)

- #9290: Add a directive to switch off debugging in toplevel.
  This allows to see optimized bytecode with -dlambda.
  (Jacques Garrigue, review by Gabriel Scherer)

- #11166: ocamllex: the union of two character sets "cset1 | cset2" can now be
  used in any context where a character set is expected.
  (Nicolás Ojeda Bär, Martin Jambon, review by Sébastien Hinderer)

- #11718: ocamlyacc: OCaml-style comments are now supported, in addition to
  the C-style comments already supported.  The syntax is the same as that used
  in OCaml code.
  (Demi Marie Obenour, review by Damien Doligez)

- #11728: ocamlyacc: generate line directives for %type declarations
  (Demi Marie Obenour, review by Damien Doligez)

- #11773: ocamlyacc: Do not allow quoted literals (such as 'a' or "bc")
  in a token name or %type declaration.  Previously such literals were
  accepted by ocamlyacc, but produced malformed OCaml that was rejected
  by the compiler.
  (Demi Marie Obenour, review by Gabriel Scherer)

- #11774: ocamlyacc: fail if there is an I/O error
  (Demi Marie Obenour, review by Gabriel Scherer)

- #11973: Add support for postfixed mingw host triplets
  (Romain Beauxis)

- #12165: ocamldoc, use standard doctype to avoid quirk mode.
  (Florian Angeletti, review by Gabriel Scherer)

### Manual and documentation:

- #11476: Add examples in documentation of Hashtbl, Queue, Atomic, Format
  (Simon Cruanes, review by Yotam Barnoy, Gabriel Scherer, Daniel Bünzli,
   Ulugbek Abdullaev, and Nicolás Ojeda Bär)

- #11883, #11884: Update documentation for In_channel and Out_channel
  with examples and sections to group related functions.
  (Kiran Gopinathan, review by Daniel Bünzli and Xavier Leroy)


- #12095, #12097: Put the sample code of the user's manual and reference
  documentation of the standard library under the CC0 1.0 Universal
  (CC0 1.0) Public Domain Dedication license.

- #11892: Document the semantic differences of Unix.exec* between Unix and
  Windows.
  (Boris Yakobowski, review by Daniel Bünzli, Gabriel Scherer and Nicolás Ojeda
  Bär)

- #9430, #11291: Document the general desugaring rules for binding operators.
  (Gabriel Scherer, review by Nicolás Ojeda Bär)

- #11481: Fix the type of Unix.umask to Unix.file_perm -> Unix.file_perm
  (Favonia, review by Sébastien Hinderer)

- #11514: Document ocamltest builtin variables and actions
  (Olivier Nicole, review by Sébastien Hinderer)

- #11676: Fix missing since annotation in the `Sys` and `Format` modules
  (Github user Bukolab99, review by Florian Angeletti)

- #12028: Update format documentation to make it clearer that
  `pp_print_newline` flushes its newline
  (Florian Angeletti, review by Gabriel Scherer)

- #12201: in the tutorial on modules, replace priority queue example by
  a simpler example based on FIFO queues.
  (Xavier Leroy, review by Anil Madhavapeddy and Nicolás Ojeda Bär).

- #12352: Fix a typo in the documentation of Arg.write_arg
  (Christophe Raffalli, review by Florian Angeletti)

- #7179, #11894: correct the description of CAMLreturn and CAMLreturn0 in
  the Interfacing C page and memory.h file.
  (Dong An, review by Guillaume Munch-Maccagnoni and Olivier Nicole )

### Compiler user-interface and warnings:

- #10647: Show hints for the "undefined global" error in the toplevel
  (Wiktor Kuchta, review by Gabriel Scherer)

- #12116: Don't suggest to insert a semicolon when the type is not unit
  (Jules Aguillon, review by Florian Angeletti)

- #11679: Improve the error message about too many arguments to a function
  (Jules Aguillon, review by Gabriel Scherer and Florian Angeletti)

- #10009: Improve the error reported by mismatched struct/sig and =/: in module
  and module type bindings.
  (Jules Aguillon, review by Gabriel Scherer)

- #11530: Include kinds in kind mismatch error message.
  "Error: This variant or record definition does not match that of type M.t
          The original is abstract, but this is a record".
  (Leonhard Markert, review by Gabriel Scherer and Florian Angeletti)

- #11646: Add colors to error message hints.
  (Christiana Anthony, review by Florian Angeletti)

- #11235, #11864: usage warnings for constructors and fields can now be disabled
  on field-by-field or constructor-by-constructor basis
  (Florian Angeletti, review by Gabriel Scherer)

- #11888: Improve the error message when type variables cannot be deduced from
  the type parameters:
  Before:
    "Error: In this definition, a type variable cannot be deduced
            from the type parameters."
  After:
    "Error: In the GADT constructor
              T : 'a -> 'a s t
     the type variable 'a cannot be deduced from the type parameters."
  (Stefan Muenzel, review by Florian Angeletti and Gabriel Scherer)


- #10818: Preserve integer literal formatting in type hint.
  (Leonhard Markert, review by Gabriel Scherer and Florian Angeletti)

- #11338: Turn some partial application warnings into hints.
  (Leo White, review by Stephen Dolan)

- #10931: Improve warning 14 (illegal backslash) with a better explanation
  of the causes and how to fix it.
  (David Allsopp, Florian Angeletti, Lucas De Angelis, Gabriel Scherer,
  review by Nicolás Ojeda Bär, Florian Angeletti, David Allsopp and
  Gabriel Scherer)

- #10911: Improve the location reported by parenthesized assert expressions
  (Fabian Hemmer, review by Gabriel Scherer)

- #1391, #7645, #3922: Add an early error when compiling different
  modules with mismatching -for-pack
  (Pierre Chambart and Vincent Laviron, review by Mark Shinwell)

- #11297: Report "unclosed" error when "done" is missing in a "do .. done"
  construct.
  (Nicolás Ojeda Bär, review by Gabriel Scherer)

- #11635, #5461, #10564: turn warning 31 (Module_linked_twice) into a hard error
  for ocamlc — this was already an error with ocamlopt.
  (Hugo Heuzard, review by Valentin Gatien-Baron and Gabriel Scherer)

- #11653: Add the -no-absname option to ocamlc, ocamlopt and ocamldep.
  (Abiola Abdulsalam, review by Sébastien Hinderer and Florian Angeletti)

- #11696: Add the -no-g option to ocamlc and ocamlopt.
  (Abiola Abdulsalam, review by Sébastien Hinderer, Nicolás Ojeda Bär and
  Florian Angeletti)

- #11722: clearer error messages on non-well-founded type definitions
  (Gabriel Scherer, review by Jacques Garrigue)

- #11819: make the `native_compiler` and `native_dynlink` configuration
  variables available through ocamlc -config.
  (Sébastien Hinderer, review by Gabriel Scherer and David Allsopp)

- #8602, #11863: Add -stop-after lambda flag option
  (Douglas Smith and Dmitrii Kosarev, review by Gabriel Scherer)

- #11910: Simplify naming convention for shadowed or ephemeral identifiers in
  error messages (eg: `Illegal shadowing of included type t/2 by t`)
  (Florian Angeletti, review by Jules Aguillon)

- #12024: insert a blank line between separate compiler messages
  (Gabriel Scherer, review by Florian Angeletti, report by David Wong)

- #12088, #9265, #11949: ocamldebug: fix confusing repeating behavior
  on blank lines within source scripts
  (Damien Doligez, review by Gabriel Scherer, report by Gaëtan Gilbert)

- #12107: use aliases to mark weak row variables: `_[< ... ]`, `< _..>`, `_#ct`
  are now rendered as `[< ...] as '_weak1`, `< .. > as '_weak1`,
  and `#ct as '_weak1`.
  (Florian Angeletti, suggestion by Stefan Muenzel, review by Gabriel Scherer)

- #12051: Improve the error messages when type variables cannot be generalized
  (Stefan Muenzel, review by Florian Angeletti)

* #12094: Trigger warning 5 (ignored-partial-application) when the scrutinee of
  a pattern matching is of arrow type and all cases match wildcard or exception
  patterns.
  (Nicolás Ojeda Bär, review by Gabriel Scherer)

### Internal/compiler-libs changes:

- #11018, #11869: Clean up Types.Variance, adding a description of
  the lattice used, and defining explicitly composition.
  (Jacques Garrigue, review by Gabriel Scherer and Jeremy Yallop)

- #11536: Introduce wrapper functions for level management
  ([Ctype.with_level], etc) and for type variable scoping
  ([Typetexp.with_local_type_variable_scope]).
  The older API ([Ctype.(begin_def,end_def)], [Typetexp.(narrow,widen)], etc.)
  is now removed.
  (Jacques Garrigue and Takafumi Saikawa, review by Gabriel Scherer)

- #11601, #11612, #11628, #11613, #11623, #12120 : Clean up some
  global state handling in emitcode, bytepackager, bytegen,
  bytesections, spill.
  (Hugo Heuzard, Stefan Muenzel, review by Vincent Laviron, Gabriel Scherer
   and Nathanaëlle Courant)

- #12119, #12188, #12191: mirror type constraints on value binding in the
  parsetree:
  the constraint `typ` in `let pat : typ = exp` is now directly stored
  in the value binding node in the parsetree.
  (Florian Angeletti, review by  Richard Eisenberg)

- #11912: Refactoring handling of scoped type variables
  (Richard Eisenberg, review by Gabriel Scherer and Florian Angeletti)


- #11691, #11706: use __asm__ instead of asm for strict ISO C conformance
  (Xavier Leroy, report by Gregg Reynolds , review by Sadiq Jaffer)

- #11693: Remove use of C99 Variable Length Arrays (VLAs) in the runtime.
  (David Allsopp, review by Xavier Leroy, Guillaume Munch-Maccagnoni,
   Stefan Muenzel and Gabriel Scherer)

- #12138: Generalise interface for BUILD_PATH_PREFIX_MAP mapping.
  Absolute paths are now rewritten too.
  (Richard L Ford, suggestions and review by Gabriel Scherer)

- #10512: explain the compilation strategy for switches on constructors
  (Gabriel Scherer, review by Vincent Laviron)

- #11990: Improve comments and macros around frame descriptors.
  (Nick Barnes, review by Gabriel Scherer)

- #11847, #11849, #11851, #11898: small refactorings in the type checker
  (Gabriel Scherer, review by Nicolás Ojeda Bär)

- #11027: Separate typing counter-examples from type_pat into retype_pat;
  type_pat is no longer in CPS.
  (Jacques Garrigue and Takafumi Saikawa, review by Gabriel Scherer)

- #11286, #11515: disambiguate identifiers by using how recently they have
  been bound in the current environment
  (Florian Angeletti, review by Gabriel Scherer)

- #11364: Allow `make -C testsuite promote` to take `TEST` and `LIST` variables
  (Antal Spector-Zabusky, review by Gabriel Scherer and David Allsopp)

- #11446: document switch compilation (lambda/switch.ml)
  (Gabriel Scherer, review by Luc Maranget and Vincent Laviron)

- #11568: Encode inline record types in Path.t
  (Leo White and Hyunggyu Jang, review by Gabriel Scherer)

- #11569: Remove hash type encoding
  (Hyunggyu Jang, review by Gabriel Scherer and Florian Angeletti)

- #11627: use return values instead of globals for linear scan intervals
  (Stefan Muenzel, review by Nicolás Ojeda Bär)

- #11634: Dll.open_dll now properly handles opening for execution while already
  opened for checking
  (Hugo Heuzard, review by Nicolás Ojeda Bär)

* #11745, #12358: Debugger and toplevels: embed printer types rather than
  reading their representations from topdirs.cmi at runtime.
  This change also removes the ocamlmktop initialization module introduced
  in #11382 which was no longer useful.
  This change breaks toplevel scripts relying on the visibility of `Topdirs`
  in the initial toplevel environment without loading `topfind`.
  Since the opam default `.ocamlinit` file loads `topfind`, it is expected
  that only scripts run with `ocaml -noinit` are affected.
  For those scripts, accessing `Topdirs` now requires the `compiler-libs`
  directory to be added to the toplevel search path with
  ```
    #directory "+compiler-libs";;
  ````
  as was already the case for the other modules in the toplevel interface
  library.
  (Sébastien Hinderer, review by Florian Angeletti, Nicolás Ojeda Bär and
  Gabriel Scherer)

- #11615: remove global variables form asmcomp/linearize.ml
  (Stefan Muenzel, review by Nicolás Ojeda Bär

- #10856: Add location, attribute(s) visitors to Tast_mapper/Tast_iterator
  (Yan Dong, review by Nicolás Ojeda Bär and Gabriel Scherer)

- #11933: Use the correct machtype when reading the code pointer from closures
  (Nathanaëlle Courant, review by Gabriel Scherer and Vincent Laviron)

- #11972: refactor runtime/frame_descriptors.c
  in preparation for quadratic-time fix
  (Gabriel Scherer, review by Enguerrand Decorne)

- #11997: translate structured constants into their Obj.t representation
  at compile time rather than link time. Changes the way dumpobj prints
  these constants because their representation becomes untyped.
  (Sébastien Hinderer, review by Xavier Leroy, Nicolás Ojeda Bär and
  Hugo Heuzard)

- #12011: remove Ctype.reified_var_counter
  (Takafumi Saikawa and Jacques Garrigue, review by Gabriel Scherer)

- #12012: move calls to Typetexp.TyVarEnv.reset inside with_local_level etc.
  (Jacques Garrigue and Takafumi Saikawa, review by Gabriel Scherer)

- #12034: a logarithmic algorithm to find the next free variable
  (Gabriel Scherer, review by Stefan Muenzel)

- #12092: remove Lev_module_definition from lambda
  (Nick Roberts, review by Gabriel Scherer)

- #12117: Remove arity-interrupting elaboration of module unpacks
  (Nick Roberts, review by Richard Eisenberg and Jacques Garrigue)

- #12118: stop storing names of predefined exceptions in the
  cu_required_globals field of compilation unit descriptors.
  (Sébastien Hinderer, review by Vincent Laviron)

- #12125: Add Misc.print_see_manual and modify [@manual_ref] to accept
  lists for simpler printing of manual references
  (Stefan Muenzel, review by Florian Angeletti)

### Build system:

- #11844: Reduce verbosity of `make` logs by printing program invocations in
  shorthand (eg `OCAMLC foo.cmo`). Setting `V=1` recovers the old style (with
  full command-lines).
  (Xavier Leroy, Nicolás Ojeda Bär, review by Sébastien Hinderer)


- #11243, #11248, #11268, #11420, #11675: merge the sub-makefiles into
  the root Makefile.
  (Sébastien Hinderer, review by David Allsopp and Florian Angeletti)

- #11828: Compile otherlibs/ C stubs in two version for native and bytecode
  (Olivier Nicole, review by Sébastien Hinderer and Xavier Leroy)

- #12265: Stop adding -lexecinfo to cclibs (leftover debugging code from the
  multicore project). Harden the feature probe for -lm in configure so -lm is
  only added if strictly necessary. configure.ac now correctly propagates
  library flags for the Windows ports, allowing Windows OCaml to be configured
  with ZSTD support.
  (David Allsopp, review by Sébastien Hinderer)

### Bug fixes:

- #8813, #12029: In the toplevel, let the user type several phrases in one line
  (Damien Doligez, report by Daniel Bünzli, review by Gabriel Scherer and
   Wiktor Kuchta)

- #12062: fix runtime events consumer: when events are dropped they shouldn't be
  parsed. (Lucas Pluvinage)

- #12132: Fix overcounting of minor collections in GC stats.
  (Damien Doligez, review by Gabriel Scherer)

- #12017: Re-register finaliser only after calling user alarm in Gc.create_alarm
  (Fabrice Buoro, report by Sam Goldman, review by Guillaume Munch-Maccagnoni)

- #11887, #11893: Code duplication in pattern-matching compilation
  (Vincent Laviron, report par Greta Yorsh, review by Luc Maranget and
   Gabriel Scherer)

- #10664, #11600: Unsoundness in the typing of polymorphic methods
  involving polymorphic variants
  (Jacques Garrigue, report by Mike Shulman, review by Gabriel Scherer)

- #11302, #11412: `ocamlc` and `ocamlopt` should not remove generated files
  when they are not regular files.
  (Xavier Leroy, report by Thierry Martinez, review by
   Anil Madhavapeddy, Nicolás Ojeda Bär, David Allsopp)

- #10348, #10560, #11561: Expand GADT equations lazily during unification to
  avoid ambiguity
  (Jacques Garrigue, review by Leo White)

- #11436: Fix wrong stack backtrace for out-of-bound exceptions raised
  by leaf functions.
  (Tom Kelly and Xavier Leroy, review by Mark Shinwell)

- #11450, #12018: Fix erroneous functor error messages that were too eager to
  cast `struct end` functor arguments as unit modules in `F(struct end)`.
  (Florian Angeletti, review by Gabriel Scherer)

- #11643: Add missing test declaration to float_compare test, so that it will
  run.
  (Stefan Muenzel, review by David Allsopp)

- #11630: Use correct location when reporting record labels with non-existent
  paths.
  (Nicolás Ojeda Bär, report by Jason Gross, review by Gabriel Scherer)

- #11727: Ensure push_defaults can push past module patterns, fixing an
  currying optimisation accidentally disabled by #10340.
  (Stephen Dolan, review by Gabriel Scherer)

- #11771: Use a more relaxed mode for unification in Ctype.subst
  (Leo White, review by Jacques Garrigue and Gabriel Scherer)

- #11803, #11808: on x86, the destination of an integer comparison must be
  a register, it cannot be a stack slot.
  (Vincent Laviron, review by Xavier Leroy, report by
   Emilio Jesús Gallego Arias)

- #11809: Protect Parmatch.pats_of_type from missing cmis
  (Jacques Garrigue, review by Stephen Dolan and Gabriel Scherer)

- #11824: Fix a crash when calling `ocamlrun -b`
  (Florian Angeletti, review by Sébastien Hinderer)

- #11815: Marshalling continuations raises invalid argument exception.
  (Jérôme Vouillon, review by Nicolás Ojeda Bär, Stephen Dolan and
   Hugo Heuzard)

- #11846: Mark rbx as destroyed at C call for Win64 (mingw-w64 and Cygwin64).
  Reserve the shadow store for the ABI in the c_stack_link struct instead of
  explicitly when calling C functions. This simultaneously reduces the number of
  stack pointer manipulations and also fixes a bug when calling noalloc
  functions where the shadow store was not being reserved.
  (David Allsopp, report by Vesa Karvonen, review by Xavier Leroy and
   KC Sivaramakrishnan)

- #11850: When stopping before the `emit` phase (using `-stop-after`), an empty
  temporary assembly file is no longer left in the file system.
  (Nicolás Ojeda Bär, review by Gabriel Scherer and Xavier Leroy)

- #11866: Fix the result of `caml_read_directory()` on non-existent paths.
  (Andrei Paskevich and Charlène Gros, review by David Allsopp and
   Nicolás Ojeda Bär)

- #11879: Bugfix for Ctype.nondep_type
  (Stephen Dolan, review by Gabriel Scherer)

- #12004: Don't ignore function attributes on lambdas with locally abstract
  types.
  (Chris Casinghino, review by Gabriel Scherer)

- #12037: Fix some data races by using volatile when necessary
  (Fabrice Buoro and Olivier Nicole, review by Guillaume Munch-Maccagnoni,
  Gabriel Scherer and Luc Maranget)

- #12046: Flush stderr when tracing the parser
  (Hugo Heuzard, review by David Allsopp and Nicolás Ojeda Bär)

- #12061, #12063: don't add inconsistent equalities when computing
  high-level error messages for functor applications and inclusions.
  (Florian Angeletti, review by Gabriel Scherer)

- #12075: auto-detect whether `ar` support @FILE arguments at
  configure-time to avoid using this feature with toolchains
  that do not support it (eg FreeBSD/Darwin).
  (Nicolás Ojeda Bär, review by Xavier Leroy, David Allsopp, Javier
  Chávarri, Anil Madhavapeddy)

- #12103, 12104: fix a concurrency memory-safety bug in Buffer
  (Gabriel Scherer, review by Florian Angeletti, report by Samuel Hym)

- #12112: Fix caml_callback{2,3}_exn when used with effect handlers.
  (Lucas Pluvinage, review by Gabriel Scherer, David Allsopp and Xavier Leroy)

- #12134: Use ghost location for nodes created when handling defaults in
  optional arguments.
  (Paul-Elliot Anglès d'Auriac, review by Gabriel Scherer)

- #12153: Fix segfault in bytecode programs involving recursive value
  definitions of values of size 0
  (Vincent Laviron, Xavier Leroy, Gabriel Scherer,
   review by Xavier Leroy, report by Nick Roberts)

- #12162: Fix miscompilation on amd64 backends involving integer overflows
  (Vincent Laviron and Greta Yorsh, review by Stefan Muenzel)

- #12170: fix pthread_geaffinity_np configure check for android
  (David Allsopp, review by Sébastien Hinderer)

- #12178: Fix runtime events consumer poll function returning an invalid value
  instead of an OCaml integer value. (Lucas Pluvinage)

- #12252: Fix shared library build error on RISC-V.
  (Edwin Török, review by Nicolás Ojeda Bär and Xavier Leroy)

- #12255, #12256: Handle large signal numbers correctly (Nick Barnes,
   review by David Allsopp).

- #12277: ARM64, fix a potential assembler error for very large functions by
  emitting stack reallocation code before the body of the function.
  (Xavier Leroy, review by KC Sivaramakrishnan)

- #12253, #12342: Fix infinite loop in signal handling.
  (Guillaume Munch-Maccagnoni, report by Thomas Leonard, review by
   KC Sivaramakrishnan and Sadiq Jaffer)

- #12445: missing GC root registrations in runtime/io.c
  (Gabriel Scherer, review by Xavier Leroy and Jeremy Yallop)

- #12481, #12505: Fix incorrect initialization of array expressions
  `[|e1;...;eN|]` when `N` is large enough to require major heap allocation.
  (Xavier Leroy, report by Andrey Popp, analysis by KC Sivaramakrishnan
   and Vincent Laviron, review by Gabriel Scherer)

- #11150, #11207, #11936: Avoid recomputation in Typedecl.check_wellfounded
  (Jacques Garrigue, report by Boris Yakobowski, review by Gabriel Scherer)

- #11186, #11188: Fix composition of coercions with aliases
  (Vincent Laviron, report and review by Leo White)

- #12486: Fix delivery of unhandled effect exceptions on s390x
  (Miod Vallat, report by Jan Midtgaard, review by Vincent Laviron and Xavier
  Leroy)

OCaml 5.0.0 (15 December 2022)
------------------------------

- #10831: Multicore OCaml
  (Enguerrand Decorne, Stephen Dolan, Tom Kelly, Sadiq Jaffer,
  Anil Madhavapeddy, Sudha Parimala, KC Sivaramakrishnan,
  Leo White, the Tarides multicore team,
  review by Florian Angeletti, Damien Doligez, Xavier Leroy,
  Guillaume Munch-Maccagnoni, Olivier Nicole, Nicolás Ojeda Bär,
  Gabriel Scherer, the OCaml core development team, and many
  other valued reviewers.)

### Language features:

### Runtime system:

- #11400: Runtime events counters fixes
  Fixes mismatch between OCaml and C APIs, removes events from 4.x that
  are not present in the 5.0 GC and adds some missing probes.
  (Sadiq Jaffer, review by Gabriel Scherer, Florian Angeletti)

- #11368: Runtime events buffer size OCAMLRUNPARAMS fix
  The runtime events buffer size can now be set via the 'e' OCAMLRUNPARAM.
  This is previously mistakenly enabled/disabled tracing instead.
  (Sadiq Jaffer, review by KC Sivaramakrishnan, David Allsopp, Damien Doligez)

- #11308: Add environment variable to preserve runtime_events after exit
  If the environment variable OCAML_RUNTIME_EVENTS_PRESERVE exists then the
  runtime will not remove the runtime events ring buffers at exit. This
  makes tracing very short running programs more reliable.
  (Sadiq Jaffer, review by KC Sivaramakrishnan)

- #10964: Ring-buffer based runtime tracing (runtime_events)
  Runtime_events is a very low overhead runtime tracing system designed for
  continuous monitoring of OCaml applications.
  (Sadiq Jaffer, review by Anil Madhavapeddy, Enguerrand Decorne,
  Richard Warburton, Gabriel Scherer, Sabine Schmaltz, Florian Angeletti,
  Patrick Ferris, Tom Kelly)

* #10723: do not use `-flat-namespace` linking for macOS.
  (Carlo Cabrera, review by Damien Doligez)

* #10863, #10933: Remove support for old, unprefixed C runtime function names
  such as `alloc`.  The new names prefixed with `caml_` must be used instead,
  such as `caml_alloc`.  Consequently, it is no longer needed to define
  `CAML_NAME_SPACE` to avoid bringing unprefixed names into scope: this is now
  the default behavior.
  (Nicolás Ojeda Bär, review by Xavier Leroy)

- #10902: Do not register empty code fragments in natdynlink.
  (David Allsopp, review by Xavier Leroy and Damien Doligez)

- #10965: `caml_fatal_error_hook`, GC timing hooks, and
  `caml_scan_roots_hook` are now atomic variables. Restore GC timing
  hooks in multicore.
  (Guillaume Munch-Maccagnoni, review by Enguerrand Decorne, Xavier
  Leroy, Gabriel Scherer, and KC Sivaramakrishnan)

- #11209: Add a public and thread-safe timing hook running at domain
  termination, after this domain has stopped running any OCaml code:
  `caml_domain_terminated_hook`. This can be useful for implementing
  domain-local state in C.
  (Guillaume Munch-Maccagnoni, review by Xavier Leroy and Gabriel
  Scherer)

- #10875, #11731: Add option to allocate fiber stacks and sigaltstacks with
  mmap(MAP_STACK) instead of malloc. This is exposed via a configure
  --enable-mmap-map-stack option, and is enabled by default on OpenBSD where
  it is mandatory.
  (Anil Madhavapeddy, review by Gabriel Scherer, Tom Kelly,
   Michael Hendricks and KC Sivaramakrishnan).

- #10950: Do not use mmap to allocate Caml_state.
  In order to reduce virtual memory usage, we dynamically allocate
  the domain_state structure.
  (Enguerrand Decorne, KC Sivaramakrishnan and Tom Kelly,
  review by Anil Madhavapeddy and Gabriel Scherer)

- #11010: Use strerror_r for reentrant error string conversion.
  (Anil Madhavapeddy and Xavier Leroy, review by same and Edwin Török)

- #11002, #11066, #11086: Do not use Begin_roots/End_roots macros in
  the runtime system.  Also fix a missing root registration in the
  implementation of Unix.write on Windows.
  (Nicolás Ojeda Bär, Daniel Bünzli and Antonin Décimo,
   review by Xavier Leroy and David Allsopp)

- #11022: Track GC work for all managed bigarray allocations
  (Stephen Dolan, report by Andrew Hunter, review by Damien Doligez)

- #10802: Use 4.12 value macros and helpers in C code
  (Antonin Décimo, review by Gabriel Scherer)

- #11105: Fix handling of fiber stack cache with multiple domains
  (Jon Ludlam, KC Sivaramakrishnan and Tom Kelly)

- #11054: Respect user provided maximum stack space
  Make sure the stack we initially request is sized accordingly to
  the user provided settings. tmc/stack_space is also updated by
  this PR in order to account for this change.
  (Enguerrand Decorne, report by Jon Ludlam,
  review by Tom Kelly, KC Sivaramakrishnan and Gabriel Scherer)

- #11238: Increase the default limit for the stack size to 128 Mi words,
  i.e. 1 Gib for 64-bit platforms and 512 Mib for 32-bit platforms.
  (Xavier Leroy, review by Sébastien Hinderer)

* #11295: An ISO C 2011 compliant compiler, including full support for atomic
  types, is now required to build the OCaml runtime system.
  (Xavier Leroy, review by David Allsopp and Sébastien Hinderer)

- #10915, #11039, #11057, #11095, #11190: Implement quality treatment for
  asynchronous actions in multicore. Reimplement the old behaviour of
  `caml_process_pending*` for multicore.
  (Guillaume Munch-Maccagnoni, review by Sadiq Jaffer and Gabriel Scherer)

- #11303: Ensure that GC is not invoked from bounds check failures
  (Stephen Dolan, review by Sadiq Jaffer and Xavier Leroy)

- #11304: Fix data race on Windows file descriptors
  (Olivier Nicole and Xavier Leroy, review by Xavier Leroy, David Allsopp,
   and Sadiq Jaffer)

* #11337: pass 'flags' metadata to root scanners, to optimize stack
  scanning in the bytecode interpreter.
  Changes the interface of user-provided root-scanning hooks.
  (Gabriel Scherer, review by Xavier Leroy,
   Guillaume Munch-Maccagnoni, Sadiq Jaffer and Tom Kelly)

* #11255: in the C interface, `&Field(v, i)` now has type `volatile value *`
  instead of `value *` in OCaml 4.  This makes the memory model
  for mixed OCaml/C code better defined, but can cause warnings or type
  errors in user C code.
  (KC Sivaramakrishnan, review by Xavier Leroy, Gabriel Scherer and
  Guillaume Munch-Maccagnoni, additional discussions with Stephen
  Dolan and Luc Maranget)

- #5299, #4787, #11138, #11272, #11506: To help debugging, `Caml_state`
  now dynamically checks that the domain lock is held, and fails
  otherwise (with a fatal error at most entry points of the C API, or
  systematically in debug mode). A new variable `Caml_state_opt` is
  introduced, and is `NULL` when the domain lock is not held. This
  allows to test from C code if the current thread holds the lock of
  its domain.
  (Guillaume Munch-Maccagnoni, review by Florian Angeletti, Damien
  Doligez, Sadiq Jaffer, Xavier Leroy, and Gabriel Scherer)

- #11223: The serialization format of custom blocks changed in 4.08,
  but the deserializer would still support the pre-4.08 format.  OCaml
  5.x removed support for this old format; provide a clear error message
  in this case.
  (Hugo Heuzard, review by Gabriel Scherer)

- #11504, #11522: Use static allocation in `caml_make_float_vect` in
  no-flat-float-array mode, it's more efficient and avoids a a race condition
  (Xavier Leroy, report by Guillaume Munch-Maccagnoni, review by David Allsopp)

- #11652: Fix benign off-by-one error in Windows implementation of caml_mem_map.
  (David Allsopp, review by Gabriel Scherer)

- #11669, #11704: Fix construction of Effect.Unhandled exceptions in the
  bytecode interpreter.
  (David Allsopp and Xavier Leroy, report by Samuel Hym, review by Xavier Leroy
  and Gabriel Scherer)

### Code generation and optimizations:

- #10972: ARM64 multicore support: OCaml & C stack separation;
  dynamic stack size checks; fiber and effects support.
  (Tom Kelly and Xavier Leroy, review by KC Sivaramakrishnan, Xavier Leroy,
  Guillaume Munch-Maccagnoni, Eduardo Rafael, Stephen Dolan and
  Gabriel Scherer)

### Standard library:

- #10742: Use LXM as the pseudo-random number generator for module Random.
  Add `Random.State.split` and `Random.split` to "split" a PRNG off
  another PRNG.
  (Xavier Leroy, review by Gabriel Scherer and Hugo Heuzard)

* #10867, #11345: Remove deprecated values: Array.create, Array.make_float,
  Array.create_matrix, Bytes.uppercase, Bytes.lowercase, Bytes.capitalize,
  Bytes.uncapitalize, Char.lowercase, Char.uppercase, Filename.temp_dir_name,
  Int32.format, Int64.format, Nativeint.format, Format.bprintf, Format.kprintf,
  Format.set_all_formatter_output_functions,
  Format.get_all_formatter_output_functions,
  Format.pp_set_all_formatter_output_functions,
  Format.pp_get_all_formatter_output_functions, Format.pp_open_tag,
  Format.pp_close_tag, Format.open_tag, Format.close_tag,
  Format.formatter_tag_functions, Format.pp_set_formatter_tag_functions,
  Format.pp_get_formatter_tag_functions, Format.set_formatter_tag_functions,
  Format.get_formatter_tag_functions, Gc (mutability of the fields of type
  Gc.control), Lazy.lazy_from_fun, Lazy.lazy_from_val, Lazy.lazy_is_val,
  Obj.set_tag, Obj.truncate, Obj.final_tag, Obj.extension_constructor,
  Obj.extension_name, Obj.extension_id, Scanf.stdib, Scanf.fscanf,
  Scanf.kfscanf, Stdlib.( & ), Stdlib.( or ), String.set, String.copy,
  String.fill, String.unsafe_set, String.unsafe_fill, String.uppercase,
  String.lowercase, String.capitalize, String.uncapitalize, Thread.kill,
  Thread.wait_write, Thread.wait_read, the whole ThreadUnix module, the
  infix operator (.[]<-).
  (Nicolás Ojeda Bär, review by Damien Doligez)

* #10896: Remove Stream, Genlex and Pervasives. Also remove legacy standalone
  bigarray library (the Bigarray module is now part of the standard library).
  (Nicolás Ojeda Bär, review by Kate Deplaix and Anil Madhavapeddy)

- #10921: Use getentropy, when available, to seed the generator during
  `Random.self_init`
  (Michael Hendricks, review by Gabriel Scherer, Xavier Leroy, and
  Anil Madhavapeddy)

* #10924: Add deprecated attribute to Printexc.catch, Printf.kprintf and
  Unix.SO_ERROR.
  (Nicolás Ojeda Bär, review by Damien Doligez)

- #10986: Add Scanf.sscanf_opt, Scanf.bscanf_opt and Scanf.scanf_opt.
  (Nicolás Ojeda Bär, review by Florian Angeletti and Gabriel Scherer)

* #11157: Rename "hash" in the "Hashtbl.SeededHashedType" signature to
  "seeded_hash". This allows defining both seeded and unseeded hash functions in
  the same module.
  (Nicolás Ojeda Bär, review by Gabriel Scherer and Xavier Leroy)

- #8878: Add String.hash and String.seeded_hash.
  (Tom Kelly, review by Alain Frisch and Nicolás Ojeda Bär)

- #11279, #11585, #11742: ensure that the unsafe Buffer code
  remains memory-safe in concurrent settings.
  Unsynchronized access to Buffer is a programming error and may
  result in wrong behavior, but it should preserve memory-safety.
  (Florian Angeletti and Gabriel Scherer, review by Gabriel Scherer
   and Vincent Laviron, report by David Allsopp)


### Other libraries:

* #9071, #9100, #10935: Reimplement `Thread.exit()` as raising the
  exception `Thread.Exit`, and mark `Thread.exit` as deprecated.
  The new implementation changes the behavior compared with
  the OCaml 4 implementation.  For example, the new implementation
  causes `Fun.finally` finalizers to be run and catch-all exception
  handlers to prevent termination.
  (Jacques-Henri Jourdan and Xavier Leroy, review by Damien Doligez,
  Guillaume Munch-Maccagnoni, Gabriel Scherer, and Enguerrand Decorne)

- #11034: Dynlink library, add a global lock to make dynlinking
  thread-safe.
  (Florian Angeletti, review by Gabriel Scherer)

- #11087: deprecate Thread.wait_timed_read, Thread.wait_timed_write,
  Thread.select, Thread.wait_pid. The same functionality is available in the
  Unix module.
  (Nicolás Ojeda Bär, review by Anil Madhavapeddy)

- #11309, #11424, #11427, #11545: Add Domain.recommended_domain_count.
  (Christiano Haesbaert, Konstantin Belousov, review by David Allsopp,
  KC Sivaramakrishnan, Gabriel Scherer, Nicolás Ojeda Bär)

- #11461, #11466: Fix gethostbyaddr for IPv6 arguments and make it domain-safe
  (Olivier Nicole, Nicolás Ojeda Bär, David Allsopp and Xavier Leroy,
   review by the same)

- #11479: Make Unix.symlink domain-safe on Windows
  (Olivier Nicole, review by Xavier Leroy and David Allsopp)

### Tools:

* #11004: Litmus tests for checking the implementation of the
  memory model.
  (Luc Maranget, review by Gabriel Scherer and Xavier Leroy)

- #11024: Handle alerts in ocamldoc.
  The alert `[@@alert deprecated]` is handled specifically and it's no longer
  needed to duplicate the deprecated annotation (the alert for the compiler and
  the tag for the documentation). Every other alerts also appear in the
  documentation.
  (Jules Aguillon, review by Florian Angeletti)

- #11065: Port the bytecode debugger to 5.0, adding support for effect handlers.
  (Damien Doligez and @fabbing, review by @fabbing and Xavier Leroy)

- #11079: Add the -nobanners option to dumpobj.
  (Sébastien Hinderer, review by Gabriel Scherer and Vincent Laviron)

- #11100: Fix ocamltest to make sure failed tests are not counted as
  "unexpected error".
  (Damien Doligez, review by Sébastien Hinderer)

- #11245: Merge the common code of ocamlcp and ocamloptp into a single module.
  (David Allsopp, review by Sébastien Hinderer)

- #11382: OCamlmktop use a new initialization module "OCamlmktop_init" to
  preserve backward-compatibility with user-module provided modules that install
  toplevel printers.
  (Florian Angeletti, review by Gabriel Scherer and David Allsopp)

### Manual and documentation:

- #11058: runtime/HACKING.adoc tips on debugging the runtime
  (Gabriel Scherer, review by Enguerrand Decorne and Nicolás Ojeda Bär)

- #11093: Add an effect handlers tutorial
  (KC Sivaramakrishnan, review by François Pottier, Gabriel Scherer, François
  Bobot and Wiktor Kuchta)

- #11192: Better documentation for condition variables.
  (François Pottier, review by Luc Maranget, Xavier Leroy, and Wiktor Kuchta)

- #11093: Add tutorials on parallelism features and the relaxed memory model
  (KC Sivaramakrishnan, review by Damien Doligez, Anil Madhavapeddy, Gabriel
  Scherer, Thomas Leonard, Tom Ridge, Xavier Leroy, Luc Maranget, Fabrice
  Buoro, Olivier Nicole, Guillaume Munch-Maccagnoni, Jacques-Henri Jourdan)

- #11640, #11647: Add missing options to the man pages:
   flambda commonly-used options, and negative options (`-no-rectypes`, ... ).
   (Amandine Nangah, review by David Allsopp, Florian Angeletti,
   Sébastien Hinderer, and Vincent Laviron)

- #11676: Fix missing since annotation in the `Sys` and `Format` modules
  (Github user Bukolab99, review by Florian Angeletti)

- #11813: Make new multicore chapters easier to discover, and emphasize impact
  on C bindings.
  (Edwin Török, review by KC Sivaramakrishnan, and Florian Angeletti)

### Compiler user-interface and warnings:

- #9140, #11131: New command-line flag -nocwd to not include implicit
  the current directory to the load path.
  (Thomas Roglin, review by Gabriel Scherer and Nicolás Ojeda Bär)

- #11089: Add 'since <version>' information to compiler warnings.
  (André Maroneze, review by Florian Angeletti and Gabriel Scherer)

- #10909: Disable warning 59 (assignment to immutable blocks) unless flambda
  invariant checks are enabled.
  (Vincent Laviron, review by Gabriel Scherer)

- #10981, #11276: Implement a -cmi-file option for ocamlc and ocamlopt.
  (Sébastien Hinderer, review by Damien Doligez, Daniel Bünzli and
  Florian Angeletti)

* #11049: Stop padding 1-digit compiler minor version numbers.
  (So for instance OCaml 5.0 rather than 5.00)
  (Sébastien Hinderer, review by David Allsopp, Florian Angeletti and
  Xavier Leroy)

- #11253: Deprecate `ocaml script` and `ocamlnat` script where `script` has no
  extension and is an implicit basename.
  (David Allsopp, review by Florian Angeletti and Sébastien Hinderer)

### Internal/compiler-libs changes:

- #10878, #10909: restore flambda after the Multicore merge.
  (Vincent Laviron, review by Gabriel Scherer and Xavier Leroy)

- #10864, #10888: restore afl-fuzz mode for sequential programs.
  (Jan Midtgaard, review by Xavier Leroy and Gabriel Scherer)

- #11008, #11047: rework GC statistics in the Multicore runtime
  (Gabriel Scherer, review by Enguerrand Decorne)

- #11058: basic debugging documentation in runtime/HACKING.adoc
  (Gabriel Scherer, review by Enguerrand Decorne and Nicolás Ojeda Bär)

- #11199: Stop installing topdirs.cmi twice. The toplevel now reads topdirs.cmi
  from +compiler-libs, as the debugger does.
  (David Allsopp, review by Sébastien Hinderer)

- #11007, #11399: META files for the stdlib, compiler-libs and other libraries
  (unix, dynlink, str, runtime_events, threads, ocamldoc) are now installed
  along with the compiler.
  (David Allsopp, Florian Angeletti, Nicolás Ojeda Bär and Sébastien Hinderer,
   review by Daniel Bünzli, Kate Deplaix, Anil Madhavapeddy and Gabriel Scherer)

### Build system:

* #10893: Remove configuration options --disable-force-safe-string and
  DEFAULT_STRING=unsafe as well as --enable-force-safe-string and
  DEFAULT_STRING=safe which are now the default unconditionally.
  (Kate Deplaix, review by Gabriel Scherer and David Allsopp)

- #11092: Build native-code compilers on OpenBSD/aarch64.
  (Christopher Zimmermann, review by Anil Madhavapeddy)

- #11126: Build system: make it possible to choose which ocamldep
  (and flags) to use when computing dependencies for the compiler.
  Add a -no-slash option to ocamldep to let users override -slash.
  (Sébastien Hinderer, review by David Allsopp)

- #11147: Factorize the stdlib-related compilation flags. Make it
  possible to control them consistently through the STDLIBFLAGS
  build variable. Make sure ocamldoc and ocamllex get compiled and
  linked with debugging information (-g).
  (Sébastien Hinderer, review by Gabriel Scherer)

- #11149: Make the bootstrap process reproducible on systems with non-big-endian
  floating point. If the boot/ artefacts are up-to-date, this means that running
  make bootstrap on any platform should not change the images in boot/ and paves
  the way for automated testing that the bootstrap is repeatable.
  (David Allsopp, review by Damien Doligez and Sébastien Hinderer)

- #11160: otherlibs: merge win32unix into unix.
  (Sébastien Hinderer, review by David Allsopp, Nicolás Ojeda Bär,
  Xavier Leroy, Vincent Laviron and Antonin Décimo)

* #11198, #11298: Install the Dynlink, Str and Unix libraries to individual
  subdirectories of LIBDIR. The compiler, debugger and toplevel automatically
  add `-I +lib` if required, but display an alert.
  (David Allsopp, review by Florian Angeletti, Nicolás Ojeda Bär,
   Valentin Gatien-Baron and Sébastien Hinderer)

- #11200: Install ocamlprof's Profiling runtime module to a +profiling,
  removing it from the default namespace.
  (David Allsopp, review by Sébastien Hinderer)

- #11294: Switch minimum required autoconf to 2.71.
  (David Allsopp, review by Xavier Leroy)

- #11097: Build native-code compilers on NetBSD/aarch64
  (Kate Deplaix, review by Anil Madhavapeddy)

### Bug fixes:

- #10790: don't drop variance and injectivity annotations when pretty printing
  `with` constraints (for example, `with type +!'a t = ...`).
  (Florian Angeletti, report by Luke Maurer, review by Matthew Ryan and
   Gabriel Scherer)

- #11167: Fix memory leak from signal stack.
  (Antoni Żewierżejew, review by Gabriel Scherer and Enguerrand Decorne)

- #11112: harden -use-runtime against spaces or quotes in the provided path
  (Gabriel Scherer, report by Brahima Dibassi, review by David Allsopp)

- #11068, #11070: Fix typo in function name given in Unix_error exception for
  Unix.readlink on Windows.
  (David Allsopp, report by Xia Li-yao)

- #10807: Don't duplicate standard handles in the child process
  spawned by win32unix Unix.create_process if the handles were already
  inheritable. Fix broken signalling of EOF on standard handles if
  they were already inheritable.
  (Antonin Décimo, review by Xavier Leroy and Nicolás Ojeda Bär)

- #10868: Fix off-by-1 bug when initializing frame hashtables
  (Jonah Beckford, review by Tom Kelly, Nicolás Ojeda Bär and
  KC Sivaramakrishnan)

- #11077: Make dumpobj compatible with absence of naked pointer support
  (Olivier Nicole and Jan Midtgaard, review by Gabriel Scherer)

- #11111: fix fork() usage in ocamltest C code.
  When calling fork() from C code with the Multicore runtime active,
  one needs to call caml_atfork_hook() on the forked child before it
  can use the OCaml runtime.
  (Gabriel Scherer, review by Xavier Leroy, report by Brahima Dibassi)

- #10809: Use the WSA_FLAG_NO_HANDLE_INHERIT on Windows when creating
  sockets with WSASocket if the cloexec (non-inheritable) parameter is
  true. Fixes a race condition where a child process could inherit the
  socket and deadlock the parent.
  (Antonin Décimo, review by Xavier Leroy)

- #11289, #11405: fix some leaks on systhread termination
  (Fabrice Buoro, Enguerrand Decorne, Gabriel Scherer,
   review by Xavier Leroy and Florian Angeletti, report by Romain Beauxis)

- #11314, #11416: fix non-informative error message for module inclusion
  (Florian Angeletti, report by Thierry Martinez, review by Gabriel Scherer)

- #11358, #11379: Refactor the initialization of bytecode threading,
  This avoids a "dangling pointer" warning of GCC 12.1.
  (Xavier Leroy, report by Armaël Guéneau, review by Gabriel Scherer)

- #11387, module type with constraints no longer crash the compiler in presence
  of both shadowing warnings and the `-bin-annot` compiler flag.
  (Florian Angeletti, report by Christophe Raffalli, review by Gabriel Scherer)

- #11482, #11542: Fix random crash in large closure allocation
  (Damien Doligez, report by Thierry Martinez and Vincent Laviron, review by
   Xavier Leroy)

- #11508, #11509: make Bytes.escaped domain-safe
  (Christiano Haesbaert and Gabriel Scherer,
   review by Xavier Leroy,
   report by Jan Midtgaard and Tom Kelly)

- #11576: Fix bug in Bigarray.Genarray.init in the the case of zero-dimensional
  arrays.
  (Nicolás Ojeda Bär, Jeremy Yallop, report by Masayuki Takeda, review by Jeremy
  Yallop and Florian Angeletti)

- #11587: Prevent integer comparison from being used on pointers
  (Vincent Laviron, review by Gabriel Scherer)

- #11662, #11673: fix a memory leak when using Dynlink,
  the bug was only present in development version of OCaml 5.
  (Stephen Dolan, report by Andre Maroneze, review by Gabriel Scherer)


OCaml 4.14 maintenance version
------------------------------

### Runtime system:

- #11764, #12577: Add prototypes to old-style C function definitions
   and declarations.
  (Antonin Décimo, review by Xavier Leroy and Nick Barnes)

- #11763, #11759, #11861, #12509, #12577: Use strict prototypes on primitives.
  (Antonin Décimo, review by Xavier Leroy, David Allsopp, Sébastien
   Hinderer and Nick Barnes)

### Build system:

- #11590: Allow installing to a destination path containing spaces.
  (Élie Brami, review by Sébastien Hinderer and David Allsopp)

- #12372: Pass option -no-execute-only to the linker for OpenBSD >= 7.3
  so that code sections remain readable, as needed for closure marshaling.
  (Xavier Leroy and Anil Madhavapeddy, review by Anil Madhavapeddy and
  Sébastien Hinderer)

- #12903: Disable control flow integrity on OpenBSD >= 7.4 to avoid
  illegal instruction errors on certain CPUs.
  (Michael Hendricks, review by Miod Vallat)

### Bug fixes:

- #12878: fix incorrect treatment of injectivity for private recursive types.
  (Jeremy Yallop, review by Gabriel Scherer and Jacques Garrigue)

- #12971, #12974: fix an uncaught Ctype.Escape exception on some
  invalid programs forming recursive types.
  (Gabriel Scherer, review by Florian Angeletti, report by Neven Villani)

- #12264, #12289: Fix compact_allocate to avoid a pathological case
  that causes very slow compaction.
  (Damien Doligez, report by Arseniy Alekseyev, review by Sadiq Jaffer)

* #10845 Emit frametable size on amd64 BSD (OpenBSD, FreeBSD, NetBSD) systems
  (emitted for Linux in #8805)
  (Hannes Mehnert, review by Nicolás Ojeda Bär)

- #13448, #13449: fix a code-generation bug on unsafe array accesses
  at type int32, int64, nativeint, which has been introduced in OCaml 4.04.
  (Gabriel Scherer, review by Nicolás Ojeda Bär and Vincent Laviron,
   report by Raphaël Bocquet and Simon Cruanes)

OCaml 4.14.1 (20 December 2022)
------------------------------

### Compiler user-interface and warnings:

- #11184, #11670: Stop calling ranlib on created / installed libraries
  (Sébastien Hinderer and Xavier Leroy, review by the same)

### Build system:

- #11370, #11373: Don't pass CFLAGS to flexlink during configure.
  (David Allsopp, report by William Hu, review by Xavier Leroy and
   Sébastien Hinderer)

- #11487: Thwart FMA test optimization during configure
  (William Hu, review by David Allsopp and Sébastien Hinderer)

### Bug fixes:

- #10768, #11340: Fix typechecking regression when combining first class
  modules and GADTs.
  (Jacques Garrigue, report by François Thiré, review by Matthew Ryan)

- #11204: Fix regression introduced in 4.14.0 that would trigger Warning 17 when
  calling virtual methods introduced by constraining the self type from within
  the class definition.
  (Nicolás Ojeda Bär, review by Leo White)

- #11263, #11267: caml/{memory,misc}.h: check whether `_MSC_VER` is defined
  before using it to ensure that the headers can always be used in code which
  turns on -Wundef (or equivalent).
  (David Allsopp and Nicolás Ojeda Bär, review by Nicolás Ojeda Bär and
   Sébastien Hinderer)

- #11392, #11392: assertion failure with -rectypes and external definitions
  (Gabriel Scherer, review by Florian Angeletti, report by Dmitrii Kosarev)

- #11417: Fix regression allowing virtual methods in non-virtual classes.
  (Leo White, review by Florian Angeletti)

- #11468: Fix regression from #10186 (OCaml 4.13) detecting IPv6 on Windows for
  mingw-w64 i686 port.
  (David Allsopp, review by Xavier Leroy and Sébastien Hinderer)

- #11489, #11496: More prudent deallocation of alternate signal stack
  (Xavier Leroy, report by @rajdakin, review by Florian Angeletti)

- #11516, #11524: Fix the `deprecated_mutable` attribute.
  (Chris Casinghino, review by Nicolás Ojeda Bär and Florian Angeletti)

- #11194, #11609: Fix inconsistent type variable names in "unbound type var"
  messages
  (Ulysse Gérard and Florian Angeletti, review Florian Angeletti and
   Gabriel Scherer)

- #11622: Prevent stack overflow when printing a constructor or record
  mismatch error involving recursive types.
  (Florian Angeletti, review by Gabriel Scherer)

- #11732: Ensure that types from packed modules are always generalised
  (Stephen Dolan and Leo White, review by Jacques Garrigue)

- #11737: Fix segfault condition in Unix.stat under Windows in the presence of
  multiple threads.
  (Marc Lasson, Nicolás Ojeda Bär, review by Gabriel Scherer and David Allsopp)

- #11776: Extend environment with functor parameters in `strengthen_lazy`.
  (Chris Casinghino and Luke Maurer, review by Gabriel Scherer)

- #11533, #11534: follow synonyms again in #show_module_type
  (this had stopped working in 4.14.0)
  (Gabriel Scherer, review by Jacques Garrigue and Florian Angeletti,
   report by Yaron Minsky)

- #11768, #11788: Fix crash at start-up of bytecode programs in
  no-naked-pointers mode caused by wrong initialization of caml_global_data
  (Xavier Leroy, report by Etienne Millon, review by Gabriel Scherer)

- #11803, #11808: on x86, the destination of an integer comparison must be
  a register, it cannot be a stack slot.
  (Vincent Laviron, review by Xavier Leroy, report by
   Emilio Jesús Gallego Arias)

OCaml 4.14.0 (28 March 2022)
----------------------------

### Language features:

- #10462: Add attribute to produce a compiler error for polls.
  (Sadiq Jaffer, review by Mark Shinwell, Stephen Dolan
   and Guillaume Munch-Maccagnoni)

- #10437: Allow explicit binders for type variables.
  (Stephen Dolan, review by Leo White)

- #10441: Remove unnecessary parentheses surrounding immediate objects.
  Allow 'object ... end # f', 'f object ... end', etc.
  (Yan Dong, review by Nicolás Ojeda Bär, Florian Angeletti and Gabriel Scherer)

- #181, #9760, #10740: opt-in tail-modulo-cons (TMC) transformation
    let[@tail_mod_cons] rec map f li = ...
  (Frédéric Bour, Gabriel Scherer, Basile Clément,
   review by Basile Clément and Pierre Chambart,
   tested by Konstantin Romanov)

### Runtime system:

* #9391, #9424: Fix failed assertion in runtime due to ephemerons *set_* and
  *blit_* function during Mark phase
  (François Bobot, reported by Stephen Dolan, reviewed by Damien Doligez)

- #10195, #10680: Speed up GC by prefetching during marking
  (Stephen Dolan, review by Xavier Leroy, Guillaume Munch-Maccagnoni,
   Jacques-Henri Jourdan, Damien Doligez and Leo White)

- #10549: Stack overflow detection and naked pointers checking for ARM64
  (Xavier Leroy, review by Stephen Dolan)

* #10675: Emit deprecation warnings when old C runtime function names
  are used.  This will break C stub code that uses these old names and
  treats warnings as errors.  The workaround is to use the new names.
  (Xavier Leroy and David Allsopp, review by Sébastien Hinderer and
   Damien Doligez)

- #10698, #10726: Free the alternate signal stack when the main OCaml
   code or an OCaml thread stops
  (Xavier Leroy, review by David Allsopp and Damien Doligez)

- #10730, 10731: Fix bug in `Obj.reachable_words` causing a slowdown when called
  multiple time (Alain Frisch, report by ygrek, review by Xavier Leroy)

- #10926: Rename the two internal Windows Unicode functions with `caml_` prefix
  instead of `win_`.
  (David Allsopp, review by Kate Deplaix, Damien Doligez and Xavier Leroy)

### Code generation and optimizations:

- #10578: Increase the number of integer registers used for
  parameter passing on PowerPC (16 registers) and on s390x (8 registers).
  (Xavier Leroy, review by Mark Shinwell)

- #10591, #10615: Tune the heuristic for CSE of integer constants
  so as to avoid excessive CSE on compiler-generated constants
  and long register allocation times.
  (Xavier Leroy, report by Edwin Török, review by Nicolás Ojeda Bär)

- #10595: Tail calls with up to 64 arguments are guaranteed to be compiled
  as tail calls.  To this end, memory locations in the domain state
  are used for passing arguments that do not fit in registers.
  (Xavier Leroy, review by Vincent Laviron)

- #10681: Enforce boolean conditions for the native backend
  (Vincent Laviron, review by Gabriel Scherer)

- #10719: Ensure that build_apply respects Lambda.max_arity
  (Stephen Dolan, review by Xavier Leroy)

- #10728: Ensure that functions are evaluated after their arguments
  (Stephen Dolan, review by Mark Shinwell)

- #10732: Ensure right-to-left evaluation of arguments in cmm_helpers
  (Greta Yorsh, review by Xavier Leroy)

### Standard library:

* #10710: Add UTF tools, codecs and validations to the Uchar, Bytes and
  String modules.
  (Daniel Bünzli, review by Florian Angeletti, Nicolás Ojeda Bär, Alain
   Frisch and Gabriel Scherer)

* #10622: Annotate `Uchar.t` with immediate attribute
  (Hongbo Zhang, reivew by Gabriel Scherer and Nicolás Ojeda Bär)

* #7812, #10475: `Filename.chop_suffix name suff` now checks that `suff`
  is actually a suffix of `name` and raises Invalid_argument otherwise.
  (Xavier Leroy, report by whitequark, review by David Allsopp)

* #10482: mark the Stream and Genlex modules as deprecated, in preparation
  for a future removal.  These modules (without deprecation alert)
  are now provided by the camlp-streams library.
  (Xavier Leroy, review by Nicolás Ojeda Bär)

- #10526: add Random.bits32, Random.bits64, Random.nativebits
  (Xavier Leroy, review by Gabriel Scherer and François Bobot)

* #10568: remove Obj.marshal and Obj.unmarshal
  (these functions have been deprecated for a while and are superseded
   by the functions from module Marshal)
  (François Pottier, review by Gabriel Scherer and Kate Deplaix)

- #10545: Add In_channel and Out_channel modules.
  (Nicolás Ojeda Bär, review by Daniel Bünzli, Simon Cruanes, Gabriel Scherer,
  Guillaume Munch-Maccagnoni, Alain Frisch and Xavier Leroy)

- #10538: add Out_channel.set_buffered and Out_channel.is_buffered to control
  the buffering mode of output channels.
  (Nicolás Ojeda Bär, review by John Whitington, Daniel Bünzli, David Allsopp
  and Xavier Leroy)

* #10583, #10998: Add over 40 new functions in Seq.
  (François Pottier and Simon Cruanes, review by Nicolás Ojeda Bär,
  Daniel Bünzli, Nathanaëlle Courant, Craig Ferguson, Wiktor Kuchta,
  Xavier Leroy, Guillaume Munch-Maccagnoni, Raphaël Proust, Gabriel Scherer
  and Thierry Martinez)

- #10596, #10978: Add with_open_bin, with_open_text and with_open_gen to
  In_channel and Out_channel. Also, add In_channel.input_all.
  (Nicolás Ojeda Bär, review by Daniel Bünzli, Jérémie Dimino, Damien Doligez
  and Xavier Leroy)

- #10658: add detailed information about the current version of OCaml
  to the Sys module of the standard library.
  (Sébastien Hinderer, review by Damien Doligez, Gabriel Scherer, David
  Allsopp, Nicolás Ojeda Bär, Vincent Laviron)

- #10642: On Windows, Sys.remove and Unix.unlink now remove symlinks
  to directories instead of raising EACCES. Introduce
  caml/winsupport.h to hold more common code between the runtime,
  lib-sys, and win32unix.
  (Antonin Décimo, review by David Allsopp and Xavier Leroy)

- #10737: add new ephemeron API for forward compatibility with Multicore
  OCaml.
  (Damien Doligez, review by Stephen Dolan)

- #10786: The implementation of Complex.norm now uses Float.hypot.
  (Christophe Troestler, review by David Allsopp and Xavier Leroy)

### Other libraries:

- #10192: Add support for Unix domain sockets on Windows and use them
  to emulate Unix.socketpair (only available on Windows 1803+)
  (Antonin Décimo, review by David Allsopp)

- #10469: Add Thread.set_uncaught_exception_handler and
  Thread.default_uncaught_exception_handler.
  (Enguerrand Decorne, review by David Allsopp)

- #10697: Bindings of dup and dup2 in win32unix now correctly call
  WSADuplicateSocket on sockets instead of DuplicateHandle.
  (Antonin Décimo, review by Xavier Leroy and Nicolás Ojeda Bär)

* #10926, #11336: Ensure all C functions in the Unix library are prefixed with
  `caml_`.
  (David Allsopp, review by Kate Deplaix, Damien Doligez and Xavier Leroy)

- #10951: Introduce the Thread.Exit exception as an alternative way to
  terminate threads prematurely.  This alternative way will become
  the standard way in 5.0.
  (Xavier Leroy, review by Florian Angeletti)

### Tools:

- #9701: Release bytecode only after collecting backtrace information
  for exceptions, same for dynamic loaded code compiled from toplevel on
  ocamlnat.
  (Renato Alencar, reported by Krzysztof Leśniak, reviewed by Gabriel Scherer)

- #10839: Fix regression of #show when printing class type
  (Élie Brami, review by Florian Angeletti)

- #3959, #7202, #10476: ocaml, in script mode, directive errors
  (`#use "missing_file";;`) use stderr and exit with an error.
  (Florian Angeletti, review by Gabriel Scherer)

- #10438: add a new toplevel cli argument `-e <script>` to
  run script passed to the toplevel.
  (Pavlo Khrystenko, review by Gabriel Scherer)

- #10524: Directive argument type error now shows expected and received type.
  (Wiktor Kuchta, review by Gabriel Scherer)

- #10560: Disable colors if the env variable `NO_COLOR` is set.  If
  `OCAML_COLOR` is set, its setting takes precedence over `NO_COLOR`.
  (Nicolás Ojeda Bär, report by Gabriel Scherer, review by Daniel Bünzli,
  Gabriel Scherer and David Allsopp)

- #10565: Toplevel value printing: truncate strings only after 8 bytes.
  (Wiktor Kuchta, review by Xavier Leroy)

- #10527: Show "#help;; for help" at toplevel startup
  (Wiktor Kuchta, review by David Allsopp and Florian Angeletti)

- #10846: add the `-shape` command-line option to ocamlobjinfo. When reading a
  `cmt` file, shape information will only be shown if that option is used.
  (Ulysse Gérard, review by Florian Angeletti)

### Debugging:

- #10517, #10594: when running ocamldebug on a program linked with the
  threads library, don't fail immediately; instead, allow debugging
  until the program creates a thread for the first time, then fail cleanly.
  (Xavier Leroy, report by @anentropic, review by Gabriel Scherer)

- #9621: Pack the ocamldebug modules to minimize clashes
  (Raphael Sousa Santos, review by Vincent Laviron and Gabriel Scherer)

### Manual and documentation:

- #7812, #10475: reworded the description of the behaviors of
  float->int conversions in case of overflow, and of iterators
  in case of concurrent modifications.
  (Xavier Leroy, report by whitequark, review by David Allsopp)

- #8697, #10666: add M, m, n options of the OCAMLRUNPARAM to manual and man page
  for ocamlrun command line options
  (Dong An and Anukriti Kumar, review by David Allsopp, Gabriel Scherer
   and Damien Doligez)

- #10281, #10685: Add description of C compiler on macOS and Windows platforms.
  (Dong An, review by Xavier Leroy and David Allsopp)

- #10397: Document exceptions raised by Unix module functions on Windows
  (Martin Jambon, review by Daniel Bünzli, David Allsopp, Damien Doligez,
   Xavier Leroy, and Florian Angeletti)

- #10589: Fix many typos (excess/inconsistent spaces) in the HTML manual.
  (Wiktor Kuchta, review by Florian Angeletti)

- #10605: manual, name few css classes to ease styling and maintainability.
  (Florian Angeletti, review by Wiktor Kuchta and Gabriel Scherer)

- #10668, #10669: the changelog (this file), LICENSE and README files are now
  installed as part of the distribution. The destination directory can be
  customized using the `--docdir` argument to `./configure`.
  (Nicolás Ojeda Bär, report by Daniel Bünzli, review by David Allsopp,
  Sébastien Hinderer, and Daniel Bünzli)

- #10671, #10672: webman: Fix misalignments in unordered lists by changing the
  CSS for coloring bullets
  (Wiktor Kuchta, review by Florian Angeletti)

- #11107: Lifted comments in the Parsetree module into actual documentation.
  (Paul-Elliot Anglès d'Auriac, review by Florian Angeletti)

- #11120, #11133: man pages, add missing warning entries and add mnemonic names
  to the list of warnings.
  (Florian Angeletti, report by Kate Deplaix, review by Gabriel Scherer)

### Compiler user-interface and warnings:

- #10328, #10780: Give more precise error when disambiguation could not
  possibly work.
  (Leo White, review by Gabriel Scherer and Florian Angeletti)

- #10361: Improve error messages for mismatched record and variant
  definitions.
  (Florian Angeletti, review by Gabriel Radanne and Gabriel Scherer)

- #10407: Produce more detailed error messages that contain full error traces
  when module inclusion fails.
  (Antal Spector-Zabusky, review by Florian Angeletti)

- #10531: add naked_pointers to ocamlc -config exporting NAKED_POINTERS from
  Makefile.config.
  (Damien Doligez, review by Mark Shinwell and Gabriel Scherer)

- #9116, #9118, #10582: Fix single-line source highlighting in the
  presence of tabs
  (Armaël Guéneau, review by Gabriel Scherer,
   split off from #9118 by Kate Deplaix, report by Ricardo M. Correia)

- #10488: Improve type variable name generation and recursive type detection
  when printing type errors; this ensures that the names given to type variables
  are always reused in the following portion of the trace and also removes
  spurious `as 'a`s in types.
  (Antal Spector-Zabusky, review by Florian Angeletti)

- #10794: Clarify warning 57 (Ambiguous or-pattern variables under guard)
  (Wiktor Kuchta, review by Gabriel Scherer)

### Internal/compiler-libs changes:

- #1599: add unset directive to ocamltest to clear environment variables before
  running tests.
  (David Allsopp, review by Damien Doligez and Sébastien Hinderer)

- #8516: Change representation of class signatures
  (Leo White, review by Thomas Refis)

- #9444: -dtypedtree, print more explicitly extra nodes in pattern ast.
  (Frédéric Bour, review by Gabriel Scherer)

- #10337: Normalize type_expr nodes on access
  One should now use accessors such as get_desc and get_level to access fields
  of type_expr, rather than calling manually Btype.repr (which is now hidden
  in Types.Transient_expr).
  (Jacques Garrigue and Takafumi Saikawa,
   review by Florian Angeletti and Gabriel Radanne)

- #10474: Force normalization on access to row_desc
  Similar to #10337. Make row_desc an abstract types, with constructor
  create_row and accessors defined in Types rather than Btype.
  A normalized view row_desc_repr is provided for convenience.
  (Jacques Garrigue and Takafumi Saikawa,
   review by Leo White and Florian Angeletti)

- #10541: Make field_kind and commutable abstract, enforcing correct access
  (Jacques Garrigue and Takafumi Saikawa,
   review by Thomas Refis and Florian Angeletti)

- #10575: add a -dump-dir flag, which redirects all debugging printer
   (`-dprofile`, `-dlambda`, ...) to the target directory
  (Florian Angeletti, review by Thomas Refis and Gabriel Scherer)

* #10627: Make row_field abstract
  Completes #10474 by making row_field abstract too.
  An immutable view row_field_view is provided, and one converts between it
  and row_field via inj_row_field and row_field_repr.
  (Jacques Garrigue and Takafumi Saikawa, review by Florian Angeletti)

- #10433: Remove the distinction between 32-bit aligned and 64-bit aligned
  64-bit floats in Cmm.memory_chunk.
  (Greta Yorsh, review by Xavier Leroy)

- #10434: Pun labelled arguments with type constraint in function applications.
  (Greta Yorsh, review by Nicolas Chataing and Nicolás Ojeda Bär)

- #10470: Remove unused `cstr_normal` field from the `constructor_description`
  type
  (Nicolas Chataing, review by Gabriel Scherer)

- #10382: Don't repeat environment entries in Typemod.check_type_decl
  (Leo White, review by Gabriel Scherer and Florian Angeletti)

- #10472: refactor caml_sys_random_seed to ease future Multicore changes
  (Gabriel Scherer, review by Xavier Leroy)

- #10487: Move logic to get the type path from a constructor return type in
  Types
  (Nicolas Chataing, review by Jacques Garrigue)

- #10555: Do not use ghost locations for type constraints
  (Nicolás Ojeda Bär, report by Anton Bachin, review by Thomas Refis)

- #10598, #10616: fix an exponential blow-up when typechecking nested module
  types
  (Florian Angeletti, report and review by Stephen Dolan)

- #10559: Evaluate signature substitutions lazily
  (Stephen Dolan, review by Leo White)

- #8776, #10624: Fix compilation time regression introduced in 4.08
  (Nicolás Ojeda Bär, fix by Leo White, report by Alain Frisch, review by Thomas
  Refis)

- #10618: Expose more Pprintast functions
  (Guillaume Petiot, review by Gabriel Scherer)

- #10637: Outcometree: introduce a record type for constructors
  (Gabriel Scherer, review by Thomas Refis)

- #10516: refactor the compilation of the 'switch' construct
  (Gabriel Scherer, review by Wiktor Kuchta and Luc Maranget)

- #10670: avoid global C state in the RE engine for the "str" library
  (Xavier Leroy, review by Gabriel Scherer)

- #10678: Expose descriptions in Warnings module
  (Leo White, review by Gabriel Scherer and Alain Frisch)

- #10690: Always build ocamltoplevel.cmxa
  (David Allsopp, review by Gabriel Scherer)

- #10692: Expose Parse.module_type and Parse.module_expr
  (Guillaume Petiot, review by Gabriel Scherer)

- #10714: Add X86_proc.with_internal_assembler for temporarily changing the
  assembler used by the backend.
  (David Allsopp, review by Gabriel Scherer)

- #10715: Allow the assembler and loader to be substituted in ocamlnat, for
  example to be replaced with a binary emitter.
  (David Allsopp and Nathan Rebours, review by Louis Gesbert,
  Nicolás Ojeda Bär and Gabriel Scherer)

- #10718, #11012: Add "Shape" information to the cmt files. Shapes are an
  abstraction of modules that can be used by external tooling to perform
  definition-aware operations.
  (Ulysse Gérard, Thomas Refis and Leo White, review by Florian Angeletti)

- #10742: strong call-by-need reduction for shapes
  (Gabriel Scherer and Nathanaëlle Courant,
   review by Florian Angeletti, Ulysse Gérard and Thomas Refis)

### Build system:

- #10835 Disable DT_TEXTREL warnings on x86 32 bit architecture by passing
  -Wl,-z,notext in mksharedlib and mkmaindll. Fixes relocation issues, reported
  in #9800, making local patches in Debian, Alpine, and FreeBSD superfluous.
  (Hannes Mehnert with Kate Deplaix and Stéphane Glondu, review by Xavier Leroy)

- #10717: Simplify the installation of man pages
  (Sébastien Hinderer, review by David Allsopp)

- #10739: Stop installing extract_crc
  (Sébastien Hinderer, review by David Allsopp, Daniel Bünzli, Xavier Leroy
  and Gabriel Scherer)

- #10797: Compile with -d2VolatileMetadata- on supporting versions of Visual
  Studio. This suppresses the addition of .voltbl sections and eliminates
  linking errors in systhreads.
  (David Allsopp, review by Jonah Beckford and Sébastien Hinderer)

### Bug fixes:

- #9214, #10709: Wrong unmarshaling of function pointers in debugger mode.
  This was causing ocamldebug to crash when running some user-defined printers.
  (Xavier Leroy, report by Rehan Malak, review by Gabriel Scherer and
   Vincent Laviron)

- #10364: Improve detection of ambiguity in case bodies.
  (Jacques Garrigue, review by Thomas Refis)

- #10473: Add CFI directives to RISC-V runtime and asmcomp.
  This allows stacktraces to work in gdb through C and OCaml calls.
  (Edwin Török, review by Nicolás Ojeda Bär and Xavier Leroy)

- #10539: Field kinds should be kept when copying types
  Losing the sharing meant that one could desynchronize them between several
  occurrences of self, allowing a method to be both public and hidden,
  which broke type soundness.
  (Jacques Garrigue, review by Leo White)

- #10542: Fix detection of immediate64 types through unboxed types.
  (Leo White, review by Stephen Dolan and Gabriel Scherer)

- #10590: Some typechecker optimisations
  (Stephen Dolan, review by Gabriel Scherer and Leo White)

- #10633: Stack overflow recovery in ocamlopt for AMD64/Linux and ARM/Linux
  was not restoring the minor heap pointer correctly
  (Stephen Dolan, review by Xavier Leroy)

- #10659: Fix freshening substitutions on imported modules
  (Leo White and Stephen Dolan, review by Matthew Ryan)

- #10677, #10679: Fix detection of CC as gcc in configure (allow for
  triplet-prefixed GCC) and fix all C compiler detection when CC is a path
  rather than a basename.
  (David Allsopp, report by Fabian @copy, review by Gabriel Scherer)

- #10690: Add --enable-native-toplevel to configure to enable installing
  ocamlnat as part of the main build (default is not to install it)
  (David Allsopp, review by Gabriel Scherer)

- #10693: Fix ident collision in includemod
  (Leo White, review by Matthew Ryan)

- #10702: Fix cast of more strictly aligned pointer in win32unix
  implementation of stat
  (Antonin Décimo, review by David Allsopp)

- #10712: Type-check toplevel terms in the native toplevel in the same way as
  the bytecode toplevel. In particular, this fixes the loss of type variable
  names in the native toplevel.
  (Leo White, review by David Allsopp and Gabriel Scherer)

- #10735: Uncaught unify exception from `build_as_type`
  (Jacques Garrigue, report and review by Leo White)

- #10763, #10764: fix miscompilation of method delegation
  (Alain Frisch, review by Vincent Laviron and Jacques Garrigue)

- #10822, #10823: Bad interaction between ambivalent types and subtyping
  coercions (Jacques Garrigue, report and review by Frédéric Bour)

- #10836, #10952: avoid internal typechecker errors when checking signature
  inclusion in presence of incompatible types.
  (Florian Angeletti, report by Craig Ferguson, review by Gabriel Scherer)

- #10849: Display the result of `let _ : <type> = <expr>` in the native
  toplevel, as in the bytecode toplevel.
  (David Allsopp, report by Nathan Rebours, review by Gabriel Scherer)

- #10853: `Obj.reachable_words` could crash if called after a marshaling
  operation in `NO_SHARING` mode.
  (Xavier Leroy, report by Anil Madhavapeddy, review by Alain Frisch)

- #10907, #10959: Wrong type inferred from existential types
  (Jacques Garrigue and Gabriel Scherer, report by @dyzsr, review by Leo White)

- #10688: Move frame descriptor table from `rodata` to `data` section on
  RISC-V.  Improves support for building DLLs and PIEs. In particular, this
  applies to all binaries in distributions that build PIEs by default (eg
  Gentoo and Alpine).
  (Alex Fan, review by Gabriel Scherer)

- #11031: Exception handlers restore the rbp register when using frame-pointers
  on amd64.
  (Fabrice Buoro, with help from Stephen Dolan, Tom Kelly and Mark Shinwell,
  review by Xavier Leroy)

- #11025, #11036: Do not pass -no-pie to the C compiler on musl/arm64
  (omni, Kate Deplaix and Antonio Nuno Monteiro, review by Xavier Leroy)

- #11101, #11109: A recursive type constraint fails on 4.14
  (Jacques Garrigue, report and review by Florian Angeletti)

- #11118: Fix integer overflow on 64-bit Windows when indexing bigarrays (which
  could lead to a segmentation fault).
  (Roven Gabriel, review by Nicolás Ojeda Bär and Xavier Leroy)

OCaml 4.13 maintenance branch
-----------------------------

### Bug fixes

- #10661, #10662: fix a bug with classes named "row"
  (Gabriel Scherer, report by Nicolás Ojeda Bär)


OCaml 4.13.0 (24 September 2021)
--------------------------------

### Progress towards Multicore:

- #10039: Safepoints
  Add poll points to native generated code. These are effectively
  zero-sized allocations and fix some signal and remembered set
  issues. Also multicore prerequisite.
  (Sadiq Jaffer, Stephen Dolan, Damien Doligez, Xavier Leroy,
   Anmol Sahoo, Mark Shinwell, review by Damien Doligez, Xavier Leroy,
   and Mark Shinwell)

- #9876: do not cache the young_limit GC variable in a processor register.
  This affects the ARM64, PowerPC and RISC-V ports, making signal handling
  and minor GC triggers more reliable, at the cost of a small slowdown.
  (Xavier Leroy, review by Nicolás Ojeda Bär)

### Language features (highlights):

- #9584, #7074: Allow to name existentials in pattern-matching
  One can now write '(Cstr (type a) (x, y : int * a))' to give a name to
  existentials freshly introduced by GADT constructors.
  (Jacques Garrigue, review by Leo White and Gabriel Scherer)

### Compiler user-interface and warnings (highlights):

- #9331: Improve error messages for functor application and functor types.
  (Florian Angeletti and Gabriel Radanne, review by Leo White)

* #10118, #10140: enable warning 6 [labels-omitted] by default.
  The following now warns:
    let f ~x y = ... in f 3 5
  the callsite (f 3 5) has to be turned into (f ~x:3 5).
  This prevents mistakes where two arguments of the same types are swapped.
  (Note: Dune already enables this warning by default.)
  (Gabriel Scherer, review by Xavier Leroy and Florian Angeletti,
   report by ygrek)

### Manual and documentation (highlights):

- #10247: Add initial tranche of examples to reference manual.
  Adds some eighty examples to the reference manual, principally to the
  expressions and patterns sections.
  https://ocaml.org/releases/4.13/manual/patterns.html
  (John Whitington, review by Xavier Leroy, Gabriel Scherer, @Fourchaux, and
  Florian Angeletti)

- #9987, #9988, #9996, #9997: add an odoc mode for the documentation
  of the standard library and compiler library
  (Florian Angeletti, review by David Allsopp, Sébastien Hinderer,
   and Gabriel Scherer)

### Standard library (highlights):

- #944: Add some missing C99 float operations.  `Stdlib` now contains
  the inverse hyperbolic functions
    `acosh`, `asinh`, and `atanh`.
  These functions were also added to module `Stdlib.Float` together with
    `exp2`, `log2`, `cbrt`, `erf`, and `erfc`.
  Full support on MSVC requires VS2013+ but emulated versions are
  still available (for now) for older compilers.
  (Markus Mottl, review by David Allsopp, Olivier Andrieu, Florian Angeletti,
  Nicolás Ojeda Bär, Daniel Bünzli, Fabian @copy, Pascal Cuoq, Damien
  Doligez, Sébastien Hinderer, Jacques-Henri Jourdan, Xavier Leroy, Guillaume
  Melquiond, Perry E. Metzger, Runhang Li, Gabriel Scherer, Mark Shinwell,
  Bernhard Schommer and Christophe Troestler)

- #9582: Add Array.{find_opt,find_map,split,combine}.
  (Nicolás Ojeda Bär, review by Daniel Bünzli and Gabriel Scherer)

- #9533: Added String.starts_with and String.ends_with.
  (Bernhard Schommer, review by Daniel Bünzli, Gabriel Scherer and
  Alain Frisch)

### Code generation and optimizations (highlights):

- #10404: Add a generic backward dataflow analyzer and use it to speed up
  liveness analysis
  (Xavier Leroy, review by Gabriel Scherer, Greta Yorsh, Mark Shinwell)

- #10414: Avoid compilation times exponential in the nesting of loops
  in the spilling and reloading passes
  (Xavier Leroy, review by Vincent Laviron)

### Internal typechecker changes (highlights):

- #10170: Maintain more structural information in type-checking errors
  A mostly-internal change that preserves more information in errors
  during type checking; most significantly, it split the errors from
  unification, moregen, and type equality into three different types.
  (Antal Spector-Zabusky and Mekhrubon Turaev, review by Leo White,
  Florian Angeletti, and Jacques Garrigue)

- #9994: Make Types.type_expr a private type, and abstract marking mechanism
  (Jacques Garrigue and Takafumi Saikawa,
   review by Gabriel Scherer and Leo White)

### Runtime system (highlights):

- #10188, #10213: Switch the default allocation policy to best-fit and adjust
  the default overhead parameter accordingly.
  (Damien Doligez, review by Josh Berdine and Xavier Leroy)

- #10549: Stack overflow detection and naked pointers checking for ARM64
  (Xavier Leroy, review by Stephen Dolan)

- #9934: Optimise sweeping using prefetching.
  (Stephen Dolan and Will Hasenplaugh, review by David Allsopp, Xavier
   Leroy and Damien Doligez, benchmarking by Shubham Kumar and KC
   Sivaramakrishnan)

- #10194: Change compaction-triggering heuristic: use the overhead measured
  by the previous GC cycle instead of an indirect (and noisy) computation
  of the current overhead.
  (Damien Doligez, review by Stephen Dolan)

- #10449: Fix major GC work accounting (the GC was running too fast).
  (Damien Doligez, report by Stephen Dolan, review by Nicolás Ojeda Bär and
   Sadiq Jaffer)


### Language features:

- #10013: Let-punning
  Allow 'let* x in ...' and 'let%ext x in ...' as shorthand for
    'let* x = x in ...' and 'let%ext x = x in ...' respectively.
  (Stephen Dolan, review by Gabriel Scherer)

- #10133: module type substitutions
  Allow 'SIG with module type T = F(X).S', 'SIG with module type T := sig end'
  and their local equivalent `module type T := sig type u end`
  (Florian Angeletti, review by Gabriel Radanne and Leo White)

### Type system:

* #10081: Typecheck `x |> f` and `f @@ x` as `(f x)`
  (Alain Frisch, review by Jacques Garrigue, Josh Berdine and Thomas Refis)

### Runtime system:

- #10318: Windows Unicode runtime functions are no longer marked as
  experimental.
  (Nicolás Ojeda Bär, review by David Allsopp)

- #9284: Add -config option to display the configuration of ocamlrun on stdout,
  including the search path for shared stub libraries.
  (David Allsopp, review by Xavier Leroy)

- #9919: Introduce caml_record_backtraces and update Interfacing with C to
  refer to it (previous instruction to use caml_record_backtrace primitive was
  not possible without defining CAML_INTERNALS)
  (David Allsopp, review by Xavier Leroy)

- #10102: Ignore PROFINFO_WIDTH if WITH_PROFINFO is not defined (technically
  a breaking change if the configuration system was being abused before).
  (David Allsopp, review by Xavier Leroy)

- #10107: Ensure modules compiled with -afl-instrument can still link on
  platforms without AFL support.
  (David Allsopp, review by Xavier Leroy)

* #10098: Improve command-line parsing in ocamlrun: strictly recognise options,
  be more informative for `ocamlrun -I` and support `--` for terminating options
  parsing.
  (David Allsopp, review by Xavier Leroy)

- #10101: Add -help/--help option to ocamlrun.
  (David Allsopp, review by Xavier Leroy)

- #10136: Minor clean-ups in runtime/io.c and runtime/caml/io.h
  (Xavier Leroy, review by David Allsopp and Guillaume Munch-Maccagnoni)

- #10171: Tweak the naked pointers checker so that processes which trigger the
  alarm always exit with non-zero status (i.e. exit(0) becomes exit(70)).
  (David Allsopp, review by Xavier Leroy)

- #10212: Simplify and improve the Windows-specific code that connects
  to the debugger via a socket.
  (Antonin Décimo, review by Xavier Leroy)

- #10217: Fix a segfault in a corner case of compaction (reported in #9853)
  (Damien Doligez, report by Sadiq Jaffer, review by Stephen Dolan)

- #10250, #10266: Dynamically allocate alternate signal stacks to
   accommodate changes in Glibc 2.34.
  (Xavier Leroy, reports by Tomasz Kłoczko and Richard Jones, review by Anil
   Madhavapeddy, Stephen Dolan, and Florian Angeletti)

### Code generation and optimizations:

- #1400: Add an optional invariants check on Cmm, which can be activated
  with the -dcmm-invariants flag
  (Vincent Laviron, with help from Sébastien Hinderer, review by Stephen Dolan
   and David Allsopp)

- #9562, #367: Allow CSE of immutable loads across stores
  (Stephen Dolan, review by Mark Shinwell)

- #9937: improvements in ARM64 code generation (constants, sign extensions)
  (Xavier Leroy, review by Stephen Dolan)

- #10228: Better code-generation for inlined comparisons
  (Stephen Dolan, review by Alain Frisch and Xavier Leroy)

- #10244: Optimise Int32.unsigned_to_int
  (Fabian Hemmer, review by Stephen Dolan and Xavier Leroy)

- #10302, #10303: Fix incorrect instruction selection for string constant loads
  on ppc.
  (David Allsopp, review by Stephen Dolan)

- #10349: Fix destroyed_at_c_call on RISC-V
  (Mark Shinwell, review by Nicolás Ojeda Bär)

- #10419: Add %frame_pointers primitive which is true only in native code with
  frame pointers mode enabled.
  (David Allsopp, review by Vincent Laviron and Mark Shinwell)

### Standard library:

- #9448: Add String.{empty,cat} as dual of Bytes.{empty,cat},
  String.{of,to}_bytes as aliases of Bytes.{to,of}_string,
  Bytes.split_on_char as dual of String.split_on_char, and binary decoding
  functions in String to match those in Bytes.
  (David Allsopp, review by Damien Doligez, Gabriel Scherer and others)

- #9487, #9489: Add Random.full_int which allows 62-bit bounds on 64-bit
  systems.
  (David Allsopp, request by François Berenger, review by Xavier Leroy and
   Damien Doligez)

- #9961: Add Array.fold_left_map.
  (Craig Ferguson, review by Damien Doligez)

- #10097: Lazy.map, Lazy.map_val: ('a -> 'b) -> 'a Lazy.t -> 'b Lazy.t
  (map f x) is always (lazy (f (force x))), whereas (map_val f x)
  applies f directly if x is already forced.
  (Gabriel Scherer, review by Nicolás Ojeda Bär, Alain Frisch, Xavier Leroy,
   Daniel Bünzli and Stephen Dolan)

- #10242: Added convenience pretty printer for Either.t in the Format module.
  (Oghenevwogaga Ebresafe, review by Nicolás Ojeda Bär,
  Gabriel Scherer and Xavier Van de Woestyne)

- #10352: Seq.(concat : 'a t t -> 'a t)
  Seq.concat_map as an alias to Seq.flat_map,
  (Gabriel Scherer, review by Ulugbek Abdullaev and Daniel Bünzli
   and Nicolás Ojeda Bär and Florian Angeletti)

- #882: Add fold_left, fold_right, exists and for_all to String/Bytes
  (Yotam Barnoy, review by Alain Frisch and Jeremy Yallop)

- #4070, #10398: small optimization of Stdlib.{frexp,modf}.
  (Markus Mottl, Nicolás Ojeda Bär, review by Gabriel Scherer)

- #10389, #10391, #10392: Add {Int,Int32,Int64,Nativeint}.{min,max}.
  (Nicolás Ojeda Bär and Alain Frisch, review by Xavier Leroy)

- #10430: Add Format.print_bytes and Format.pp_print_bytes.
  (Gabriel Radanne, review by Gabriel Scherer and David Allsopp)

### Other libraries:

* #10084: Unix.open_process_args* functions now look up the program in the PATH.
  This was already the case under Windows, but this is now also done under
  Unix. Note that previously the program was interpreted relative to the current
  directory.
  (Nicolás Ojeda Bär, review by Gabriel Scherer and Xavier Leroy)

- #10047: Add `Unix.realpath`
  (Daniel Bünzli, review by David Allsopp, Josh Berdine and Gabriel Scherer)

- #10184: Remove expensive debug assertion from dynlink.
  (Leo White, review by David Allsopp and Xavier Leroy)

- #10185: Consider that IPv6 is always enabled on Windows.
  (Antonin Décimo, review by David Allsopp and Xavier Leroy)

- #10306: Map WSA error code to Unix errno for sockopt and getsockname
  functions (Antonin Décimo, review by David Allsopp)

- #10309: Properly return EBADF on error in Unix.descr_of_{in,out}_channel on
  Win32 and map Windows error correctly in Unix.truncate and Unix.ftruncate on
  Win32.
  (David Allsopp, review by Nicolás Ojeda Bär)

### Tools:

- #10139: Adds a -nonavbar option to ocamldoc, to remove confusing
  'Up', 'Previous' and 'Next' links
  (John Whitington, review by David Allsopp)

- #8645, #10363: ocamldoc: escape `<`, `>`, and `&` in html backend.
  (Florian Angeletti, report by Wim Lewis, review by Gabriel Scherer)

### Manual and documentation:

- #9525, #10402: document that ocamldoc only creates paragraphs
  at the toplevel of documentation comments
  (Florian Angeletti, report by Hendrik Tews, review by Gabriel Scherer)

- #10206: Split labels and polymorphic variants tutorials in two.
  Moves the GADTs tutorial from the Language Extensions chapter
  to the tutorials.
  (John Whitington, review by Florian Angeletti and Xavier Leroy)

- #9786, #10181: improved documentation of Unix.{in,out}_channel_of_descr
  with respect to closing.
  (Xavier Leroy, report by Jacques-Henri Jourdan, review by Guillaume
   Munch-Maccagnoni, Gabriel Scherer, Jacques-Henri Jourdan)

- #10139: Use the new -nonavbar option to improve navigation within
  the reference manual stdlib documentation.
  (John Whitington, review by David Allsopp)

- #1351: Document `-output-complete-obj` option in the manual.
  (François Bobot, Nicolás Ojeda Bär, review by Daniel Bünzli and Damien
  Doligez)

- #9632: Document incremental build solutions with opam
  (Vincent Laviron, review by Daniel Bünzli and Gabriel Scherer)

- #10497: Styling changes in the post-processed HTML manual (webman)
  (Wiktor Kuchta, review by Florian Angeletti)

- #10605: manual, name few css classes to ease styling and maintainability.
  (Florian Angeletti, review by Wiktor Kuchta and Gabriel Scherer)

### Compiler user-interface and warnings:

- #1737, #2092, #7852, #7859, #10405, #10417: Update locations during
  destructive substitutions
  (Thomas Refis, review by Gabriel Radanne, report by Hugo Heuzard)

- #2245: Improve error message for link order error in bytecode
  (Pierre Chambart, review by Jérémie Dimino and Gabriel Scherer)

- #8732, improved error messages for invalid private row type definitions.
  For instance, [ type t = private [< `A > `A ] ] .
  (Florian Angeletti, review by Jacques Garrigue, Thomas Refis,
   and Gabriel Scherer)

- #9407: optional warning for missing mli interface file
  (Anukriti Kumar, review by Florian Angeletti)

- #9960, #10619: extend ocamlc/ocamlopt's -o option to work when
  compiling C files
  (Sébastien Hinderer, reported by Daniel Bünzli, review by
  Florian Angeletti and Gabriel Scherer)

- #10095: minor simplifications to some syntax error messages.
  (François Pottier, review by Gabriel Scherer and Frédéric Bour.)

- #10196, #10197: better error message on empty character literals ''.
  (Gabriel Scherer, review by David Allsopp and Florian Angeletti
   and Daniel Bünzli, report by Robin Björklin)

- #8877: Call the linker when ocamlopt is invoked with .o and .a files only.
  (Greta Yorsh, review by Leo White)

- #10207, #10312: deprecate consecutive letters in warning
  specifications.
  The form `-w aBcD` was equivalent to `-w -a+b-c+d`.
  It is now deprecated to improve the coexistence with warning mnemonics.
  However, using isolated single letter is not deprecated to allow the form
  `-w "A-32..50-45"`.
  (Florian Angeletti, review by Damien Doligez and Gabriel Scherer)

- #10232: Warning for unused record fields.
  (Leo White, review by Florian Angeletti)

### Internal/compiler-libs changes:

- #9243, simplify parser rules for array indexing operations
  (Florian Angeletti, review by Damien Doligez and Gabriel Scherer)

- #9650, #9651: keep refactoring the pattern-matching compiler
  (Gabriel Scherer, review by Thomas Refis and Florian Angeletti)

- #9827: Replace references with functions arguments in Simplif
  (Anukriti Kumar, review by Vincent Laviron and David Allsopp)

- #10007: Driver.compile_common: when typing a .ml file, return the
  compilation unit signature (inferred or from the .cmi) in addition
  to the implementation and the coercion.
  (Leandro Ostera, review by Gabriel Scherer and Thomas Refis)

- #10045: Add libext variable to ocamltest and enable C# tests on on mingw
  (David Allsopp, review by Gabriel Scherer)

* #10061, #10078, #10187: remove library `ocamlopttoplevel`, remove modules
  `Opttoploop`, `Opttopstart`, which are replaced by `Toploop` and `Topstart` in
  library `ocamltoplevel`, made available in native code.
  (Louis Gesbert, review by Jeremie Dimino, Mark Shinwell and Gabriel Radanne)

- #10124: remove duplicated code from the native toplevel, split toplevel
  implementation into the shared part (`Topcommon`, etc.) and specific ones
  (`Topeval`, `Trace`, `Topmain`).
  (Louis Gesbert, review by Jeremie Dimino and Gabriel Radanne)

- #10086: add the commands `make list-parse-errors` and `make
  generate-parse-errors` to generate a set of syntactically incorrect
  sentences that covers all error states of the LR automaton. Add these
  sentences to the test suite. This can be used to evaluate the quality of the
  parser's syntax error messages and (in the future) to evaluate the impact of
  changes in the parser.
  (François Pottier, review by Gabriel Scherer and Xavier Leroy.)

- #10090: Distinguished constructors for ref variables at lambda level
  (Keryan Didier, review by Gabriel Scherer and Vincent Laviron)

- #10113: add a `-timeout` option to ocamltest and use it in the test suite.
  (Xavier Leroy and Gabriel Scherer, review by Sébastien Hinderer
   and David Allsopp)

* #10169, #10270, #10301, #10451: Use capitalized module names in the Standard
  Library prefixing scheme to match Dune, e.g. Stdlib__String instead of
  Stdlib__string. This is a breaking change only to code which attempted to use
  the internal names before. The Standard Library generated by the Dune rules is
  now equivalent to the main build (the Dune rules still do not generate a
  distributable compiler).
  (David Allsopp and Mark Shinwell, review by Gabriel Scherer)

- #10327: Add a subdirectories variable and a copy action to ocamltest
  (Sébastien Hinderer, review by David Allsopp)

* #10337: Normalize type_expr nodes on access
  One should now use accessors such as get_desc and get_level to access fields
  of type_expr, rather than calling manually Btype.repr (which is now hidden
  in Types.Transient_expr).
  (Jacques Garrigue and Takafumi Saikawa,
   review by Florian Angeletti and Gabriel Radanne)

- #10358: Use a hash table for the load path.
  (Leo White, review by Gabriel Scherer)

- #8936: Per-function environment for Emit
  (Greta Yorsh, review by Vincent Laviron and Florian Angeletti)

- #10543: Fix Ast_mapper to apply the mapping function to the constants in
  "interval" patterns `c1..c2`.
  (Guillaume Petiot, review by Gabriel Scherer and Nicolás Ojeda Bär)

### Internal typechecker changes:

- #10174: Make Tsubst more robust by avoiding strange workarounds
  (Takafumi Saikawa and Jacques Garrigue, review by Gabriel Scherer and
   Florian Angeletti)

- #10265: Move type_unboxed.unboxed into type_kind
  (Stephen Dolan, review by Gabriel Scherer)

- #10307: Refactor type_description in the typing env
  (Nicolas Chataing, review by Takafumi Saikawa, Florian Angeletti and Thomas
   Refis)

- #10311: Separate the constraint-solving part of Typecore.type_pat into
  specific solver functions.
  (Jacques Garrigue and Takafumi Saikawa, review by Gabriel Scherer)

- #10428: Make build_other_constrs work with names instead of tags.
  (Nicolas Chataing, review by Florian Angeletti)

### Build system:

- #10332, #10333: Generate lambda/runtimedef.ml correctly in Swedish locale.
  (the letter 'w' is not included in '[a-z]' in sv_SE.UTF-8)
  (David Allsopp, report by Anders Jackson, review by Florian Angeletti and
   Gabriel Scherer)

- #10289, #10406: Do not print option documentation in usage messages.
    (Pavlo Khrystenko, review by Gabriel Scherer, fix by Kate Deplaix)

- #9191, #10091, #10182: take the LDFLAGS variable into account, except on
  flexlink-using systems.
  (Gabriel Scherer, review by Sébastien Hinderer and David Allsopp,
   report by Ralph Seichter)

- #10135: Overhaul the FlexDLL bootstrap process. It's now fully integrated
  with the default build target and controlled by --with-flexdll which allows
  externally downloaded sources for FlexDLL to be specified. A separate
  non-shared version of the runtime is built, and shared artefacts are no longer
  built twice. When bootstrapping, any flexlink in PATH is now ignored and the
  Cygwin port also supports bootstrapping FlexDLL. flexlink.opt is automatically
  built and installed as part of opt.opt/world.opt.
  (David Allsopp, review by Sébastien Hinderer)

- #10156: configure script: fix sockets feature detection.
  (Lucas Pluvinage, review by David Allsopp and Damien Doligez)

- #10176, #10632: By default, call the assembler through the C compiler driver
  (Sébastien Hinderer, review by Gabriel Scherer, David Allsopp and Xavier
  Leroy)

- #10186: configure wasn't using library link flags when searching for
  network functions on systems where they're not in libc. Fix IPv6 and
  socklen_t detection on Windows.
  (Antonin Décimo, review by David Allsopp and Sébastien Hinderer)

- #10366: Make it possible to use the OCAMLRUN variable to specify
  which runtime to use while building the compilers (Sébastien Hinderer,
  review by David Allsopp)

- #10451, #10635: Replace the use of iconv with a C utility to convert $(LIBDIR)
  to a C string constant on Windows when building the runtime. Hardens the
  generation of the constant on Unix for paths with backslashes, double-quotes
  and newlines.
  (David Allsopp, review by Florian Angeletti and Sébastien Hinderer)

- #10471: Fix detection of arm32 architectures with musl in configure.
  (Louis Gesbert, review by David Allsopp)

### Bug fixes:

- #6654, #9774, #10401: make `include` and with `constraints` handle correctly
  the ghost components of signatures. For instance, in

    include struct class c = object end end type c

   the type `c` shadows the `class c` to avoid shadowing only the ghost type
   c introduced by the class.
  (Florian Angeletti, report by Eduardo Rafael, review by Gabriel Scherer)

- #6985, #10385: remove all ghost row types from included modules
  (Florian Angeletti, review by Gabriel Scherer)

- #7453, #9828, #10416: fix #show for recursive types and modules
  (Florian Angeletti, review by Gabriel Scherer)

* #7469, #10408: Sys.time now returns processor time on Windows (previously
  returned wall-clock time)
  (David Allsopp, review by Nicolás Ojeda Bär)

* #8857, #10220: Don't clobber GetLastError() in caml_leave_blocking_section
  when the systhreads library is loaded.
  (David Allsopp, report by Anton Bachin, review by Xavier Leroy)

- #8575, #10362: Surprising interaction between polymorphic variants
  and constructor disambiguation.
  (Jacques Garrigue, report and review by Thomas Refis)

- #8917, #8929, #9889, #10219: fix printing of nested recursive definitions
  in presence of a name collision.
  (Florian Angeletti, report by Thomas Refis, review by Gabriel Scherer)

- #10005: Try expanding aliases in Ctype.nondep_type_rec
  (Stephen Dolan, review by Gabriel Scherer, Leo White and Xavier Leroy)

- #10072, #10085: Check that sizes and offsets in stack frame descriptors
  do not overflow the 16-bit fields where they are stored.
  (Xavier Leroy, report by Github user pveber, review by Gabriel Scherer)

- #10087, #10138: In the toplevel REPL, don't use the cache
  of included directories, so that files created or deleted while
  the REPL is running are correctly handled.
  (Xavier Leroy, report by Github user quakerquickoats, review by
   Jeremie Dimino)

- #10294, #10295: fix an assert-failure in pattern-matching compilation
  (Gabriel Scherer, review by Thomas Refis and Luc Maranget,
   report by Nicolás Ojeda Bär)

- #10147, #10148: Fix building runtime with GCC on macOS.
  (David Allsopp, report by John Skaller)

- #10166: Fix illegal permutation error reporting in module aliases.
  (Matthew Ryan, review by Florian Angeletti)

- #10189, #10190, #10347: Universal variables leaking through GADT equations
  (Jacques Garrigue, report and review by Leo White)

- #10205: Avoid overwriting closures while initialising recursive modules
  (Stephen Dolan, review by Xavier Leroy, Hugo Heuzard and Vincent Laviron)

- #10253, #10373: tweak error message for unknown variant constructors
  or record fields in type-directed disambiguation
  (Florian Angeletti, report by Hongbo Zhang, review by Gabriel Scherer)

* #10277, #10383: Need to detect ambiguity recursively inside types to
  guarantee principality (affects only principal mode)
  (Jacques Garrigue, review by Thomas Refis, Leo White and Kate Deplaix)

- #10283, #10284: Enforce right-to-left evaluation order for Lstaticraise
  (Vincent Laviron, report by Github user Ngoguey42, review by Gabriel Scherer)

- #10298, #10305: Incorrect propagation of type equalities in functor
  application
  (Jacques Garrigue, report and review by Didier Remy)

- #10324, #10325: Prevent generation of Lsend(Cached, _) in bytecode
  (Vincent Laviron, report by Yawar Amin and Nicolás Ojeda Bär, review by
   Jacques Garrigue)

- #10338, #10340: Translcore.push_defaults does not respect scoping
  (Jacques Garrigue, report and review by Stephen Dolan)

- #10351: Fix DLL loading with binutils 2.36+ on mingw-w64
  (David Allsopp, review by Nicolás Ojeda Bär)

- #10339, #10354, #10387: Fix handling of exception-raising specific
  operations during spilling and liveness analysis.
  (This bug affects ARM and ARM64.)
  In passing, refactor Proc.op_is_pure and Mach.operation_can_raise.
  (Xavier Leroy, report by Richard Bornat, review by Stephen Dolan
   and Mark Shinwell)

- #10371: Stop generating useless `.cds` file when using
  `-output-complete-exe`.
  (Nicolás Ojeda Bär, review by David Allsopp)

- #10376: Link runtime libraries correctly on msvc64 in -output-complete-obj
  (David Allsopp, review by Gabriel Scherer)

- #10380: Correct handling of UTF-8 paths in configure on Windows
  (David Allsopp, review by Sébastien Hinderer)

- #10450, #10558: keep %apply and %revapply primitives working with abstract
  types. This breach of backward compatibility was only present in the alpha
  releases of OCaml 4.13.0 .
  (Florian Angeletti, review by Thomas Refis and Leo White)

- #10454: Check row_more in nondep_type_rec.
  (Leo White, review by Thomas Refis)

- #10468: Correctly pretty print local type substitution, e.g. type t := ...,
  with -dsource
  (Matt Else, review by Florian Angeletti)

- #10461, #10498: `caml_send*` helper functions take derived pointers
  as arguments.  Those must be declared with type Addr instead of Val.
  Moreover, poll point insertion must be disabled for `caml_send*`,
  otherwise the derived pointer is live across a poll point.
  (Vincent Laviron and Xavier Leroy, review by Xavier Leroy and Sadiq Jaffer)

- #10511: Cygwin ports now correctly configure when flexdll is not available.
  (David Allsopp, review by Florian Angeletti)

- #10550, #10551: fix pretty-print of gadt-pattern-with-type-vars
  (Chet Murthy, review by Gabriel Scherer)

- #10584, #10856: Standard Library documentation build no longer fails if
  optional libraries have been disabled.
  (David Allsopp, report by Yuri Victorovich, review by Florian Angeletti)

- #10593: Fix untyping of patterns without named existential quantifiers. This
  bug was only present in the beta version of OCaml 4.13.0.
  (Ulysse Gérard, review by Florian Angeletti)

- #10603, #10611: Fix if condition marked as inconstant in flambda
  (Vincent Laviron and Pierre Chambart, report by Marcello Seri)


OCaml 4.12, maintenance version
-------------------------------

### Bug fixes:

- #10442, #10446: Fix regression in the toplevel to #directory caused by
  corrections and improvements to the Load_path in #9611. #directory now
  adds the path to the start of the load path again (so files in the newly
  added directory take priority).
  (David Allsopp, report by Vasile Rotaru, review by Florian Angeletti
   and Nicolás Ojeda Bär)

- #10478: Fix segfault under Windows due to a mistaken initialization of thread
  ID when a thread starts.
  (David Allsopp, Nicolás Ojeda Bär, review by Xavier Leroy)

- #10626, #10628: Wrong reloading of the x86-64 instruction for
  integer multiplication by a constant, causing the assembler to
  reject the ocamlopt-generated code.
  (Xavier Leroy, report by Dave Aitken, review by Vincent Laviron)

OCaml 4.12.0 (24 February 2021)
-------------------------------

### Supported platforms (highlights):

- #9699: add support for iOS and macOS on ARM 64 bits
  (Eduardo Rafael, review by Xavier Leroy, Nicolás Ojeda Bär
   and Anil Madhavapeddy, additional testing by Michael Schmidt)

### Standard library (highlights):

- #9797: Add Sys.mkdir and Sys.rmdir.
  (David Allsopp, review by Nicolás Ojeda Bär, Sébastien Hinderer and
   Xavier Leroy)

* #9765: add init functions to Bigarray.
  (Jeremy Yallop, review by Gabriel Scherer, Nicolás Ojeda Bär, and
   Xavier Leroy)

* #9668: List.equal, List.compare
  (This could break code using "open List" by shadowing
   Stdlib.{equal,compare}.)
  (Gabriel Scherer, review by Nicolás Ojeda Bär, Daniel Bünzli and Alain Frisch)

- #9066: a new Either module with
  type 'a Either.t = Left of 'a | Right of 'b
  (Gabriel Scherer, review by Daniel Bünzli, Thomas Refis, Jeremy Yallop)

- #9066: List.partition_map :
    ('a -> ('b, 'c) Either.t) -> 'a list -> 'b list * 'c list
  (Gabriel Scherer, review by Jeremy Yallop)

- #9865: add Format.pp_print_seq
  (Raphaël Proust, review by Nicolás Ojeda Bär)

### Compiler user-interface and warnings (highlights):

- #9657: Warnings can now be referred to by their mnemonic name. The names are
  displayed using `-warn-help` and can be utilized anywhere where a warning list
  specification is expected.
      ocamlc -w +fragile-match
      ...[@@ocaml.warning "-fragile-match"]
  Note that only a single warning name at a time is supported for now:
  "-w +foo-bar" does not work, you must use "-w +foo -w -bar".
  (Nicolás Ojeda Bär, review by Gabriel Scherer, Florian Angeletti and
   Leo White)

- #8939: Command-line option to save Linear IR before emit.
  (Greta Yorsh, review by Mark Shinwell, Sébastien Hinderer and Frédéric Bour)

- #9003: Start compilation from Emit when the input file is in Linear IR format.
  (Greta Yorsh, review by Jérémie Dimino, Gabriel Scherer and Frédéric Bour)

### Language features (highlights):

* #9500, #9727, #9866, #9870, #9873: Injectivity annotations
  One can now mark type parameters as injective, which is useful for
  abstract types:
    module Vec : sig type !'a t end = struct type 'a t = 'a array end
  On non-abstract types, this can be used to check the injectivity of
  parameters. Since all parameters of record and sum types are by definition
  injective, this only makes sense for type abbreviations:
    type !'a t = 'a list
  Note that this change required making the regularity check stricter.
  (Jacques Garrigue, review by Jeremy Yallop and Leo White)

### Runtime system (highlights):

- #9534, #9947: Introduce a naked pointers checker mode to the runtime
  (configure option --enable-naked-pointers-checker).  Alarms are printed
  when the garbage collector finds out-of-heap pointers that could
  cause a crash in no-naked-pointers mode.
  (Enguerrand Decorne, KC Sivaramakrishnan, Xavier Leroy, Stephen Dolan,
  David Allsopp, Nicolás Ojeda Bär review by Xavier Leroy, Nicolás Ojeda Bär)

* #1128, #7503, #9036, #9722, #10069: EINTR-based signal handling.
  When a signal arrives, avoid running its OCaml handler in the middle
  of a blocking section. Instead, allow control to return quickly to
  a polling point where the signal handler can safely run, ensuring that
  I/O locks are not held while it runs. A polling point was removed from
  caml_leave_blocking_section, and one added to caml_raise.
  (Stephen Dolan, review by Goswin von Brederlow, Xavier Leroy, Damien
   Doligez, Anil Madhavapeddy, Guillaume Munch-Maccagnoni
   and Jacques-Henri Jourdan)

* #5154, #9569, #9734: Add `Val_none`, `Some_val`, `Is_none`, `Is_some`,
  `caml_alloc_some`, and `Tag_some`. As these macros are sometimes defined by
  authors of C bindings, this change may cause warnings/errors in case of
  redefinition.
  (Nicolás Ojeda Bär, review by Stephen Dolan, Gabriel Scherer, Mark Shinwell,
  and Xavier Leroy)

* #9674: Memprof: guarantee that an allocation callback is always run
  in the same thread the allocation takes place
  (Jacques-Henri Jourdan, review by Stephen Dolan)

- #10025: Track custom blocks (e.g. Bigarray) with Memprof
  (Stephen Dolan, review by Leo White, Gabriel Scherer and Jacques-Henri
   Jourdan)

- #9619: Change representation of function closures so that code pointers
  can be easily distinguished from environment variables
  (Xavier Leroy, review by Mark Shinwell and Damien Doligez)

- #9654: More efficient management of code fragments.
  (Xavier Leroy, review by Jacques-Henri Jourdan, Damien Doligez, and
  Stephen Dolan)

### Other libraries (highlights):

- #9573: reimplement Unix.create_process and related functions without
  Unix.fork, for better efficiency and compatibility with threads.
  (Xavier Leroy, review by Gabriel Scherer and Anil Madhavapeddy)

- #9575: Add Unix.is_inet6_addr
  (Nicolás Ojeda Bär, review by Xavier Leroy)

- #9930: new module Semaphore in the thread library, implementing
  counting semaphores and binary semaphores
  (Xavier Leroy, review by Daniel Bünzli and Damien Doligez,
   additional suggestions by Stephen Dolan and Craig Ferguson)

* #9206, #9419: update documentation of the threads library;
  deprecate Thread.kill, Thread.wait_read, Thread.wait_write,
  and the whole ThreadUnix module.
  (Xavier Leroy, review by Florian Angeletti, Guillaume Munch-Maccagnoni,
   and Gabriel Scherer)

### Manual and documentation (highlights):

- #9755: Manual: post-processing the html generated by ocamldoc and
   hevea. Improvements on design and navigation, including a mobile
   version, and a quick-search functionality for the API.
   (San Vũ Ngọc, review by David Allsopp and Florian Angeletti)

- #9468: HACKING.adoc: using dune to get merlin support
  (Thomas Refis, review by Gabriel Scherer)

- #9684: document in address_class.h the runtime value model in
  naked-pointers and no-naked-pointers mode
  (Xavier Leroy and Gabriel Scherer)

### Internal/compiler-libs changes (highlights):

- #9464, #9493, #9520, #9563, #9599, #9608, #9647: refactor
  the pattern-matching compiler
  (Thomas Refis and Gabriel Scherer, review by Florian Angeletti)

- #9696: ocamltest now shows its log when a test fails. In addition, the log
  contains the output of executed programs.
  (Nicolás Ojeda Bär, review by David Allsopp, Sébastien Hinderer and Gabriel
  Scherer)

### Build system (highlights):

- #9824, #9837: Honour the CFLAGS and CPPFLAGS variables.
  (Sébastien Hinderer, review by David Allsopp)

- #10063: (Re-)enable building on illumos (SmartOS, OmniOS, ...) and
  Oracle Solaris; x86_64/GCC and 64-bit SPARC/Sun PRO C compilers.
  (partially revert #2024).
  (Tõivo Leedjärv and Konstantin Romanov,
   review by Gabriel Scherer, Sébastien Hinderer and Xavier Leroy)


### Language features:

- #1655: pattern aliases do not ignore type constraints
  (Thomas Refis, review by Jacques Garrigue and Gabriel Scherer)

- #9429: Add unary operators containing `#` to the parser for use in ppx
  rewriters
  (Leo White, review by Damien Doligez)

### Runtime system:

* #9697: Remove the Is_in_code_area macro and the registration of DLL code
  areas in the page table, subsumed by the new code fragment management API
  (Xavier Leroy, review by Jacques-Henri Jourdan)

- #9756: garbage collector colors change
  removes the gray color from the major gc
  (Sadiq Jaffer and Stephen Dolan reviewed by Xavier Leroy,
  KC Sivaramakrishnan, Damien Doligez and Jacques-Henri Jourdan)

* #9513: Selectively initialise blocks in `Obj.new_block`. Reject `Custom_tag`
  objects and zero-length `String_tag` objects.
  (KC Sivaramakrishnan, review by David Allsopp, Xavier Leroy, Mark Shinwell
  and Leo White)

- #9564: Add a macro to construct out-of-heap block header.
  (KC Sivaramakrishnan, review by Stephen Dolan, Gabriel Scherer,
   and Xavier Leroy)

- #9951: Ensure that the mark stack push optimisation handles naked pointers
  (KC Sivaramakrishnan, reported by Enguerrand Decorne, review by Gabriel
   Scherer, and Xavier Leroy)

- #9678: Reimplement `Obj.reachable_words` using a hash table to
  detect sharing, instead of temporary in-place modifications.  This
  is a prerequisite for Multicore OCaml.
  (Xavier Leroy, review by Jacques-Henri Jourdan and Sébastien Hinderer)

- #1795, #9543: modernize signal handling on Linux i386, PowerPC, and s390x,
  adding support for Musl ppc64le along the way.
  (Xavier Leroy and Anil Madhavapeddy, review by Stephen Dolan)

- #9648, #9689: Update the generic hash function to take advantage
  of the new representation for function closures
  (Xavier Leroy, review by Stephen Dolan)

- #9649: Update the marshaler (output_value) to take advantage
  of the new representation for function closures
  (Xavier Leroy, review by Damien Doligez)

- #10050: update {PUSH,}OFFSETCLOSURE* bytecode instructions to match new
  representation for closures
  (Nathanaëlle Courant, review by Xavier Leroy)

- #9728: Take advantage of the new closure representation to simplify the
  compaction algorithm and remove its dependence on the page table
  (Damien Doligez, review by Jacques-Henri Jourdan and Xavier Leroy)

- #2195: Improve error message in bytecode stack trace printing and load
  debug information during bytecode startup if OCAMLRUNPARAM=b=2.
  (David Allsopp, review by Gabriel Scherer and Xavier Leroy)

- #9466: Memprof: optimize random samples generation.
  (Jacques-Henri Jourdan, review by Xavier Leroy and Stephen Dolan)

- #9628: Memprof: disable sampling when memprof is suspended.
  (Jacques-Henri Jourdan, review by Gabriel Scherer and Stephen Dolan)

- #10056: Memprof: ensure young_trigger is within the bounds of the minor
  heap in caml_memprof_renew_minor_sample (regression from #8684)
  (David Allsopp, review by Guillaume Munch-Maccagnoni and
  Jacques-Henri Jourdan)

- #9506: Remove support for FreeBSD prior to 4.0R, that required explicit
  floating-point initialization to behave like IEEE standard
  (Hannes Mehnert, review by David Allsopp)

- #8807, #9503: Use different symbols for do_local_roots on bytecode and native
  (Stephen Dolan, review by David Allsopp and Xavier Leroy)

- #9670: Report full major collections in Gc stats.
  (Leo White, review by Gabriel Scherer)

- #9675: Remove the caml_static_{alloc,free,resize} primitives, now unused.
  (Xavier Leroy, review by Gabriel Scherer)

- #9710: Drop "support" for an hypothetical JIT for OCaml bytecode
   which has never existed.
  (Jacques-Henri Jourdan, review by Xavier Leroy)

- #9742, #9989: Ephemerons are now compatible with infix pointers occurring
   when using mutually recursive functions.
   (Jacques-Henri Jourdan, review by François Bobot)

- #9888, #9890: Fixes a bug in the `riscv` backend where register t0 was not
  saved/restored when performing a GC. This could potentially lead to a
  segfault.
  (Nicolás Ojeda Bär, report by Xavier Leroy, review by Xavier Leroy)

- #9907: Fix native toplevel on native Windows.
  (David Allsopp, review by Florian Angeletti)

- #9909: Remove caml_code_area_start and caml_code_area_end globals (no longer
  needed as the pagetable heads towards retirement).
  (David Allsopp, review by Xavier Leroy)

- #9949: Clarify documentation of GC message 0x1 and make sure it is
  displayed every time a major cycle is forcibly finished.
  (Damien Doligez, review by Xavier Leroy)

- #10062: set ARCH_INT64_PRINTF_FORMAT correctly for both modes of mingw-w64
  (David Allsopp, review by Xavier Leroy)

### Code generation and optimizations:

- #9551: ocamlc no longer loads DLLs at link time to check that
  external functions referenced from OCaml code are defined.
  Instead, .so/.dll files are parsed directly by pure OCaml code.
  (Nicolás Ojeda Bär, review by Daniel Bünzli, Gabriel Scherer,
   Anil Madhavapeddy, and Xavier Leroy)

- #9620: Limit the number of parameters for an uncurried or untupled
   function.  Functions with more parameters than that are left
   partially curried or tupled.
   (Xavier Leroy, review by Mark Shinwell)

- #9752: Revised handling of calling conventions for external C functions.
   Provide a more precise description of the types of unboxed arguments,
   so that the ARM64 iOS/macOS calling conventions can be honored.
   (Xavier Leroy, review by Mark Shinwell and Eduardo Rafael)

- #9838: Ensure that Cmm immediates are generated as Cconst_int where
  possible, improving instruction selection.
  (Stephen Dolan, review by Leo White and Xavier Leroy)

- #9864: Revised recognition of immediate arguments to integer operations.
  Fixes several issues that could have led to producing assembly code
  that is rejected by the assembler.
  (Xavier Leroy, review by Stephen Dolan)

- #9969, #9981: Added mergeable flag to ELF sections containing mergeable
  constants.  Fixes compatibility with the integrated assembler in clang 11.0.0.
  (Jacob Young, review by Nicolás Ojeda Bär)

### Standard library:

- #9781: add injectivity annotations to parameterized abstract types
  (Jeremy Yallop, review by Nicolás Ojeda Bär)

* #9554: add primitive __FUNCTION__ that returns the name of the current method
  or function, including any enclosing module or class.
  (Nicolás Ojeda Bär, Stephen Dolan, review by Stephen Dolan)

- #9075: define to_rev_seq in Set and Map modules.
  (Sébastien Briais, review by Gabriel Scherer and Nicolás Ojeda Bär)

- #9561: Unbox Unix.gettimeofday and Unix.time
  (Stephen Dolan, review by David Allsopp)

- #9570: Provide an Atomic module with a trivial purely-sequential
  implementation, to help write code that is compatible with Multicore
  OCaml.
  (Gabriel Scherer, review by Xavier Leroy)

- #10035: Make sure that flambda respects atomicity in the Atomic module.
  (Guillaume Munch-Maccagnoni, review by Gabriel Scherer)

- #9571: Make at_exit and Printexc.register_printer thread-safe.
  (Guillaume Munch-Maccagnoni, review by Gabriel Scherer and Xavier Leroy)

- #9587: Arg: new Rest_all spec to get all rest arguments in a list
  (this is similar to Rest, but makes it possible to detect when there
   are no arguments (an empty list) after the rest marker)
  (Gabriel Scherer, review by Nicolás Ojeda Bär and David Allsopp)

- #9655: Obj: introduce type raw_data and functions raw_field, set_raw_field
   to manipulate out-of-heap pointers in no-naked-pointer mode,
   and more generally all other data that is not a well-formed OCaml value
   (Xavier Leroy, review by Damien Doligez and Gabriel Scherer)

- #9663: Extend Printexc API for raw backtrace entries.
  (Stephen Dolan, review by Nicolás Ojeda Bär and Gabriel Scherer)

- #9763: Add function Hashtbl.rebuild to convert from old hash table
  formats (that may have been saved to persistent storage) to the
  current hash table format.  Remove leftover support for the hash
  table format and generic hash function that were in use before OCaml 4.00.
  (Xavier Leroy, review by Nicolás Ojeda Bär)

- #10070: Fix Float.Array.blit when source and destination arrays coincide.
  (Nicolás Ojeda Bär, review by Alain Frisch and Xavier Leroy)

### Other libraries:

- #8796: On Windows, make Unix.utimes use FILE_FLAG_BACKUP_SEMANTICS flag
  to allow it to work with directories.
  (Daniil Baturin, review by Damien Doligez)

- #9593: Use new flag for non-elevated symbolic links and test for Developer
  Mode on Windows
  (Manuel Hornung, review by David Allsopp and Nicolás Ojeda Bär)

* #9601: Return EPERM for EUNKNOWN -1314 in win32unix (principally affects
  error handling when Unix.symlink is unavailable)
  (David Allsopp, review by Xavier Leroy)

- #9338, #9790: Dynlink: make sure *_units () functions report accurate
  information before the first load.
  (Daniel Bünzli, review by Xavier Leroy and Nicolás Ojeda Bär)

* #9757, #9846, #10161: check proper ownership when operating over mutexes.
  Now, unlocking a mutex held by another thread or not locked at all
  reliably raises a Sys_error exception.  Before, it was undefined
  behavior, but the documentation did not say so.
  Likewise, locking a mutex already locked by the current thread
  reliably raises a Sys_error exception.  Before, it could
  deadlock or succeed (and do recursive locking), depending on the OS.
  (Xavier Leroy, report by Guillaume Munch-Maccagnoni, review by
  Guillaume Munch-Maccagnoni, David Allsopp, and Stephen Dolan)

- #9802: Ensure signals are handled before Unix.kill returns
  (Stephen Dolan, review by Jacques-Henri Jourdan)

- #9869, #10073: Add Unix.SO_REUSEPORT
  (Yishuai Li, review by Xavier Leroy, amended by David Allsopp)

- #9906, #9914: Add Unix._exit as a way to exit the process immediately,
  skipping any finalization action
  (Ivan Gotovchits and Xavier Leroy, review by Sébastien Hinderer and
   David Allsopp)

- #9958: Raise exception in case of error in Unix.setsid.
  (Nicolás Ojeda Bär, review by Stephen Dolan)

- #9971, #9973: Make sure the process can terminate when the last thread
  calls Thread.exit.
  (Xavier Leroy, report by Jacques-Henri Jourdan, review by David Allsopp
  and Jacques-Henri Jourdan).

### Tools:

- #9551: ocamlobjinfo is now able to display information on .cmxs shared
  libraries natively; it no longer requires libbfd to do so
  (Nicolás Ojeda Bär, review by Daniel Bünzli, Gabriel Scherer,
   Anil Madhavapeddy, and Xavier Leroy)

* #9299, #9795: ocamldep: do not process files during cli parsing. Fixes
  various broken cli behaviours.
  (Daniel Bünzli, review by Nicolás Ojeda Bär)

### Debugging and profiling:

- #9606, #9635, #9637: fix 4.10 performance regression in the debugger
  (behaviors quadratic in the size of the debugged program)
  (Xavier Leroy, report by Jacques Garrigue and Virgile Prevosto,
  review by David Allsopp and Jacques-Henri Jourdan)

- #9948: Remove Spacetime.
  (Nicolás Ojeda Bär, review by Stephen Dolan and Xavier Leroy)

### Manual and documentation:

- #10142, #10154: improved rendering and latex code for toplevel code examples.
  (Florian Angeletti, report by John Whitington, review by Gabriel Scherer)

- #9745: Manual: Standard Library labeled and unlabeled documentation unified
  (John Whitington, review by Nicolás Ojeda Bär, David Allsopp,
   Thomas Refis, and Florian Angeletti)

- #9877: manual, warn that multi-index indexing operators should be defined in
  conjunction of single-index ones.
  (Florian Angeletti, review by Hezekiah M. Carty, Gabriel Scherer,
   and Marcello Seri)

- #10233: Document `-save-ir-after scheduling` and update `-stop-after` options.
  (Greta Yorsh, review by Gabriel Scherer and Florian Angeletti)

### Compiler user-interface and warnings:

- #1931: rely on levels to enforce principality in patterns
  (Thomas Refis and Leo White, review by Jacques Garrigue)

* #9011: Do not create .a/.lib files when creating a .cmxa with no modules.
  macOS ar doesn't support creating empty .a files (#1094) and MSVC doesn't
  permit .lib files to contain no objects. When linking with a .cmxa containing
  no modules, it is now not an error for there to be no .a/.lib file.
  (David Allsopp, review by Xavier Leroy)

- #9560: Report partial application warnings on type errors in applications.
  (Stephen Dolan, report and testcase by whitequark, review by Gabriel Scherer
   and Thomas Refis)

- #9583: when bytecode linking fails due to an unavailable module, the module
  that requires it is now included in the error message.
  (Nicolás Ojeda Bär, review by Vincent Laviron)

- #9615: Attach package type attributes to core_type.
  When parsing constraints on a first class module, attributes found after the
  module type were parsed but ignored. Now they are attached to the
  corresponding core_type.
  (Etienne Millon, review by Thomas Refis)

- #6633, #9673: Add hint when a module is used instead of a module type or
  when a module type is used instead of a module or when a class type is used
  instead of a class.
  (Xavier Van de Woestyne, report by whitequark, review by Florian Angeletti
  and Gabriel Scherer)

- #9754: allow [@tailcall true] (equivalent to [@tailcall]) and
  [@tailcall false] (warns if on a tailcall)
  (Gabriel Scherer, review by Nicolás Ojeda Bär)

- #9751: Add warning 68. Pattern-matching depending on mutable state
  prevents the remaining arguments from being uncurried.
  (Hugo Heuzard, review by Leo White)

- #9783: Widen warning 16 (Unerasable optional argument) to more cases.
  (Leo White, review by Florian Angeletti)

- #10008: Improve error message for aliases to the current compilation unit.
  (Leo White, review by Gabriel Scherer)

- #10046: Link all DLLs with -static-libgcc on mingw32 to prevent dependency
  on libgcc_s_sjlj-1.dll with mingw-w64 runtime 8.0.0 (previously this was
  only needed for dllunix.dll).
  (David Allsopp, report by Andreas Hauptmann, review by Xavier Leroy)

- #9634: Allow initial and repeated commas in `OCAMLRUNPARAM`.
  (Nicolás Ojeda Bär, review by Gabriel Scherer)

### Internal/compiler-libs changes:

- #8987: Make some locations more accurate
  (Thomas Refis, review by Gabriel Scherer)

- #9216: add Lambda.duplicate which refreshes bound identifiers
  (Gabriel Scherer, review by Pierre Chambart and Vincent Laviron)

- #9376: Remove spurious Ptop_defs from #use
  (Leo White, review by Damien Doligez)

- #9604: refactoring of the ocamltest codebase.
  (Nicolás Ojeda Bär, review by Gabriel Scherer and Sébastien Hinderer)

- #9498, #9511: make the pattern-matching analyzer more robust to
  or-pattern explosion, by stopping after the first counter-example to
  exhaustivity
  (Gabriel Scherer, review by Luc Maranget, Thomas Refis and Florian Angeletti,
   report by Alex Fedoseev through Hongbo Zhang)

- #9514: optimize pattern-matching exhaustivity analysis in the single-row case
  (Gabriel Scherer, review by Stephen Dolan)

- #9442: refactor the implementation of the [@tailcall] attribute
  to allow for a structured attribute payload
  (Gabriel Scherer, review by Vladimir Keleshev and Nicolás Ojeda Bär)

- #9688: Expose the main entrypoint in compilerlibs
  (Stephen Dolan, review by Nicolás Ojeda Bär, Greta Yorsh and David Allsopp)

- #9715: recheck scope escapes after normalising paths
  (Matthew Ryan, review by Gabriel Scherer and Thomas Refis)

- #9778: Fix printing for bindings where polymorphic type annotations and
  attributes are present.
  (Matthew Ryan, review by Nicolás Ojeda Bär)

- #9797, #9849: Eliminate the routine use of external commands in ocamltest.
  ocamltest no longer calls the mkdir, rm and ln external commands (at present,
  the only external command ocamltest uses is diff).
  (David Allsopp, review by Nicolás Ojeda Bär, Sébastien Hinderer and
   Xavier Leroy)

- #9801: Don't ignore EOL-at-EOF differences in ocamltest.
  (David Allsopp, review by Damien Doligez, much input and thought from
   Daniel Bünzli, Damien Doligez, Sébastien Hinderer, and Xavier Leroy)

- #9889: more caching when printing types with -short-path.
  (Florian Angeletti, review by Gabriel Scherer)

-  #9591: fix pprint of polyvariants that start with a core_type, closed,
   not low (Chet Murthy, review by Florian Angeletti)

-  #9590: fix pprint of extension constructors (and exceptions) that rebind
   (Chet Murthy, review by Florian Angeletti)

- #9963: Centralized tracking of frontend's global state
  (Frédéric Bour and Thomas Refis, review by Gabriel Scherer)

- #9631: Named text sections for caml_system__code_begin/end symbols
  (Greta Yorsh, review by Frédéric Bour)

- #9896: Share the strings representing scopes, fixing some regression
  on .cmo/.cma sizes
  (Alain Frisch and Xavier Clerc, review by Gabriel Scherer)

### Build system:

- #9332, #9518, #9529: Cease storing C dependencies in the codebase. C
  dependencies are generated on-the-fly in development mode. For incremental
  compilation, the MSVC ports require GCC to be present.
  (David Allsopp, review by Sébastien Hinderer, YAML-fu by Stephen Dolan)

- #7121, #9558: Always have the autoconf-discovered ld in PACKLD, with
  extra flags in new variable PACKLD_FLAGS. For
  cross-compilation, this means the triplet-prefixed version will always be
  used.
  (David Allsopp, report by Adrian Nader, review by Sébastien Hinderer)

- #9527: stop including configuration when running 'clean' rules
  to avoid C dependency recomputation.
  (Gabriel Scherer, review by David Allsopp)

- #9804: Build C stubs of libraries in otherlibs/ with debug info.
  (Stephen Dolan, review by Sébastien Hinderer and David Allsopp)

- #9938, #9939: Define __USE_MINGW_ANSI_STDIO=0 for the mingw-w64 ports to
  prevent their C99-compliant snprintf conflicting with ours.
  (David Allsopp, report by Michael Soegtrop, review by Xavier Leroy)

- #9895, #9523: Avoid conflict with C++20 by not installing VERSION to the OCaml
  Standard Library directory.
  (Bernhard Schommer, review by David Allsopp)

- #10044: Always report the detected ARCH, MODEL and SYSTEM, even for bytecode-
  only builds (fixes a "configuration regression" from 4.08 for the Windows
  builds)
  (David Allsopp, review by Xavier Leroy)

- #10071: Fix bug in tests/misc/weaklifetime.ml that was reported in #10055
  (Damien Doligez and Gabriel Scherer, report by David Allsopp)

### Bug fixes:

- #7538, #9669: Check for misplaced attributes on module aliases
  (Leo White, report by Thomas Leonard, review by Florian Angeletti)

- #7813, #9955: make sure the major GC cycle doesn't get stuck in Idle state
  (Damien Doligez, report by Anders Fugmann, review by Jacques-Henri Jourdan)

- #7902, #9556: Type-checker infers recursive type, even though -rectypes is
  off.
  (Jacques Garrigue, report by François Pottier, review by Leo White)

- #8746: Hashtbl: Restore ongoing traversal status after filter_map_inplace
  (Mehdi Bouaziz, review by Alain Frisch)

- #8747, #9709: incorrect principality warning on functional updates of records
  (Jacques Garrigue, report and review by Thomas Refis)

* #8907, #9878: `Typemod.normalize_signature` uses wrong environment
  (Jacques Garrigue, report and review by Leo White)

- #9421, #9427: fix printing of (::) in ocamldoc
  (Florian Angeletti, report by Yawar Amin, review by Damien Doligez)

- #9440: for a type extension constructor with parameterised arguments,
  REPL displayed <poly> for each as opposed to the concrete values used.
  (Christian Quinn, review by Gabriel Scherer)

- #9433: Fix package constraints for module aliases
  (Leo White, review by Jacques Garrigue)

- #9469: Better backtraces for lazy values
  (Leo White, review by Nicolás Ojeda Bär)

- #9521, #9522: correctly fail when comparing functions
  with Closure and Infix tags.
  (Gabriel Scherer and Jeremy Yallop and Xavier Leroy,
   report by Twitter user @st_toHKR through Jun Furuse)

- #9611: maintain order of load path entries in various situations: when passing
  them to system linker, ppx contexts, etc.
  (Nicolás Ojeda Bär, review by Jérémie Dimino and Gabriel Scherer)

- #9633: ocamltest: fix a bug when certain variables set in test scripts would
  be ignored (eg `ocamlrunparam`).
  (Nicolás Ojeda Bär, review by Sébastien Hinderer)

- #9681, #9690, #9693: small runtime changes
  for the new closure representation (#9619)
  (Xavier Leroy, Sadiq Jaffer, Gabriel Scherer,
   review by Xavier Leroy and Jacques-Henri Jourdan)

- #9739, #9747: Avoid calling type variables, types that are not variables in
  recursive occurrence error messages
  (for instance, "Type variable int occurs inside int list")
  (Florian Angeletti, report by Stephen Dolan, review by Armaël Guéneau)

- #9759, #9767: Spurious GADT ambiguity without -principal
  (Jacques Garrigue, report by Thomas Refis,
   review by Thomas Refis and Gabriel Scherer)

- #9799, #9803: make pat_env point to the correct environment
  (Thomas Refis, report by Alex Fedoseev, review by Gabriel Scherer)

- #9825, #9830: the C global variable caml_fl_merge and the C function
  caml_spacetime_my_profinfo (bytecode version) were declared and
  defined with different types.  This is undefined behavior and
  cancause link-time errors with link-time optimization (LTO).
  (Xavier Leroy, report by Richard Jones, review by Nicolás Ojeda Bär)

- #9753: fix build for Android
  (Eduardo Rafael, review by Xavier Leroy)

- #9848, #9855: Fix double free of bytecode in toplevel
  (Stephen Dolan, report by Sampsa Kiiskinen, review by Gabriel Scherer)

- #9858, #9861: Compiler fails with Ctype.Nondep_cannot_erase exception
  (Thomas Refis, report by Philippe Veber, review by Florian Angeletti)

- #9860: wrong range constraint for subtract immediate on zSystems / s390x
  (Xavier Leroy, review by Stephen Dolan)

- #9868, #9872, #9892: bugs in {in,out}_channel_length and seek_in
  for files opened in text mode under Windows
  (Xavier Leroy, report by Alain Frisch, review by Nicolás Ojeda Bär
  and Alain Frisch)

- #9925: Correct passing -fdebug-prefix-map to flexlink on Cygwin by prefixing
  it with -link.
  (David Allsopp, review by Xavier Leroy)

- #9927: Restore Cygwin64 support.
  (David Allsopp, review by Xavier Leroy)

- #9940: Fix unboxing of allocated constants from other compilation units
  (Vincent Laviron, report by Stephen Dolan, review by Xavier Leroy and
  Stephen Dolan)

- #9991: Fix reproducibility for `-no-alias-deps`
  (Leo White, review by Gabriel Scherer and Florian Angeletti)

- #9998: Use Sys.opaque_identity in CamlinternalLazy.force
  This removes extra warning 59 messages when compiling afl-instrumented
  code with flambda -O3.
  (Vincent Laviron, report by Louis Gesbert, review by Gabriel Scherer and
   Pierre Chambart)

- #9999: fix -dsource printing of the pattern (`A as x | (`B as x)).
  (Gabriel Scherer, report by Anton Bachin, review by Florian Angeletti)

- #9970, #10010: fix the declaration scope of extensible-datatype constructors.
  A regression that dates back to 4.08 makes extensible-datatype constructors
  with inline records very fragile, for example:
    type 'a t += X of {x : 'a}
  (Gabriel Scherer, review by Thomas Refis and Leo White,
   report by Nicolás Ojeda Bär)

- #10048: Fix bug with generalized local opens.
  (Leo White, review by Thomas Refis)

- #10106, #10112: some expected-type explanations where forgotten
  after some let-bindings
  (Gabriel Scherer, review by Thomas Refis and Florian Angeletti,
   report by Daniil Baturin)

OCaml 4.11 maintenance branch
-----------------------------

### Bug fixes:

- #9096, #10096: fix a 4.11.0 performance regression in classes/objects
  declared within a function
  (Gabriel Scherer, review by Leo White, report by Sacha Ayoun)

OCaml 4.11.1 (31 August 2020)
-----------------------------

### Bug fixes:

- #9856, #9857: Prevent polymorphic type annotations from generalizing
  weak polymorphic variables.
  (Leo White, review by Jacques Garrigue)

- #9859, #9862: Remove an erroneous assertion when inferred function types
  appear in the right hand side of an explicit :> coercion
  (Florian Angeletti, review by Thomas Refis)

OCaml 4.11.0 (19 August 2020)
-----------------------------

(Changes that can break existing programs are marked with a "*")

### Runtime system:

- #9096: Print function names in backtraces.
  Old output:
  > Called from file "foo.ml", line 16, characters 42-53
  New output:
  > Called from Foo.bar in file "foo.ml", line 16, characters 42-53
  (Stephen Dolan, review by Leo White and Mark Shinwell)

- #9082: The instrumented runtime now records logs in the CTF format.
  A new API is available in the runtime to collect runtime statistics,
  replacing the previous instrumented runtime macros.
  Gc.eventlog_pause and Gc.eventlog_resume were added to allow user to control
  instrumentation in a running program.
  See the manual for more information on how to use this instrumentation mode.
  (Enguerrand Decorne and Stephen Dolan, with help and review from
  David Allsopp, Sébastien Hinderer, review by Anil Madhavapeddy,
  Nicolás Ojeda Bär, Shakthi Kannan, KC Sivaramakrishnan, Gabriel Scherer,
  Guillaume Munch-Maccagnoni, Damien Doligez, Leo White, Daniel Bünzli
  and Xavier Leroy)

- #9230, #9362: Memprof support for native allocations.
  (Jacques-Henri Jourdan and Stephen Dolan, review by Gabriel Scherer)

- #8920, #9238, #9239, #9254, #9458: New API for statistical memory profiling
  in Memprof.Gc. The new version does no longer use ephemerons and allows
  registering callbacks for promotion and deallocation of memory
  blocks.
  The new API no longer gives the block tags to the allocation callback.
  (Stephen Dolan and Jacques-Henri Jourdan, review by Damien Doligez
   and Gabriel Scherer)

- #9353: Reimplement `output_value` and the `Marshal.to_*` functions
  using a hash table to detect sharing, instead of temporary in-place
  modifications.  This is a prerequisite for Multicore OCaml.
  (Xavier Leroy and Basile Clément, review by Gabriel Scherer and
  Stephen Dolan)


- #9119: Make [caml_stat_resize_noexc] compatible with the [realloc]
  API when the old block is NULL.
  (Jacques-Henri Jourdan, review by Xavier Leroy)

- #9233: Restore the bytecode stack after an allocation.
  (Stephen Dolan, review by Gabriel Scherer and Jacques-Henri Jourdan)

- #9249: restore definition of ARCH_ALIGN_INT64 in m.h if the architecture
  requires 64-bit integers to be double-word aligned (autoconf regression)
  (David Allsopp, review by Sébastien Hinderer)

- #9259: Made `Ephemeron.blit_key` and `Weak.blit` faster. They are now
  linear in the size of the range being copied instead of depending on the
  total sizes of the ephemerons or weak arrays involved.
  (Arseniy Alekseyev, design advice by Leo White, review by François Bobot
  and Damien Doligez)

- #9279: Memprof optimisation.
  (Stephen Dolan, review by Jacques-Henri Jourdan)

- #9280: Micro-optimise allocations on amd64 to save a register.
  (Stephen Dolan, review by Xavier Leroy)

- #9426: build the Mingw ports with higher levels of GCC optimization
  (Xavier Leroy, review by Sébastien Hinderer)

* #9483: Remove accidental inclusion of <stdio.h> in <caml/misc.h>
  The only release with the inclusion of stdio.h has been 4.10.0
  (Christopher Zimmermann, review by Xavier Leroy and David Allsopp)

- #9282: Make Cconst_symbol have typ_int to fix no-naked-pointers mode.
  (Stephen Dolan, review by Mark Shinwell, Xavier Leroy and Vincent Laviron)

- #9497: Harmonise behaviour between bytecode and native code for
  recursive module initialisation in one particular case (fixes #9494).
  (Mark Shinwell, David Allsopp, Vincent Laviron, Xavier Leroy,
  Geoff Reedy, original bug report by Arlen Cox)

- #8791: use a variable-length encoding when marshalling bigarray dimensions,
  avoiding overflow.
  (Jeremy Yallop, Stephen Dolan, review by Xavier Leroy)

### Code generation and optimizations:

- #9441: Add RISC-V RV64G native-code backend.
  (Nicolás Ojeda Bär, review by Xavier Leroy and Gabriel Scherer)

- #9316, #9443, #9463, #9782: Use typing information from Clambda
  for mutable Cmm variables.
  (Stephen Dolan, review by Vincent Laviron, Guillaume Bury, Xavier Leroy,
  and Gabriel Scherer; temporary bug report by Richard Jones)

- #8637, #8805, #9247, #9296: Record debug info for each allocation.
  (Stephen Dolan and Jacques-Henri Jourdan, review by Damien Doligez,
   KC Sivaramakrishnan and Xavier Leroy)


- #9193: Make tuple matching optimisation apply to Lswitch and Lstringswitch.
  (Stephen Dolan, review by Thomas Refis and Gabriel Scherer)

- #9392: Visit registers at most once in Coloring.iter_preferred.
  (Stephen Dolan, review by Pierre Chambart and Xavier Leroy)

- #9412: Keep Sys.opaque_identity in Cmm and Mach
  (Stephen Dolan, review by Mark Shinwell and Gabriel Scherer)

- #9549, #9557: Make -flarge-toc the default for PowerPC and introduce
  -fsmall-toc to enable the previous behaviour.
  (David Allsopp, report by Nathaniel Wesley Filardo, review by Xavier Leroy)

### Language features

- #8820, #9166: quoted extensions: {%foo|...|} is lighter syntax for
  [%foo {||}], and {%foo bar|...|bar} for [%foo {bar|...|bar}].
  (Gabriel Radanne, Leo White, Gabriel Scherer and Pieter Goetschalckx,
   request by Bikal Lem)

- #7364, #2188, #9592, #9609: improvement of the unboxability check for types
  with a single constructor. Mutually-recursive type declarations can
  now contain unboxed types. This is based on the paper
    https://arxiv.org/abs/1811.02300
  (Gabriel Scherer and Rodolphe Lepigre,
   review by Jeremy Yallop, Damien Doligez and Frédéric Bour)

- #1154, #1706: spellchecker hints and type-directed disambiguation
  for extensible sum type constructors
  (Florian Angeletti, review by Alain Frisch, Gabriel Radanne, Gabriel Scherer
  and Leo White)


- #6673, #1132, #9617: Relax the handling of explicit polymorphic types.
  This improves error messages in some polymorphic recursive definition,
  and requires less polymorphic annotations in some cases of
  mutually-recursive definitions involving polymorphic recursion.
  (Leo White, review by Jacques Garrigue and Gabriel Scherer)

- #9232: allow any class type paths in #-types,
  For instance, "val f: #F(X).t -> unit" is now allowed.
  (Florian Angeletti, review by Gabriel Scherer, suggestion by Leo White)

### Standard library:

- #9077: Add Seq.cons and Seq.append
  (Sébastien Briais, review by Yawar Amin and Florian Angeletti)

- #9235: Add Array.exists2 and Array.for_all2
  (Bernhard Schommer, review by Armaël Guéneau)

- #9226: Add Seq.unfold.
   (Jeremy Yallop, review by Hezekiah M. Carty, Gabriel Scherer and
   Gabriel Radanne)

- #9059: Added List.filteri function, same as List.filter but
  with the index of the element.
  (Léo Andrès, review by Alain Frisch)

- #8894: Added List.fold_left_map function combining map and fold.
  (Bernhard Schommer, review by Alain Frisch and github user @cfcs)

- #9365: Set.filter_map and Map.filter_map
  (Gabriel Scherer, review by Stephen Dolan and Nicolás Ojeda Bär)


- #9248: Add Printexc.default_uncaught_exception_handler
  (Raphael Sousa Santos, review by Daniel Bünzli)

- #8771: Lexing: add set_position and set_filename to change (fake)
   the initial tracking position of the lexbuf.
   (Konstantin Romanov, Miguel Lumapat, review by Gabriel Scherer,
    Sébastien Hinderer, and David Allsopp)

- #9237: `Format.pp_update_geometry ppf (fun geo -> {geo with ...})`
  for formatter geometry changes that are robust to new geometry fields.
  (Gabriel Scherer, review by Josh Berdine and Florian Angeletti)

- #7110: Added Printf.ikbprintf and Printf.ibprintf
  (Muskan Garg, review by Gabriel Scherer and Florian Angeletti)

- #9266: Install pretty-printer for the exception Fun.Finally_raised.
  (Guillaume Munch-Maccagnoni, review by Daniel Bünzli, Gabriel Radanne,
   and Gabriel Scherer)

### Other libraries:

- #9106: Register printer for Unix_error in win32unix, as in unix.
  (Christopher Zimmermann, review by David Allsopp)

- #9183: Preserve exception backtrace of exceptions raised by top-level phrases
  of dynlinked modules.
  (Nicolás Ojeda Bär, review by Xavier Clerc and Gabriel Scherer)

- #9320, #9550: under Windows, make sure that the Unix.exec* functions
  properly quote their argument lists.
  (Xavier Leroy, report by André Maroneze, review by Nicolás Ojeda Bär
   and David Allsopp)

- #9490, #9505: ensure proper rounding of file times returned by
  Unix.stat, Unix.lstat, Unix.fstat.
  (Xavier Leroy and Guillaume Melquiond, report by David Brown,
   review by Gabriel Scherer and David Allsopp)

### Tools:

- #9283, #9455, #9457: add a new toplevel directive `#use_output "<command>"` to
  run a command and evaluate its output.
  (Jérémie Dimino, review by David Allsopp)


- #6969: Argument -nocwd added to ocamldep
  (Muskan Garg, review by Florian Angeletti)

- #8676, #9594: turn debugger off in programs launched by the program
  being debugged
  (Xavier Leroy, report by Michael Soegtrop, review by Gabriel Scherer)

- #9057: aid debugging the debugger by preserving backtraces of unhandled
  exceptions.
  (David Allsopp, review by Gabriel Scherer)

- #9276: objinfo: cm[x]a print extra C options, objects and dlls in
  the order given on the cli. Follow up to #4949.
  (Daniel Bünzli, review by Gabriel Scherer)

- #463: objinfo: better errors on object files coming
  from a different (older or newer), incompatible compiler version.
  (Gabriel Scherer, review by Gabriel Radanne and Damien Doligez)

* #9197: remove compatibility logic from #244 that was designed to
  synchronize toplevel printing margins with Format.std_formatter,
  but also resulted in unpredictable/fragile changes to formatter
  margins.
  Setting the margins on the desired formatters should now work.
  typically on `Format.std_formatter`.
  Note that there currently is no robust way to do this from the
  toplevel, as applications may redirect toplevel printing. In
  a compiler/toplevel driver, one should instead access
  `Location.formatter_for_warnings`; it is not currently exposed
  to the toplevel.
  (Gabriel Scherer, review by Armaël Guéneau)

- #9207, #9210: fix ocamlyacc to work correctly with up to 255 entry
  points to the grammar.
  (Andreas Abel, review by Xavier Leroy)

- #9482, #9492: use diversions (@file) to work around OS limitations
  on length of Sys.command argument.
  (Xavier Leroy, report by Jérémie Dimino, review by David Allsopp)

### Manual and documentation:

- #9141: beginning of the ocamltest reference manual
  (Sébastien Hinderer, review by Gabriel Scherer and Thomas Refis)

- #9228: Various Map documentation improvements: add missing key argument in
  the 'merge' example; clarify the relationship between input and output keys
  in 'union'; note that find and find_opt return values, not bindings.
  (Jeremy Yallop, review by Gabriel Scherer and Florian Angeletti)

- #9255, #9300: reference chapter, split the expression grammar
  (Florian Angeletti, report by Harrison Ainsworth, review by Gabriel Scherer)

- #9325: documented base case for `List.for_all` and `List.exists`
  (Glenn Slotte, review by Florian Angeletti)

- #9410, #9422: replaced naive fibonacci example with gcd
  (Anukriti Kumar, review by San Vũ Ngọc, Florian Angeletti, Léo Andrès)

- #9541: Add a documentation page for the instrumented runtime;
  additional changes to option names in the instrumented runtime.
  (Enguerrand Decorne, review by Anil Madhavapeddy, Gabriel Scherer,
   Daniel Bünzli, David Allsopp, Florian Angeletti,
   and Sébastien Hinderer)

- #9610: manual, C FFI: naked pointers are deprecated, detail the
  forward-compatible options for handling out-of-heap pointers.
  (Xavier Leroy, review by Mark Shinwell, David Allsopp and Florian Angeletti)

- #9618: clarify the Format documentation on the margin and maximum indentation
  limit
  (Florian Angeletti, review by Josh Berdine)


- #8644: fix formatting comment about @raise in stdlib's mli files
  (Élie Brami, review by David Allsopp)

- #9327, #9401: manual, fix infix attribute examples
  (Florian Angeletti, report by David Cadé, review by Gabriel Scherer)

- #9403: added a description for warning 67 and added a "." at the end of
  warnings for consistency.
  (Muskan Garg, review by Gabriel Scherer and Florian Angeletti)

- #7708, #9580: Ensure Stdlib documentation index refers to Stdlib.
  (Stephen Dolan, review by Florian Angeletti, report by Hannes Mehnert)

### Compiler user-interface and warnings:

- #9712: Update the version format to allow "~".
  The new format is "major.minor[.patchlevel][(+|~)additional-info]",
  for instance "4.12.0~beta1+flambda".
  This is a documentation-only change for the 4.11 branch, the new format
  will be used starting with the 4.12 branch.
  (Florian Angeletti, review by Damien Doligez and Xavier Leroy)

- #1664: make -output-complete-obj link the runtime native c libraries when
  building shared libraries like `-output-obj`.
  (Florian Angeletti, review by Nicolás Ojeda Bär)

- #9349: Support [@inlined hint] attribute.
  (Leo White, review by Stephen Dolan)

- #2141: generate .annot files from cmt data; deprecate -annot.
  (Nicolás Ojeda Bär, review by Alain Frisch, Gabriel Scherer and Damien
  Doligez)


* #7678, #8631: ocamlc -c and ocamlopt -c pass same switches to the C
  compiler when compiling .c files (in particular, this means ocamlopt
  passes -fPIC on systems requiring it for shared library support).
  (David Allsopp, report by Daniel Bünzli, review by Sébastien Hinderer)

- #9074: reworded error message for non-regular structural types
  (Florian Angeletti, review by Jacques Garrigue and Leo White,
   report by Chas Emerick)

- #8938: Extend ocamlopt option "-stop-after" to handle "scheduling" argument.
  (Greta Yorsh, review by Florian Angeletti and Sébastien Hinderer)

- #8945, #9086: Fix toplevel show directive to work with constructors
  (Simon Parry, review by Gabriel Scherer, Jeremy Yallop,
  Alain Frisch, Florian Angeletti)

- #9107: improved error message for exceptions in module signature errors
  (Gabriel Scherer, review by Florian Angeletti)

- #9208: -dno-locations option to hide source locations (and debug events)
  from intermediate-representation dumps (-dfoo).
  (Gabriel Scherer, review by Vincent Laviron)

- #9393: Improve recursive module usage warnings
  (Leo White, review by Thomas Refis)

- #9486: Fix configuration for the Haiku operating system
  (Sylvain Kerjean, review by David Allsopp and Sébastien Hinderer)

### Internal/compiler-libs changes:

- #9021: expose compiler Longident.t parsers
  (Florian Angeletti, review by Gabriel Scherer)

- #9452: Add locations to docstring attributes
  (Leo White, review by Gabriel Scherer)


- #463: a new Misc.Magic_number module for user-friendly parsing
  and validation of OCaml magic numbers.
  (Gabriel Scherer, review by Gabriel Radanne and Damien Doligez)

- #1176: encourage better compatibility with older Microsoft C compilers by
  using GCC's -Wdeclaration-after-statement when available. Introduce
  Caml_inline to stop abuse of the inline keyword on MSVC and to help ensure
  that only static inline is used in the codebase (erroneous instance in
  runtime/win32.c removed).
  (David Allsopp, review by Olivier Andrieu and Xavier Leroy)

- #8934: Stop relying on location to track usage
  (Thomas Refis, review by Gabriel Radanne)

- #8970: separate value patterns (matching on values) from computation patterns
  (matching on the effects of a copmutation) in the typedtree.
  (Gabriel Scherer, review by Jacques Garrigue and Alain Frisch)

- #9060: ensure that Misc.protect_refs preserves backtraces
  (Gabriel Scherer, review by Guillaume Munch-Maccagnoni and David Allsopp)

- #9078: make all compilerlibs/ available to ocamltest.
  (Gabriel Scherer, review by Sébastien Hinderer)

- #9079: typecore/parmatch: refactor ppat_of_type and refine
  the use of backtracking on wildcard patterns
  (Florian Angeletti, Jacques Garrigue, Gabriel Scherer,
   review by Thomas Refis)

- #9081: typedtree, make the pat_env field of pattern data immutable
  (Gabriel Scherer, review by Jacques Garrigue, report by Alain Frisch)

- #9178, #9182, #9196: refactor label-disambiguation (Typecore.NameChoice)
  (Gabriel Scherer, Thomas Refis, Florian Angeletti and Jacques Garrigue,
   reviewing each other without self-loops)

- #9321, #9322, #9359, #9361, #9417, #9447: refactor the
  pattern-matching compiler
  (Thomas Refis and Gabriel Scherer, review by Florian Angeletti)

- #9211, #9215, #9222: fix Makefile dependencies in
  compilerlibs, dynlink, ocamltest.
  (Gabriel Scherer, review by Vincent Laviron and David Allsopp)

- #9275: Short circuit simple inclusion checks
  (Leo White, review by Thomas Refis)

- #9305: Avoid polymorphic compare in Ident
  (Leo White, review by Xavier Leroy and Gabriel Scherer)

- #7927: refactor val_env met_env par_env to class_env
  (Muskan Garg, review by Gabriel Scherer and Florian Angeletti)

- #2324, #9613: Replace the caml_int_compare and caml_float_compare
  (C functions) with primitives.
  (Greta Yorsh, review by Stephen Dolan and Vincent Laviron)

- #9246: Avoid rechecking functor applications
  (Leo White, review by Jacques Garrigue)

- #9402: Remove `sudo:false` from .travis.yml
  (Hikaru Yoshimura)

* #9411: forbid optional arguments reordering with -nolabels
  (Thomas Refis, review by Frédéric Bour and Jacques Garrigue)

- #9414: testsuite, ocamltest: keep test artifacts only on failure.
  Use KEEP_TEST_DIR_ON_SUCCESS=1 to keep all artifacts.
  (Gabriel Scherer, review by Sébastien Hinderer)


### Build system:

- #9250: Add --disable-ocamltest to configure and disable building for
  non-development builds.
  (David Allsopp, review by Sébastien Hinderer)

### Bug fixes:

- #7520, #9547: Odd behaviour of refutation cases with polymorphic variants
  (Jacques Garrigue, report by Leo White, reviews by Gabriel Scherer and Leo)

- #7562, #9456: ocamlopt-generated code crashed on Alpine Linux on
  ppc64le, arm, and i386.  Fixed by turning PIE off for musl-based Linux
  systems except amd64 (x86_64) and s390x.
  (Xavier Leroy, review by Gabriel Scherer)

- #7683, #1499: Fixes one case where the evaluation order in native-code
  may not match the one in bytecode.
  (Nicolás Ojeda Bär, report by Pierre Chambart, review by Gabriel Scherer)

- #7696, #6608: Record expression deleted when all fields specified
  (Jacques Garrigue, report by Jeremy Yallop)

- #7741, #9645: Failure to report escaping type variable
  (Jacques Garrigue, report by Gabriel Radanne, review by Gabriel Scherer)

- #7817, #9546: Unsound inclusion check for polymorphic variant
  (Jacques Garrigue, report by Mikhail Mandrykin, review by Gabriel Scherer)

- #7897, #9537: Fix warning 38 for rebound extension constructors
  (Leo White, review by Florian Angeletti)

- #7917, #9426: Use GCC option -fexcess-precision=standard when available,
  avoiding a problem with x87 excess precision in Float.round.
  (Xavier Leroy, review by Sébastien Hinderer)

- #9011: Allow linking .cmxa files with no units on MSVC by not requiring the
  .lib file to be present.
  (David Allsopp, report by Dmitry Bely, review by Xavier Leroy)

- #9064: Relax the level handling when unifying row fields
  (Leo White, review by Jacques Garrigue)

- #9097: Do not emit references to dead labels introduced by #2321 (spacetime).
  (Greta Yorsh, review by Mark Shinwell)

- #9163: Treat loops properly in un_anf
  (Leo White, review by Mark Shinwell, Pierre Chambart and Vincent Laviron)

- #9189, #9281: fix a conflict with Gentoo build system
  by removing an one-letter Makefile variable.
  (Florian Angeletti, report by Ralph Seichter, review by David Allsopp
   and Damien Doligez)

- #9225: Do not drop bytecode debug info after C calls.
  (Stephen Dolan, review by Gabriel Scherer and Jacques-Henri Jourdan)

- #9231: Make sure a debug event (and the corresponding debug
  information) is inserted after every primitive that can appear in a
  collected call stack, and make sure ocamlc preserves such events
  even if they are at tail position.
  (Jacques-Henri Jourdan, review by Gabriel Scherer)

- #9244: Fix some missing usage warnings
  (Leo White, review by Florian Angeletti)

- #9274, avoid reading cmi file while printing types
  (Florian Angeletti, review by Gabriel Scherer)

- #9307, #9345: reproducible env summaries for reproducible compilation
  (Florian Angeletti, review by Leo White)

- #9309, #9318: Fix exhaustivity checking with empty types
  (Florian Angeletti, Stefan Muenzel and Thomas Refis, review by Gabriel Scherer
  and Thomas Refis)

- #9335: actually have --disable-stdlib-manpages not build the manpages
  (implementation conflicted with #8837 which wasn't picked up in review)
  (David Allsopp, review by Florian Angeletti and Sébastien Hinderer)

- #9343: Re-enable `-short-paths` for some error messages
  (Leo White, review by Florian Angeletti)

- #9355, #9356: ocamldebug, fix a fatal error when printing values
  whose type involves a functor application.
  (Florian Angeletti, review by Gabriel Scherer, report by Cyril Six)

- #9367: Make bytecode and native-code backtraces agree.
  (Stephen Dolan, review by Gabriel Scherer)

- #9375, #9477: add forgotten substitution when compiling anonymous modules
  (Thomas Refis, review by Frédéric Bour, report by Andreas Hauptmann)

- #9384, #9385: Fix copy scope bugs in substitutions
  (Leo White, review by Thomas Refis, report by Nick Roberts)

* #9388: Prohibit signature local types with constraints
  (Leo White, review by Jacques Garrigue)

- #7141, #9389: returns exit_code for better user response on linking_error
  (Anukriti Kumar, review by Gabriel Scherer and Valentin Gatien-Baron)

- #9406, #9409: fix an error with packed module types from missing
  cmis.
  (Florian Angeletti, report by Thomas Leonard, review by Gabriel Radanne
   and Gabriel Scherer)

- #9415: Treat `open struct` as `include struct` in toplevel
  (Leo White, review by Thomas Refis)

- #9416: Avoid warning 58 in flambda ocamlnat
  (Leo White, review by Florian Angeletti)

- #9420: Fix memory leak when `caml_output_value_to_block` raises an exception
  (Xavier Leroy, review by Guillaume Munch-Maccagnoni)

- #9428: Fix truncated exception backtrace for C->OCaml callbacks
  on Power and Z System
  (Xavier Leroy, review by Nicolás Ojeda Bär)

- #9623, #9642: fix typing environments in Typedecl.transl_with_constraint
  (Gabriel Scherer, review by Jacques Garrigue and Leo White,
   report by Hugo Heuzard)

- #9695, #9702: no error when opening an alias to a missing module
  (Jacques Garrigue, report and review by Gabriel Scherer)

- #9714, #9724: Add a terminator to the `caml_domain_state` structure
  to better ensure that members are correctly spaced.
  (Antonin Décimo, review by David Allsopp and Xavier Leroy)

OCaml 4.10 maintenance branch
-----------------------------

### Runtime system:

- #9344, #9368: Disable exception backtraces in bytecode programs
  built with "-output-complete-exe". At the moment, such programs do
  not embed debug information and exception backtraces where causing
  them to crash.
  (Jérémie Dimino, review by Nicolás Ojeda Bär)

### Build system:

- #9531: fix support for the BFD library on FreeBSD
  (Hannes Mehnert, review by Gabriel Scherer and David Allsopp)

### Bug fixes:

- #9068, #9437: ocamlopt -output-complete-obj failure on FreeBSD 12
  (Xavier Leroy, report by Hannes Mehnert, review by Sébastien Hinderer)

- #9165, #9840: Add missing -function-sections flag in Makefiles.
  (Greta Yorsh, review by David Allsopp)

- #9495: fix a bug where bytecode binaries compiled with `-output-complete-exe`
  would not execute `at_exit` hooks at program termination (in particular,
  output channels would not be flushed).
  (Nicolás Ojeda Bär, review by David Allsopp)

- #9714, #9724: Use the C++ alignas keyword when compiling in C++ in MSVC.
  Fixes a bug with MSVC C++ 2015 onwards.
  (Antonin Décimo, review by David Allsopp and Xavier Leroy)

- #9736, #9749: Compaction must start in a heap where all free blocks are
  blue, which was not the case with the best-fit allocator.
  (Damien Doligez, report and review by Leo White)

### Tools:

- #9552: restore ocamloptp build and installation
  (Florian Angeletti, review by David Allsopp and Xavier Leroy)

OCaml 4.10.0 (21 February 2020)
-------------------------------

(Changes that can break existing programs are marked with a "*")

### Language features

- #7757, #1726: multi-indices for extended indexing operators:
  `a.%{0;1;2}` desugars to `( .%{ ;.. } ) a [|0;1;2|]`
  (Florian Angeletti, review by Gabriel Radanne)

* #1859, #9117: enforce safe (immutable) strings by removing
  the -unsafe-string option by default. This can be overridden by
  a configure-time option (available since 4.04 in 2016):
  --disable-force-safe-string since 4.08, -no-force-safe-since
  between 4.07 and 4.04.
  In the force-safe-string mode (now the default), the return type of the
  String_val macro in C stubs is `const char*` instead of
  `char*`. This change may break C FFI code.
  (Kate Deplaix)


- #6662, #8908: allow writing "module _ = E" to ignore module expressions
  (Thomas Refis, review by Gabriel Radanne)

### Runtime system:

- #8809, #9292: Add a best-fit allocator for the major heap; still
  experimental, it should be much better than current allocation
  policies (first-fit and next-fit) for programs with large heaps,
  reducing both GC cost and memory usage.
  This new best-fit is not (yet) the default; set it explicitly with
  OCAMLRUNPARAM="a=2" (or Gc.set from the program). You may also want
  to increase the `space_overhead` parameter of the GC (a percentage,
  80 by default), for example OCAMLRUNPARAM="o=85", for optimal
  speed.
  (Damien Doligez, review by Stephen Dolan, Jacques-Henri Jourdan,
   Xavier Leroy, Leo White)

* #8713, #8940, #9115, #9143, #9202, #9251:
  Introduce a state table in the runtime to contain the global variables.
  (The Multicore runtime will have one such state for each domain.)

   This changes the status of some internal variables of the OCaml runtime;
   in many cases the header file originally defining the internal variable
   provides a compatibility macro with the old name, but programs
   re-defining those variables by hand need to be fixed.

   (KC Sivaramakrishnan and Stephen Dolan,
    compatibility hacking by David Allsopp, Florian Angeletti, Kate Deplaix,
    Jacques Garrigue, Guillaume Munch-Maccagnoni and Nicolás Ojeda Bär,
    review by David Allsopp, Alain Frisch, Nicolás Ojeda Bär,
    Gabriel Scherer, Damien Doligez, and Guillaume Munch-Maccagnoni)

- #8993: New C functions caml_process_pending_actions{,_exn} in
  caml/signals.h, intended for executing all pending actions inside
  long-running C functions (requested minor and major collections,
  signal handlers, finalisers, and memprof callbacks). The function
  caml_process_pending_actions_exn returns any exception arising
  during their execution, allowing resources to be cleaned-up before
  re-raising.
  (Guillaume Munch-Maccagnoni, review by Jacques-Henri Jourdan,
   Stephen Dolan, and Gabriel Scherer)

* #8691, #8897, #9027: Allocation functions are now guaranteed not to
  trigger any OCaml callback when called from C. In long-running C
  functions, this can be replaced with calls to
  caml_process_pending_actions at safe points.
  Side effect of this change: in bytecode mode, polling for
  asynchronous callbacks is performed at every minor heap allocation,
  in addition to function calls and loops as in previous OCaml
  releases.
  (Jacques-Henri Jourdan, review by Stephen Dolan, Gabriel Scherer and
   Guillaume Munch-Maccagnoni)

* #9037: caml_check_urgent_gc is now guaranteed not to trigger any
  finaliser. In long-running C functions, this can be replaced
  with calls to caml_process_pending_actions at safe points.
  (Guillaume Munch-Maccagnoni, review by Jacques-Henri Jourdan and
   Stephen Dolan)


- #8619: Ensure Gc.minor_words remains accurate after a GC.
  (Stephen Dolan, Xavier Leroy and David Allsopp,
   review by Xavier Leroy and Gabriel Scherer)

- #8667: Limit GC credit to 1.0
  (Leo White, review by Damien Doligez)

- #8670: Fix stack overflow detection with systhreads
  (Stephen Dolan, review by Xavier Leroy, Anil Madhavapeddy, Gabriel Scherer,
   Frédéric Bour and Guillaume Munch-Maccagnoni)

* #8711: The major GC hooks are no longer allowed to interact with the
   OCaml heap.
   (Jacques-Henri Jourdan, review by Damien Doligez)

- #8630: Use abort() instead of exit(2) in caml_fatal_error, and add
  the new hook caml_fatal_error_hook.
  (Jacques-Henri Jourdan, review by Xavier Leroy)

- #8641: Better call stacks when a C call is involved in byte code mode
  (Jacques-Henri Jourdan, review by Xavier Leroy)

- #8634, #8668, #8684, #9103 (originally #847): Statistical memory profiling.
  In OCaml 4.10, support for allocations in the minor heap in native
  mode is not available, and callbacks for promotions and
  deallocations are not available.
  Hence, there is not any public API for this feature yet.
  (Jacques-Henri Jourdan, review by Stephen Dolan, Gabriel Scherer
   and Damien Doligez)

- #9268, #9271: Fix bytecode backtrace generation with large integers present.
  (Stephen Dolan and Mark Shinwell, review by Gabriel Scherer and
   Jacques-Henri Jourdan)

### Standard library:

- #8760: List.concat_map : ('a -> 'b list) -> 'a list -> 'b list
  (Gabriel Scherer, review by Daniel Bünzli and Thomas Refis)

- #8832: List.find_map : ('a -> 'b option) -> 'a list -> 'b option
  (Gabriel Scherer, review by Jeremy Yallop, Nicolás Ojeda Bär
   and Daniel Bünzli)

- #7672, #1492: Add `Filename.quote_command` to produce properly-quoted
  commands for execution by Sys.command.
  (Xavier Leroy, review by David Allsopp and Damien Doligez)

- #8971: Add `Filename.null`, the conventional name of the "null" device.
  (Nicolás Ojeda Bär, review by Xavier Leroy and Alain Frisch)

- #8651: add '%#F' modifier in printf to output OCaml float constants
  in hexadecimal
  (Pierre Roux, review by Gabriel Scherer and Xavier Leroy)


- #8657: Optimization in [Array.make] when initializing with unboxed
   or young values.
   (Jacques-Henri Jourdan, review by Gabriel Scherer and Stephen Dolan)

- #8716: Optimize [Array.fill] and [Hashtbl.clear] with a new runtime primitive
  (Alain Frisch, review by David Allsopp, Stephen Dolan and Damien Doligez)

- #8530: List.sort: avoid duplicate work by chop
  (Guillaume Munch-Maccagnoni, review by David Allsopp, Damien Doligez and
   Gabriel Scherer)

### Other libraries:

- #1939, #2023: Implement Unix.truncate and Unix.ftruncate on Windows.
  (Florent Monnier and Nicolás Ojeda Bär, review by David Allsopp)

### Code generation and optimizations:

- #8806: Add an [@@immediate64] attribute for types that are known to
  be immediate only on 64 bit platforms
  (Jérémie Dimino, review by Vladimir Keleshev)

- #9028, #9032: Fix miscompilation by no longer assuming that
  untag_int (tag_int x) = x in Cmmgen; the compilation of `(n lsl 1) + 1`,
  for example, would be incorrect if evaluated with a large value for `n`.
  (Stephen Dolan, review by Vincent Laviron and Xavier Leroy)

- #8672: Optimise Switch code generation on booleans.
  (Stephen Dolan, review by Pierre Chambart)


- #8990: amd64: Emit 32bit registers for Iconst_int when we can
  (Xavier Clerc, Tom Kelly and Mark Shinwell, review by Xavier Leroy)

- #2322: Add pseudo-instruction `Ladjust_trap_depth` to replace
  dummy Lpushtrap generated in linearize
  (Greta Yorsh and Vincent Laviron, review by Xavier Leroy)

- #8707: Simplif: more regular treatment of Tupled and Curried functions
  (Gabriel Scherer, review by Leo White and Alain Frisch)

- #8526: Add compile-time option -function-sections in ocamlopt to emit
  each function in a separate named text section on supported targets.
  (Greta Yorsh, review by Pierre Chambart)

- #2321: Eliminate dead ICatch handlers
  (Greta Yorsh, review by Pierre Chambart and Vincent Laviron)

- #8919: lift mutable lets along with immutable ones
  (Leo White, review by Pierre Chambart)

- #8909: Graph coloring register allocator: the weights put on
  preference edges should not be divided by 2 in branches of
  conditional constructs, because it is not good for performance
  and because it leads to ignoring preference edges with 0 weight.
  (Eric Stavarache, review by Xavier Leroy)

- #9006: int32 code generation improvements
  (Stephen Dolan, designed with Greta Yorsh, review by Xavier Clerc,
   Xavier Leroy and Alain Frisch)

- #9041: amd64: Avoid stall in sqrtsd by clearing destination.
  (Stephen Dolan, with thanks to Andrew Hunter, Will Hasenplaugh,
   Spiros Eliopoulos and Brian Nigito. Review by Xavier Leroy)

- #2165: better unboxing heuristics for let-bound identifiers
  (Alain Frisch, review by Vincent Laviron and Gabriel Scherer)

- #8735: unbox across static handlers
  (Alain Frisch, review by Vincent Laviron and Gabriel Scherer)

### Manual and documentation:

- #8718, #9089: syntactic highlighting for code examples in the manual
  (Florian Angeletti, report by Anton Kochkov, review by Gabriel Scherer)

- #9101: add links to section anchor before the section title,
  make the name of those anchor explicit.
  (Florian Angeletti, review by Daniel Bünzli, Sébastien Hinderer,
   and Gabriel Scherer)

- #9257, cautionary guidelines for using the internal runtime API
  without too much updating pain.
  (Florian Angeletti, review by Daniel Bünzli, Guillaume Munch-Maccagnoni
   and KC Sivaramakrishnan)


- #8950: move local opens in pattern out of the extension chapter
  (Florian Angeletti, review and suggestion by Gabriel Scherer)

- #9088, #9097: fix operator character classes
  (Florian Angeletti, review by Gabriel Scherer,
   report by Clément Busschaert)

- #9169: better documentation for the best-fit allocation policy
  (Gabriel Scherer, review by Guillaume Munch-Maccagnoni
   and Florian Angeletti)

### Compiler user-interface and warnings:

- #8833: Hint for (type) redefinitions in toplevel session
  (Florian Angeletti, review by Gabriel Scherer)

- #2127, #9185: Refactor lookup functions
  Included observable changes:
    - makes the location of usage warnings and alerts for constructors more
      precise
    - don't warn about a constructor never being used to build values when it
      has been defined as private
  (Leo White, Hugo Heuzard review by Thomas Refis, Florian Angeletti)

- #8702, #8777: improved error messages for fixed row polymorphic variants
  (Florian Angeletti, report by Leo White, review by Thomas Refis)

- #8844: Printing faulty constructors, inline records fields and their types
  during type mismatches. Also slightly changed other type mismatches error
  output.
  (Mekhrubon Turaev, review by Florian Angeletti, Leo White)

- #8885: Warn about unused local modules
  (Thomas Refis, review by Alain Frisch)

- #8872: Add ocamlc option "-output-complete-exe" to build a self-contained
  binary for bytecode programs, containing the runtime and C stubs.
  (Stéphane Glondu, Nicolás Ojeda Bär, review by Jérémie Dimino and Daniel
  Bünzli)

- #8874: add tests for typechecking error messages and pack them into
  pretty-printing boxes.
  (Oxana Kostikova, review by Gabriel Scherer)

- #8891: Warn about unused functor parameters
  (Thomas Refis, review by Gabriel Radanne)

- #8903: Improve errors for first-class modules
  (Leo White, review by Jacques Garrigue)

- #8914: clarify the warning on unboxable types used in external primitives (61)
  (Gabriel Scherer, review by Florian Angeletti, report on the Discourse forum)

- #9046: disable warning 30 by default
  This outdated warning complained on label/constructor name conflicts
  within a mutually-recursive type declarations; there is now no need
  to complain thanks to type-based disambiguation.
  (Gabriel Scherer)

### Tools:

* #6792, #8654 ocamldebug now supports programs using Dynlink. This
  changes ocamldebug messages, which may break compatibility
  with older emacs modes.
  (whitequark and Jacques-Henri Jourdan, review by Gabriel Scherer
   and Xavier Clerc)

- #8621: Make ocamlyacc a Windows Unicode application
  (David Allsopp, review by Nicolás Ojeda Bär)

* #8834, `ocaml`: adhere to the XDG base directory specification to
  locate an `.ocamlinit` file. Reads an `$XDG_CONFIG_HOME/ocaml/init.ml`
  file before trying to lookup `~/.ocamlinit`. On Windows the behaviour
  is unchanged.
  (Daniel Bünzli, review by David Allsopp, Armaël Guéneau and
   Nicolás Ojeda Bär)

- #9113: ocamldoc: fix the rendering of multi-line code blocks
  in the 'man' backend.
  (Gabriel Scherer, review by Florian Angeletti)

- #9127, #9130: ocamldoc: fix the formatting of closing brace in record types.
  (David Allsopp, report by San Vũ Ngọc)

- #9181: make objinfo work on Cygwin and look for the caml_plugin_header
  symbol in both the static and the dynamic symbol tables.
  (Sébastien Hinderer, review by Gabriel Scherer and David Allsopp)

### Build system:

- #8840: use ocaml{c,opt}.opt when available to build internal tools
  On my machine this reduces parallel-build times from 3m30s to 2m50s.
  (Gabriel Scherer, review by Xavier Leroy and Sébastien Hinderer)

- #8650: ensure that "make" variables are defined before use;
  revise generation of config/util.ml to better quote special characters
  (Xavier Leroy, review by David Allsopp)

- #8690, #8696: avoid rebuilding the world when files containing primitives
  change.
  (Stephen Dolan, review by Gabriel Scherer, Sébastien Hinderer and
   Thomas Refis)

- #8835: new configure option --disable-stdlib-manpages to disable building
  and installation of the library manpages.
  (David Allsopp, review by Florian Angeletti and Gabriel Scherer)

- #8837: build manpages using ocamldoc.opt when available
  cuts the manpages build time from 14s to 4s
  (Gabriel Scherer, review by David Allsopp and Sébastien Hinderer,
   report by David Allsopp)

- #8843, #8841: fix use of off_t on 32-bit systems.
  (Stephen Dolan, report by Richard Jones, review by Xavier Leroy)

- #8947, #9134, #9302, #9311: fix/improve support for the BFD library
  (Sébastien Hinderer, review by Damien Doligez and David Allsopp)

- #8951: let make's default target build the compiler
  (Sébastien Hinderer, review by David Allsopp)

- #8995: allow developers to specify frequently-used configure options in
  Git (ocaml.configure option) and a directory for host-specific, shareable
  config.cache files (ocaml.configure-cache option). See HACKING.adoc for
  further details.
  (David Allsopp, review by Gabriel Scherer)

- #9136: Don't propagate Cygwin-style prefix from configure to
  Makefile.config on Windows ports.
  (David Allsopp, review by Sébastien Hinderer)

### Internal/compiler-libs changes:

- #8828: Added abstractions for variants, records, constructors, fields and
  extension constructor types mismatch.
  (Mekhrubon Turaev, review by Florian Angeletti, Leo White and Gabriel Scherer)

- #7927, #8527: Replace long tuples into records in typeclass.ml
  (Ulugbek Abdullaev, review by David Allsopp and Gabriel Scherer)

- #1963: split cmmgen into generic Cmm helpers and clambda transformations
  (Vincent Laviron, review by Mark Shinwell)

- #1901: Fix lexing of character literals in comments
  (Pieter Goetschalckx, review by Damien Doligez)

- #1932: Allow octal escape sequences and identifiers containing apostrophes
  in ocamlyacc actions and comments.
  (Pieter Goetschalckx, review by Damien Doligez)

- #2288: Move middle end code from [Asmgen] to [Clambda_middle_end] and
  [Flambda_middle_end].  Run [Un_anf] from the middle end, not [Cmmgen].
  (Mark Shinwell, review by Pierre Chambart)

- #8692: Remove Misc.may_map and similar
  (Leo White, review by Gabriel Scherer and Thomas Refis)

- #8677: Use unsigned comparisons in amd64 and i386 emitter of Lcondbranch3.
  (Greta Yorsh, review by Xavier Leroy)

- #8766: Parmatch: introduce a type for simplified pattern heads
  (Gabriel Scherer and Thomas Refis, review by Stephen Dolan and
   Florian Angeletti)

- #8774: New implementation of Env.make_copy_of_types
  (Alain Frisch, review by Thomas Refis, Leo White and Jacques Garrigue)

- #7924: Use a variant instead of an int in Bad_variance exception
  (Rian Douglas, review by Gabriel Scherer)

- #8890: in -dtimings output, show time spent in C linker clearly
  (Valentin Gatien-Baron)

- #8910, #8911: minor improvements to the printing of module types
  (Gabriel Scherer, review by Florian Angeletti)

- #8913: ocamltest: improve 'promote' implementation to take
  skipped lines/bytes into account
  (Gabriel Scherer, review by Sébastien Hinderer)

- #8908: Use an option instead of a string for module names ("_" becomes None),
  and a dedicated type for functor parameters: "()" maps to "Unit" (instead of
  "*").
  (Thomas Refis, review by Gabriel Radanne)

- #8928: Move contains_calls and num_stack_slots from Proc to Mach.fundecl
  (Greta Yorsh, review by Florian Angeletti and Vincent Laviron)

- #8959, #8960, #8968, #9023: minor refactorings in the typing of patterns:
  + refactor the {let,pat}_bound_idents* functions
  + minor bugfix in type_pat
  + refactor the generic pattern-traversal functions
    in Typecore and Typedtree
  + restrict the use of Need_backtrack
  (Gabriel Scherer and Florian Angeletti,
   review by Thomas Refis and Gabriel Scherer)

- #9030: clarify and document the parameter space of type_pat
  (Gabriel Scherer and Florian Angeletti and Jacques Garrigue,
   review by Florian Angeletti and Thomas Refis)

- #8975: "ocamltests" files are no longer required or used by
  "ocamltest". Instead, any text file in the testsuite directory containing a
  valid "TEST" block will be automatically included in the testsuite.
  (Nicolás Ojeda Bär, review by Gabriel Scherer and Sébastien Hinderer)

- #8992: share argument implementations between executables
  (Florian Angeletti, review by Gabriel Scherer)

- #9015: fix fatal error in pprint_ast (#8789)
  (Damien Doligez, review by Thomas Refis)

### Bug fixes:

- #5673, #7636: unused type variable causes generalization error
  (Jacques Garrigue and Leo White, review by Leo White,
   reports by Jean-Louis Giavitto and Christophe Raffalli)

- #6922, #8955: Fix regression with -principal type inference for inherited
  methods, allowing to compile ocamldoc with -principal
  (Jacques Garrigue, review by Leo White)

- #7925, #8611: fix error highlighting for exceptionally
  long toplevel phrases
  (Kyle Miller, reported by Armaël Guéneau, review by Armaël Guéneau
   and Nicolás Ojeda Bär)

- #8622: Don't generate #! headers over 127 characters.
  (David Allsopp, review by Xavier Leroy and Stephen Dolan)

- #8715: minor bugfixes in CamlinternalFormat; removes the unused
  and misleading function CamlinternalFormat.string_of_formatting_gen
  (Gabriel Scherer and Florian Angeletti,
   review by Florian Angeletti and Gabriel Radanne)

- #8792, #9018: Possible (latent) bug in Ctype.normalize_type
  removed incrimined Btype.log_type, replaced by Btype.set_type
  (Jacques Garrigue, report by Alain Frisch, review by Thomas Refis)

- #8856, #8860: avoid stackoverflow when printing cyclic type expressions
  in some error submessages.
  (Florian Angeletti, report by Mekhrubon Turaev, review by Leo White)

- #8875: fix missing newlines in the output from MSVC invocation.
  (Nicolás Ojeda Bär, review by Gabriel Scherer)

- #8921, #8924: Fix stack overflow with Flambda
  (Vincent Laviron, review by Pierre Chambart and Leo White,
   report by Aleksandr Kuzmenko)

- #8892, #8895: fix the definition of Is_young when CAML_INTERNALS is not
  defined.
  (David Allsopp, review by Xavier Leroy)

- #8896: deprecate addr typedef in misc.h
  (David Allsopp, suggestion by Xavier Leroy)

- #8981: Fix check for incompatible -c and -o options.
  (Greta Yorsh, review by Damien Doligez)

- #9019, #9154: Unsound exhaustivity of GADTs from incomplete unification
  Also fixes bug found by Thomas Refis in #9012
  (Jacques Garrigue, report and review by Leo White, Thomas Refis)

- #9031: Unregister Windows stack overflow handler while shutting
  the runtime down.
  (Dmitry Bely, review by David Allsopp)

- #9051: fix unregistered local root in win32unix/select.c (could result in
  `select` returning file_descr-like values which weren't in the original sets)
  and correct initialisation of some blocks allocated with caml_alloc_small.
  (David Allsopp, review by Xavier Leroy)

- #9073, #9120: fix incorrect GC ratio multiplier when allocating custom blocks
  with caml_alloc_custom_mem in runtime/custom.c
  (Markus Mottl, review by Gabriel Scherer and Damien Doligez)

- #9209, #9212: fix a development-version regression caused by #2288
  (Kate Deplaix and David Allsopp, review by Sébastien Hinderer
   and Gabriel Scherer )

- #9218, #9269: avoid a rare wrong module name error with "-annot" and
  inline records.
  (Florian Angeletti, review by Gabriel Scherer, report by Kate Deplaix)

- #9261: Fix a soundness bug in Rec_check, new in 4.10 (from #8908)
  (Vincent Laviron, review by Jeremy Yallop and Gabriel Scherer)

OCaml 4.09 maintenance branch
-----------------------------

### Build system:

- #9383: Don't assume that AWKPATH includes .
  (David Allsopp, report by Ian Zimmerman)

OCaml 4.09.1 (16 Mars 2020)
---------------------------

- #8855, #8858: Links for tools not created when installing with
  --disable-installing-byecode-programs (e.g. ocamldep.opt installed, but
  ocamldep link not created)
  (David Allsopp, report by Thomas Leonard)

- #8953, #8954: Fix error submessages in the toplevel: do not display
  dummy locations
  (Armaël Guéneau, review by Gabriel Scherer)

- #8965, #8979: Alpine build failure caused by check-parser-uptodate-or-warn.sh
  (Gabriel Scherer and David Allsopp, report by Anton Kochkov)

- #8985, #8986: fix generation of the primitives when the locale collation is
  incompatible with C.
  (David Allsopp, review by Nicolás Ojeda Bär, report by Sebastian Rasmussen)

- #9050, #9076: install missing compilerlibs/ocamlmiddleend archives
  (Gabriel Scherer, review by Florian Angeletti, report by Olaf Hering)

- #9180: pass -fno-common option to C compiler when available,
  so as to detect problematic multiple definitions of global variables
  in the C runtime
  (Xavier Leroy, review by Mark Shinwell)

- #9144, #9180: multiple definitions of global variables in the C runtime,
  causing problems with GCC 10.0 and possibly with other C compilers
  (Xavier Leroy, report by Jürgen Reuter, review by Mark Shinwell)

- #9128: Fix a bug in bytecode mode which could lead to a segmentation
  fault. The bug was caused by the fact that the atom table shared a
  page with some bytecode. The fix makes sure both the atom table and
  the minor heap have their own pages.
  (Jacques-Henri Jourdan, review by Stephen Dolan, Xavier Leroy and
   Gabriel Scherer)

OCaml 4.09.0 (19 September 2019)
--------------------------------

### Runtime system:

* #1725, #2279: Deprecate Obj.set_tag and Obj.truncate
  (Stephen Dolan, review by Gabriel Scherer, Damien Doligez and Xavier Leroy)

* #2240: Constify "identifier" in struct custom_operations
  (Cedric Cellier, review by Xavier Leroy)

* #2293: Constify "caml_named_value"
  (Stephen Dolan, review by Xavier Leroy)

- #8787, #8788: avoid integer overflow in caml_output_value_to_bytes
  (Jeremy Yallop, report by Marcello Seri)


- #2075, #7729: rename _T macro used to support Unicode in the (Windows) runtime
  in order to avoid compiler warning
  (Nicolás Ojeda Bär, review by Gabriel Scherer and David Allsopp)

- #2250: Remove extra integer sign-extension in compare functions
  (Stefan Muenzel, review by Xavier Leroy)

- #8607: Remove obsolete macros for pre-2002 MSVC support
  (Stephen Dolan, review by Nicolás Ojeda Bär and David Allsopp)

- #8656: Fix a bug in [caml_modify_generational_global_root]
  (Jacques-Henri Jourdan, review by Gabriel Scherer)

### Standard library:

- #2262: take precision (.<n>) and flags ('+' and ' ') into account
  in printf %F
  (Pierre Roux, review by Gabriel Scherer)

- #6148, #8596: optimize some buffer operations
  (Damien Doligez, reports by John Whitington and Alain Frisch,
   review by Jeremy Yallop and Gabriel Scherer)

### Other libraries:

* #2318: Delete the graphics library. This library is now available
  as a separate "graphics" package in opam. Its new home is:
  https://github.com/ocaml/graphics
  (Jérémie Dimino, review by Nicolás Ojeda Bär, Xavier Leroy and
   Sébastien Hinderer)

* #2289: Delete the vmthreads library. This library was deprecated in 4.08.0.
  (Jérémie Dimino)

- #2112: Fix Thread.yield unfairness with busy threads yielding to each
  other.
  (Andrew Hunter, review by Jacques-Henri Jourdan, Spiros Eliopoulos, Stephen
  Weeks, Mark Shinwell)

- #7903, #2306: Make Thread.delay interruptible by signals again
  (Xavier Leroy, review by Jacques-Henri Jourdan and Edwin Török)

- #2248: Unix alloc_sockaddr: Fix read of uninitialized memory for an
  unbound Unix socket. Add support for receiving abstract (Linux) socket paths.
  (Tim Cuthbertson, review by Sébastien Hinderer and Jérémie Dimino)

### Compiler user-interface and warnings:

* #2276: Remove support for compiler plugins and hooks (also adds
  [Dynlink.unsafe_get_global_value])
  (Mark Shinwell, Xavier Clerc, review by Nicolás Ojeda Bär,
  Florian Angeletti, David Allsopp and Xavier Leroy)

- #2301: Hint on type error on int literal
  (Jules Aguillon, review by Nicolás Ojeda Bär , Florian Angeletti,
  Gabriel Scherer and Armaël Guéneau)

* #2314: Remove support for gprof profiling.
  (Mark Shinwell, review by Xavier Clerc and Stephen Dolan)

- #2190: fix pretty printing (using Pprintast) of "lazy ..." patterns and
  "fun (type t) -> ..." expressions.
  (Nicolás Ojeda Bär, review by Gabriel Scherer)

- #2277: Use newtype names as type variable names
  The inferred type of (fun (type t) (x : t) -> x)
  is now printed as ('t -> 't) rather than ('a -> 'a).
  (Matthew Ryan)


- #2309: New options -with-runtime and -without-runtime in ocamlopt/ocamlc
  that control the inclusion of the runtime system in the generated program.
  (Lucas Pluvinage, review by Daniel Bünzli, Damien Doligez, David Allsopp
   and Florian Angeletti)

- #3819, #8546 more explanations and tests for illegal permutation
  (Florian Angeletti, review by Gabriel Scherer)

- #8537: fix the -runtime-variant option for bytecode
  (Damien Doligez, review by David Allsopp)

- #8541: Correctly print multi-lines locations
  (Louis Roché, review by Gabriel Scherer)

- #8579: Better error message for private constructors
  of an extensible variant type
  (Guillaume Bury, review by many fine eyes)

### Code generation and optimizations:

- #2278: Remove native code generation support for 32-bit Intel macOS,
  iOS and other Darwin targets.
  (Mark Shinwell, review by Nicolás Ojeda Bär and Xavier Leroy)

- #8547: Optimize matches that are an affine function of the input.
  (Stefan Muenzel, review by Alain Frisch, Gabriel Scherer)


- #1904, #7931: Add FreeBSD/aarch64 support
  (Greg V, review by Sébastien Hinderer, Stephen Dolan, Damien Doligez
   and Xavier Leroy)

- #8507: Shorten symbol names of anonymous functions in Flambda mode
  (the directory portions are now hidden)
  (Mark Shinwell, review by Nicolás Ojeda Bär)

- #8681, #8699, #8712: Fix code generation with nested let rec of functions.
  (Stephen Dolan, Leo White, Gabriel Scherer and Pierre Chambart,
   review by Gabriel Scherer, reports by Alexey Solovyev and Jonathan French)

### Manual and documentation:

- #7584, #8538: Document .cmt* files in the "overview" of ocaml{c,opt}
  (Oxana Kostikova, rewiew by Florian Angeletti)


- #8757: Rename Pervasives to Stdlib in core library documentation.
  (Ian Zimmerman, review by David Allsopp)

- #8515: manual, precise constraints on reexported types
  (Florian Angeletti, review by Gabriel Scherer)

### Tools:

- #2221: ocamldep will now correctly allow a .ml file in an include directory
  that appears first in the search order to shadow a .mli appearing in a later
  include directory.
  (Nicolás Ojeda Bär, review by Florian Angeletti)

### Internal/compiler-libs changes:

- #1579: Add a separate types for clambda primitives
  (Pierre Chambart, review by Vincent Laviron and Mark Shinwell)

- #1965: remove loop constructors in Cmm and Mach
  (Vincent Laviron)

- #1973: fix compilation of catches with multiple handlers
  (Vincent Laviron)

- #2228, #8545: refactoring the handling of .cmi files
  by moving the logic from Env to a new module Persistent_env
  (Gabriel Scherer, review by Jérémie Dimino and Thomas Refis)

- #2229: Env: remove prefix_idents cache
  (Thomas Refis, review by Frédéric Bour and Gabriel Scherer)

- #2237, #8582: Reorder linearisation of Trywith to avoid a call instruction
  (Vincent Laviron and Greta Yorsh, additional review by Mark Shinwell;
  fix in #8582 by Mark Shinwell, Xavier Leroy and Anil Madhavapeddy)

- #2265: Add bytecomp/opcodes.mli
  (Mark Shinwell, review by Nicolás Ojeda Bär)

- #2268: Improve packing mechanism used for building compilerlibs modules
  into the Dynlink libraries
  (Mark Shinwell, Stephen Dolan, review by David Allsopp)

- #2280: Don't make more Clambda constants after starting Cmmgen
  (Mark Shinwell, review by Vincent Laviron)

- #2281: Move some middle-end files around
  (Mark Shinwell, review by Pierre Chambart and Vincent Laviron)

- #2283: Add [is_prefix] and [find_and_chop_longest_common_prefix] to
  [Misc.Stdlib.List]
  (Mark Shinwell, review by Alain Frisch and Stephen Dolan)

- #2284: Add various utility functions to [Misc] and remove functions
  from [Misc.Stdlib.Option] that are now in [Stdlib.Option]
  (Mark Shinwell, review by Thomas Refis)

- #2286: Functorise [Consistbl]
  (Mark Shinwell, review by Gabriel Radanne)

- #2291: Add [Compute_ranges] pass
  (Mark Shinwell, review by Vincent Laviron)

- #2292: Add [Proc.frame_required] and [Proc.prologue_required].
  Move tail recursion label creation to [Linearize].  Correctly position
  [Lprologue] relative to [Iname_for_debugger] operations.
  (Mark Shinwell, review by Vincent Laviron)

- #2308: More debugging information on [Cmm] terms
  (Mark Shinwell, review by Stephen Dolan)

- #7878, #8542: Replaced TypedtreeIter with tast_iterator
  (Isaac "Izzy" Avram, review by Gabriel Scherer and Nicolás Ojeda Bär)

- #8598: Replace "not is_nonexpansive" by "maybe_expansive".
  (Thomas Refis, review by David Allsopp, Florian Angeletti, Gabriel Radanne,
   Gabriel Scherer and Xavier Leroy)

### Compiler distribution build system:

- #2267: merge generation of header programs, also fixing parallel build on
  Cygwin.
  (David Allsopp, review by Sébastien Hinderer)

- #8514: Use boot/ocamlc.opt for building, if available.
  (Stephen Dolan, review by Gabriel Scherer)

### Bug fixes:

- #8864, #8865: Fix native compilation of left shift by (word_size - 1)
  (Vincent Laviron, report by Murilo Giacometti Rocha, review by Xavier Leroy)

- #2296: Fix parsing of hexadecimal floats with underscores in the exponent.
  (Hugo Heuzard and Xavier Leroy, review by Gabriel Scherer)

- #8800: Fix soundness bug in extension constructor inclusion
  (Leo White, review by Jacques Garrigue)

- #8848: Fix x86 stack probe CFI information in caml_c_call and
  caml_call_gc
  (Tom Kelly, review by Xavier Leroy)


- #7156, #8594: make top level use custom printers if they are available
  (Andrew Litteken, report by Martin Jambon, review by Nicolás Ojeda Bär,
   Thomas Refis, Armaël Guéneau, Gabriel Scherer, David Allsopp)

- #3249: ocamlmklib should reject .cmxa files
  (Xavier Leroy)

- #7937, #2287: fix uncaught Unify exception when looking for type
  declaration
  (Florian Angeletti, review by Jacques Garrigue)

- #8610, #8613: toplevel printing, consistent deduplicated name for types
  (Florian Angeletti, review by Thomas Refis and Gabriel Scherer,
   reported by Xavier Clerc)

- #8635, #8636: Fix a bad side-effect of the -allow-approx option of
  ocamldep. It used to turn some errors into successes
  (Jérémie Dimino)

- #8701, #8725: Variance of constrained parameters causes principality issues
  (Jacques Garrigue, report by Leo White, review by Gabriel Scherer)

- #8777(partial): fix position information in some polymorphic variant
  error messages about missing tags
  (Florian Angeletti, review by Thomas Refis)

- #8779, more cautious variance computation to avoid missing cmis
  (Florian Angeletti, report by Antonio Nuno Monteiro, review by Leo White)

- #8810: Env.lookup_module: don't allow creating loops
  (Thomas Refis, report by Leo White, review by Jacques Garrigue)

- #8862, #8871: subst: preserve scopes
  (Thomas Refis, report by Leo White, review by Jacques Garrigue)

- #8921, #8924: Fix stack overflow with Flambda
  (Vincent Laviron, review by Pierre Chambart and Leo White,
   report by Aleksandr Kuzmenko)

- #8944: Fix "open struct .. end" on clambda backend
  (Thomas Refis, review by Leo White, report by Damon Wang and Mark Shinwell)

OCaml 4.08 maintenance branch
-----------------------------

### Bug fixes:

- #9326, #10125: Gc.set incorrectly handles the three `custom_*` fields,
  causing a performance regression
  (report by Emilio Jesús Gallego Arias, analysis and fix by Stephen Dolan,
   code by Xavier Leroy, review by Hugo Heuzard and Gabriel Scherer)

OCaml 4.08.1 (5 August 2019)
----------------------------

### Bug fixes:

- #7887: ensure frame table is 8-aligned on ARM64 and PPC64
  (Xavier Leroy, report by Mark Hayden, review by Mark Shinwell
   and Gabriel Scherer)

- #8751: fix bug that could result in misaligned data section when compiling to
  native-code on amd64.  (observed with the mingw64 compiler)
  (Nicolás Ojeda Bär, review by David Allsopp)

- #8769, #8770: Fix assertion failure with -pack
  (Leo White, review by Gabriel Scherer, report by Fabian @copy)

- #8816, #8818: fix loading of packed modules with Dynlink (regression in
  #2176).
  (Leo White, report by Andre Maroneze, review by Gabriel Scherer)

- #8830: configure script: fix tool prefix detection and Debian's armhf
  detection
  (Stéphane Glondu, review by David Allsopp)

- #8843, #8841: fix use of off_t on 32-bit systems.
  (Stephen Dolan, report by Richard Jones, review by Xavier Leroy)

OCaml 4.08.0 (13 June 2019)
---------------------------

### Language features:

- #1947: Introduce binding operators (let*, let+, and* etc.)
  (Leo White, review by Thomas Refis)

- #1892: Allow shadowing of items coming from an include
  (Thomas Refis, review by Gabriel Radanne)

- #2122: Introduce local substitutions in signatures: "type t := type_expr"
  and "module M := Extended(Module).Path"
  (Thomas Refis, with help and review from Leo White, and Alain Frisch)

- #1804: New notion of "alerts" that generalizes the deprecated warning
      [@@ocaml.alert deprecated "Please use bar instead!"]
      [@@ocaml.alert unsafe "Please use safe_foo instead!"]
  (Alain Frisch, review by Leo White and Damien Doligez)

- #6422, #7083, #305, #1568: Allow `exception` under or-patterns
  (Thomas Refis, with help and review from Alain Frisch, Gabriel Scherer, Jeremy
  Yallop, Leo White and Luc Maranget)


- #1705: Allow @@attributes on exception declarations.
  (Hugo Heuzard, review by Gabriel Radanne and Thomas Refis)

- #1506, #2147, #2166, #2167: Extended `open` to arbitrary module
  expression in structures and to applicative paths in signatures
  (Runhang Li, review by Alain Frisch, Florian Angeletti, Jeremy Yallop,
  Leo White and Thomas Refis)

* #2106: .~ is now a reserved keyword, and is no longer available
  for use in extended indexing operators
  (Jeremy Yallop, review by Gabriel Scherer, Florian Angeletti, and
   Damien Doligez)

* #7841, #2041, #2235: allow modules from include directories
  to shadow other ones, even in the toplevel; for a example, including
  a directory that defines its own Result module will shadow the stdlib's.
  (Jérémie Dimino, review by Alain Frisch and David Allsopp)

### Type system:

- #2110: Partial support for GADTs inside or-patterns;
  The type equalities introduced by the GADT constructor are only
  available inside the or-pattern; they cannot be used in the
  right-hand-side of the clause, when both sides of the or-pattern
  agree on it.
  (Thomas Refis and Leo White, review by Jacques Garrigue)

- #1826: allow expanding a type to a private abbreviation instead of
  abstracting when removing references to an identifier.
  (Thomas Refis and Leo White, review by Jacques Garrigue)

- #1942, #2244: simplification of the static check
  for recursive definitions
  (Alban Reynaud and Gabriel Scherer,
   review by Jeremy Yallop, Armaël Guéneau and Damien Doligez)

### Standard library:

- #2128: Add Fun module: `id, const, flip, negate, protect`
  (protect is a "try_finally" combinator)
  https://caml.inria.fr/pub/docs/manual-ocaml/libref/Fun.html
  (Many fine eyes)

- #2010: Add Bool module
  https://caml.inria.fr/pub/docs/manual-ocaml/libref/Bool.html
  (Many fine eyes)

- #2011: Add Int module
  https://caml.inria.fr/pub/docs/manual-ocaml/libref/Int.html
  (Many fine eyes)

- #1940: Add Option module and Format.pp_print_option
  `none, some, value, get, bind, join, map, fold, iter`, etc.
  https://caml.inria.fr/pub/docs/manual-ocaml/libref/Option.html
  (Many fine eyes)

- #1956: Add Result module and Format.pp_print_result
  `ok, error, value, get_ok, bind, join, map, map_error`, etc.
  https://caml.inria.fr/pub/docs/manual-ocaml/libref/Result.html
  (Many fine eyes)

- #1855, #2118: Add `Fun.protect ~finally` for enforcing local
  invariants whether a function raises or not, similar to
  `unwind-protect` in Lisp and `FINALLY` in Modula-2. It is careful
  about preserving backtraces and treating exceptions in finally as
  errors.
  (Marcello Seri and Guillaume Munch-Maccagnoni, review by Daniel
  Bünzli, Gabriel Scherer, François Bobot, Nicolás Ojeda Bär, Xavier
  Clerc, Boris Yakobowski, Damien Doligez, and Xavier Leroy)

* #1605: Deprecate Stdlib.Pervasives. Following #1010, Pervasives
  is no longer needed and Stdlib should be used instead.
  (Jérémie Dimino, review by Nicolás Ojeda Bär)

- #2185: Add `List.filter_map`
  (Thomas Refis, review by Alain Frisch and Gabriel Scherer)

- #1957: Add Stack.{top_opt,pop_opt} and Queue.{peek_opt,take_opt}.
  (Vladimir Keleshev, review by Nicolás Ojeda Bär and Gabriel Scherer)

- #1182: Add new Printf formats %#d %#Ld %#ld %#nd (idem for %i and %u) for
  alternative integer formatting -- inserts '_' between blocks of digits.
  (ygrek, review by Gabriel Scherer)

- #1959: Add Format.dprintf, a printing function which outputs a closure
  usable with %t.
  (Gabriel Radanne, request by Armaël Guéneau,
   review by Florian Angeletti and Gabriel Scherer)

- #1986, #6450: Add Set.disjoint
  (Nicolás Ojeda Bär, review by Gabriel Scherer)

- #7812, #2125: Add Filename.chop_suffix_opt
  (Alain Frisch, review by Nicolás Ojeda Bär, suggestion by whitequark)

- #1864: Extend Bytes and Buffer with functions to read/write
  binary representations of numbers
  (Alain Frisch and Daniel Bünzli)

- #1458: Add unsigned operations unsigned_div, unsigned_rem, unsigned_compare
  and unsigned_to_int to modules Int32, Int64, Nativeint.
  (Nicolás Ojeda Bär, review by Daniel Bünzli, Alain Frisch and Max Mouratov)

- #2002: Add Format.pp_print_custom_break, a new more general kind of break
  hint that can emit non-whitespace characters.
  (Vladimir Keleshev and Pierre Weis, review by Josh Berdine, Gabriel Radanne)

- #1966: Add Format semantic tags using extensible sum types.
  (Gabriel Radanne, review by Nicolás Ojeda Bär)

- #1794: Add constants zero, one, minus_one and functions succ,
  pred, is_finite, is_infinite, is_nan, is_integer, trunc, round,
  next_after, sign_bit, min, max, min_max, min_num, max_num,
  min_max_num to module Float.
  (Christophe Troestler, review by Alain Frisch, Xavier Clerc and Daniel Bünzli)

- #1354, #2177: Add fma support to Float module.
  (Laurent Thévenoux, review by Alain Frisch, Jacques-Henri Jourdan,
  Xavier Leroy)



- #5072, #6655, #1876: add aliases in Stdlib for built-in types
  and exceptions.
  (Jeremy Yallop, reports by Pierre Letouzey and David Sheets,
   review by Valentin Gatien-Baron, Gabriel Scherer and Alain Frisch)

- #1731: Format, use raise_notrace to preserve backtraces.
  (Frédéric Bour, report by Jules Villard, review by Gabriel Scherer)

- #6701, #1185, #1803: make float_of_string and string_of_float
  locale-independent.
  (ygrek, review by Xavier Leroy and Damien Doligez)

- #7795, #1782: Fix off-by-one error in Weak.create.
  (KC Sivaramakrishnan, review by Gabriel Scherer and François Bobot)

- #7235: Format, flush err_formatter at exit.
  (Pierre Weis, request by Jun Furuse)

- #1857, #7812: Remove Sort module, deprecated since 2000 and emitting
  a deprecation warning since 4.02.
  (whitequark)

- #1923: Arg module sometimes misbehaved instead of rejecting invalid
  -keyword=arg inputs
  (Valentin Gatien-Baron, review by Gabriel Scherer)

- #1959: Small simplification and optimization to Format.ifprintf
  (Gabriel Radanne, review by Gabriel Scherer)

- #2119: clarify the documentation of Set.diff
  (Gabriel Scherer, suggestion by John Skaller)

- #2145: Deprecate the mutability of Gc.control record fields
  (Damien Doligez, review by Alain Frisch)

- #2159, #7874: annotate {String,Bytes}.equal as being [@@noalloc].
  (Pierre-Marie Pédrot, review by Nicolás Ojeda Bär)

- #1936: Add module Float.Array
  (Damien Doligez, review by Xavier Clerc and Alain Frisch)

- #2183: Fix segfault in Array.create_float with -no-flat-float-array
  (Damien Doligez, review by Gabriel Scherer and Jeremy Yallop)

- #1525: Make function set_max_indent respect documentation
  (Pierre Weis, Richard Bonichon, review by Florian Angeletti)

- #2202: Correct Hashtbl.MakeSeeded.{add_seq,replace_seq,of_seq} to use
  functor hash function instead of default hash function. Hashtbl.Make.of_seq
  shouldn't create randomized hash tables.
  (David Allsopp, review by Alain Frisch)

### Other libraries:

- #2533, #1839, #1949: added Unix.fsync
  (François Berenger, Nicolás Ojeda Bär, review by Daniel Bünzli, David Allsopp
  and ygrek)

- #1792, #7794: Add Unix.open_process_args{,_in,_out,_full} similar to
  Unix.open_process{,_in,_out,_full}, but passing an explicit argv array.
  (Nicolás Ojeda Bär, review by Jérémie Dimino, request by Volker Diels-Grabsch)

- #1999: Add Unix.process{,_in,_out,_full}_pid to retrieve opened process's
  pid.
  (Romain Beauxis, review by Nicolás Ojeda Bär)

- #2222: Set default status in waitpid when pid is zero. Otherwise,
  status value is undefined.
  (Romain Beauxis and Xavier Leroy, review by Stephen Dolan)

* #2104, #2211, #4127, #7709: Fix Thread.sigmask. When
  system threads are loaded, Unix.sigprocmask is now an alias for
  Thread.sigmask. This changes the behavior at least on MacOS, where
  Unix.sigprocmask used to change the masks of all threads.
  (Jacques-Henri Jourdan, review by Jérémie Dimino)

- #1061: Add ?follow parameter to Unix.link. This allows hardlinking
  symlinks.
  (Christopher Zimmermann, review by Xavier Leroy, Damien Doligez, David
   Allsopp, David Sheets)

- #2038: Deprecate vm threads.
  OCaml supported both "native threads", based on pthreads,
  and its own green-threads implementation, "vm threads". We are not
  aware of any recent usage of "vm threads", and removing them simplifies
  further maintenance.
  (Jérémie Dimino)

* #4208, #4229, #4839, #6462, #6957, #6950, #1063, #2176,
  #2297: Make (nat)dynlink sound by correctly failing when
  dynlinked module names clash with other modules or interfaces.
  (Mark Shinwell, Leo White, Nicolás Ojeda Bär, Pierre Chambart)

- #2263: Delete the deprecated Bigarray.*.map_file functions in
  favour of `*_of_genarray (Unix.map_file ...)` functions instead. The
  `Unix.map_file` function was introduced in OCaml 4.06.0 onwards.
  (Jérémie Dimino, reviewed by David Allsopp and Anil Madhavapeddy)

### Compiler user-interface and warnings:

- #2096: Add source highlighting for errors & warnings in batch mode
  (Armaël Guéneau, review by Gabriel Scherer and Jérémie Dimino)

- #2133: [@ocaml.warn_on_literal_pattern]: now warn on literal patterns
  found anywhere in a constructor's arguments.
  (Jeremy Yallop, review by Gabriel Scherer)

- #1720: Improve error reporting for missing 'rec' in let-bindings.
  (Arthur Charguéraud and Armaël Guéneau, with help and advice
   from Gabriel Scherer, Frédéric Bour, Xavier Clerc and Leo White)

- #7116, #1430: new -config-var option
  to get the value of a single configuration variable in scripts.
  (Gabriel Scherer, review by Sébastien Hinderer and David Allsopp,
   request by Adrien Nader)

- #1733,1993,1998,2058,2094,2140: Typing error message improvements
    - #1733, change the perspective of the unexpected existential error
      message.
    - #1993, expanded error messages for universal quantification failure
    - #1998, more context for unbound type parameter error
    - #2058, full explanation for unsafe cycles in recursive module
      definitions (suggestion by Ivan Gotovchits)
    - #2094, rewording for "constructor has no type" error
    - #7565, #2140, more context for universal variable escape
      in method type
  (Florian Angeletti, reviews by Jacques Garrigue, Armaël Guéneau,
   Gabriel Radanne, Gabriel Scherer and Jeremy Yallop)

- #1913: new flag -dump-into-file to print debug output like -dlambda into
  a file named after the file being built, instead of on stderr.
  (Valentin Gatien-Baron, review by Thomas Refis)

- #1921: in the compilation context passed to ppx extensions,
  add more configuration options related to type-checking:
  -rectypes, -principal, -alias-deps, -unboxed-types, -unsafe-string
  (Gabriel Scherer, review by Gabriel Radanne, Xavier Clerc and Frédéric Bour)

- #1976: Better error messages for extension constructor type mismatches
  (Thomas Refis, review by Gabriel Scherer)

- #1841, #7808: the environment variable OCAMLTOP_INCLUDE_PATH can now
  specify a list of additional include directories for the ocaml toplevel.
  (Nicolás Ojeda Bär, request by Daniel Bünzli, review by Daniel Bünzli and
  Damien Doligez)

- #6638, #1110: introduced a dedicated warning to report
  unused "open!" statements
  (Alain Frisch, report by dwang, review by and design from Leo White)

- #1974: Trigger warning 5 in "let _ = e" and "ignore e" if e is of function
  type and syntactically an application. (For the case of "ignore e" the warning
  already existed, but used to be triggered even when e was not an application.)
  (Nicolás Ojeda Bär, review by Alain Frisch and Jacques Garrigue)

- #7408, #7846, #2015: Check arity of primitives.
  (Hugo Heuzard, review by Nicolás Ojeda Bär)



- #2091: Add a warning triggered by type declarations "type t = ()"
  (Armaël Guéneau, report by linse, review by Florian Angeletti and Gabriel
  Scherer)

- #2004: Use common standard library path `lib/ocaml` for Windows,
  for consistency with OSX & Linux. Previously was located at `lib`.
  (Bryan Phelps, Jordan Walke, review by David Allsopp)

- #6416, #1120: unique printed names for identifiers
  (Florian Angeletti, review by Jacques Garrigue)

- #1691: add shared_libraries to ocamlc -config exporting
  SUPPORTS_SHARED_LIBRARIES from Makefile.config.
  (David Allsopp, review by Gabriel Scherer and Mark Shinwell)

- #6913, #1786: new -match-context-rows option
  to control the degree of optimization in the pattern matching compiler.
  (Dwight Guth, review by Gabriel Scherer and Luc Maranget)

- #1822: keep attributes attached to pattern variables from being discarded.
  (Nicolás Ojeda Bär, review by Thomas Refis)

- #1845: new `-dcamlprimc` option to keep the generated C file containing
  the information about primitives; pass `-fdebug-prefix-map` to the C compiler
  when supported, for reproducible builds
  (Xavier Clerc, review by Jérémie Dimino)

- #1856, #1869: use `BUILD_PATH_PREFIX_MAP` when compiling primitives
  in order to make builds reproducible if code contains uses of
  `__FILE__` or `__LOC__`
  (Xavier Clerc, review by Gabriel Scherer and Sébastien Hinderer)

- #1906: the -unsafe option does not apply to marshalled ASTs passed
  to the compiler directly or by a -pp preprocessor; add a proper
  warning (64) instead of a simple stderr message
  (Valentin Gatien-Baron)

- #1925: Print error locations more consistently between batch mode, toplevel
  and expect tests
  (Armaël Guéneau, review by Thomas Refis, Gabriel Scherer and François Bobot)

- #1930: pass the elements from `BUILD_PATH_PREFIX_MAP` to the assembler
  (Xavier Clerc, review by Gabriel Scherer, Sébastien Hinderer, and
   Xavier Leroy)

- #1945, #2032: new "-stop-after [parsing|typing]" option
  to stop compilation after the parsing or typing pass
  (Gabriel Scherer, review by Jérémie Dimino)

- #1953: Add locations to attributes in the parsetree.
  (Hugo Heuzard, review by Gabriel Radanne)

- #1954: Add locations to toplevel directives.
  (Hugo Heuzard, review by Gabriel Radanne)

* #1979: Remove support for TERM=norepeat when displaying errors
  (Armaël Guéneau, review by Gabriel Scherer and Florian Angeletti)

- #1960: The parser keeps previous location when relocating ast node.
  (Hugo Heuzard, review by Jérémie Dimino)

- #7864, #2109: remove duplicates from spelling suggestions.
  (Nicolás Ojeda Bär, review by Armaël Guéneau)

### Manual and documentation:

- #7548: printf example in the tutorial part of the manual
 (Kostikova Oxana, rewiew by Gabriel Scherer, Florian Angeletti,
 Marcello Seri and Armaël Guéneau)

- #7546, #2020: preambles and introduction for compiler-libs.
  (Florian Angeletti, review by Daniel Bünzli, Perry E. Metzger
  and Gabriel Scherer)

- #7547, #2273: Tutorial on Lazy expressions and patterns in OCaml Manual
  (Ulugbek Abdullaev, review by Florian Angeletti and Gabriel Scherer)

- #7720, #1596, precise the documentation
  of the maximum indentation limit in Format.
  (Florian Angeletti, review by Richard Bonichon and Pierre Weis)

- #7825: html manual split compilerlibs from stdlib in the html
  index of modules
  (Florian Angeletti, review by Perry E. Metzger and Gabriel Scherer)

- #1209, #2008: in the Extension section, use the caml_example environment
  (uses the compiler to check the example code).
  This change was made possible by a lot of tooling work from Florian Angeletti:
  #1702, #1765, #1863, and Gabriel Scherer's #1903.
  (Gabriel Scherer, review by Florian Angeletti)

- #1788, 1831, 2007, 2198, 2232, move language extensions to the core
  chapters:
     - #1788: quoted string description
     - #1831: local exceptions and exception cases
     - #2007: 32-bit, 64-bit and native integer literals
     - #2198: lazy patterns
     - #2232: short object copy notation
  (Florian Angeletti, review by Xavier Clerc, Perry E. Metzger, Gabriel Scherer
   and Jeremy Yallop)

- #1863: caml-tex2, move to compiler-libs
  (Florian Angeletti, review by Sébastien Hinderer and Gabriel Scherer)

- #2105: Change verbatim to caml_example in documentation
  (Maxime Flin, review by Florian Angeletti)

- #2114: ocamldoc, improved manpages for documentation inside modules
  (Florian Angeletti, review by Gabriel Scherer)

- #2117: stdlib documentation, duplicate the operator precedence table
  from the manual inside a separate "OCaml_operators" module.
  (Florian Angeletti, review by Daniel Bünzli, Perry E. Metzger
  and Gabriel Scherer)

- #2187: document "exception A | pat" patterns
  (Florian Angeletti, review by Perry E. Metzger and Jeremy Yallop)

- #8508: refresh \moduleref macro
  (Florian Angeletti, review by Gabriel Scherer)

### Code generation and optimizations:

- #7725, #1754: improve AFL instrumentation for objects and lazy values.
  (Stephen Dolan)

- #1631: AMD64 code generator: emit shorter instruction sequences for the
  sign-extension operations.
  (LemonBoy, review by Alain Frisch and Xavier Leroy)

- #7246, #2146: make a few int64 primitives use [@@unboxed]
  stubs on 32bits
  (Jérémie Dimino)

- #1917: comballoc: ensure object allocation order is preserved
  (Stephen Dolan)

- #6242, #2143, #8558, #8559: Optimize some local functions.
  Local functions that do not escape and whose calls all have
  the same continuation are lowered into a static-catch handler.
  (Alain Frisch, review by Gabriel Scherer)

- #2082: New options [-insn-sched] and [-no-insn-sched] to control
  instruction scheduling.
  (Mark Shinwell, review by Damien Doligez)

- #2239: Fix match miscompilation with flambda
  (Leo White, review by Alain Frisch)

### Runtime system:

- #7198, #7750, #1738: add a function (caml_alloc_custom_mem)
  and three GC parameters to give the user better control of the
  out-of-heap memory retained by custom values; use the function to
  allocate bigarrays and I/O channels.
  (Damien Doligez, review by Alain Frisch)

- #1793: add the -m and -M command-line options to ocamlrun.
  Option -m prints the magic number of the bytecode executable passed
  as argument, -M prints the magic number expected by ocamlrun.
  (Sébastien Hinderer, review by Xavier Clerc and Damien Doligez)

- #1867: Remove the C plugins mechanism.
  (Xavier Leroy, review by David Allsopp, Damien Doligez, Sébastien Hinderer)

- #8627: Require SSE2 for 32-bit mingw port to generate correct code
  for caml_round with GCC 7.4.
  (David Allsopp, review by Xavier Leroy)

- #7676, #2144: Remove old GC heuristic
  (Damien Doligez, report and review by Alain Frisch)

* #1683: Change Marshal format to make Custom_tag objects store their
  length. Old versions of OCaml will no longer be able to parse new marshalled
  files containing custom blocks, but old files will still parse.
  (Stephen Dolan)

- #1723: Remove internal Meta.static_{alloc,free} primitives.
  (Stephen Dolan, review by Gabriel Scherer)

- #1895: Printexc.get_callstack would return only one frame in native
  code in threads other then the initial one
  (Valentin Gatien-Baron, review by Xavier Leroy)

- #1900, #7814: avoid exporting non-prefixed identifiers in the debug
  and instrumented runtimes.
  (Damien Doligez, report by Gabriel Scherer)

- #2079: Avoid page table lookup in Pervasives.compare with
  no-naked-pointers
  (Sam Goldman, review by Gabriel Scherer, David Allsopp, Stephen Dolan)

- #7829, #8585: Fix pointer comparisons in freelist.c (for 32-bit platforms)
  (David Allsopp and Damien Doligez)

- #8567, #8569: on ARM64, use 32-bit loads to access caml_backtrace_active
  (Xavier Leroy, review by Mark Shinwell and Greta Yorsh)

- #8568: Fix a memory leak in mmapped bigarrays
  (Damien Doligez, review by Xavier Leroy and Jérémie Dimino)

### Tools

- #2182: Split Emacs caml-mode as an independent project.
  (Christophe Troestler, review by Gabriel Scherer)

- #1865: support dark themes in Emacs, and clean up usage of
  deprecated Emacs APIs
  (Wilfred Hughes, review by Clément Pit-Claudel)

- #1590: ocamllex-generated lexers can be instructed not to update
  their lex_curr_p/lex_start_p fields, resulting in a significant
  performance gain when those fields are not required.
  (Alain Frisch, review by Jérémie Dimino)

- #7843, #2013: ocamldoc, better handling of {{!label}text} in the latex
  backend.
  (Florian Angeletti, review by Nicolás Ojeda Bär and Gabriel Scherer)

- #7844, #2040: Emacs, use built-in detection of comments,
  fixes an imenu crash.
  (Wilfred Hughes, review by Christophe Troestler)

- #7850: Emacs, use symbol boundaries in regular expressions,
  fixes an imenu crash.
  (Wilfred Hughes, review by Christophe Troestler)

- #1711: the new 'open' flag in OCAMLPARAM takes a comma-separated list of
  modules to open as if they had been passed via the command line -open flag.
  (Nicolás Ojeda Bär, review by Mark Shinwell)

- #2000: ocamdoc, extended support for "include module type of ..."
  (Florian Angeletti, review by Jérémie Dimino)

- #2045: ocamlmklib now supports options -args and -args0 to provide extra
  command-line arguments in a file.
  (Nicolás Ojeda Bär, review by Gabriel Scherer and Daniel Bünzli)

- #2189: change ocamldep Makefile-output to print each dependency
  on a new line, for more readable diffs of versioned dependencies.
  (Gabriel Scherer, review by Nicolás Ojeda Bär)

- #2223: ocamltest: fix the "bsd" and "not-bsd" built-in actions to
  recognize all BSD variants
  (Damien Doligez, review by Sébastien Hinderer and David Allsopp)

### Compiler distribution build system:

- #1776: add -no-install-bytecode-programs and related configure options to
  control (non-)installation of ".byte" executables.
  (Mark Shinwell, review by Sébastien Hinderer and Gabriel Scherer)

- #1777: add -no-install-source-artifacts and related configure options to
  control installation of .cmt, .cmti, .mli and .ml files.
  (Mark Shinwell, review by Nicolás Ojeda Bär and Sébastien Hinderer)

- #1781: cleanup of the manual's build process.
  (steinuil, review by Marcello Seri, Gabriel Scherer and Florian Angeletti)

- #1797: remove the deprecated Makefile.nt files.
  (Sébastien Hinderer, review by Nicolás Ojeda Bär)

- #1805: fix the bootstrap procedure and its documentation.
  (Sébastien Hinderer, Xavier Leroy and Damien Doligez; review by
  Gabriel Scherer)

- #1840: build system enhancements.
  (Sébastien Hinderer, review by David Allsopp, Xavier Leroy and
  Damien Doligez)

- #1852: merge runtime directories
  (Sébastien Hinderer, review by Xavier Leroy and Damien Doligez)

- #1854: remove the no longer defined BYTECCCOMPOPTS build variable.
  (Sébastien Hinderer, review by Damien Doligez)

- #2024: stop supporting obsolete platforms: Rhapsody (old beta
  version of MacOS X, BeOS, alpha*-*-linux*, mips-*-irix6*,
  alpha*-*-unicos, powerpc-*-aix, *-*-solaris2*, mips*-*-irix[56]*,
  i[3456]86-*-darwin[89].*, i[3456]86-*-solaris*, *-*-sunos* *-*-unicos.
  (Sébastien Hinderer, review by Xavier Leroy, Damien Doligez, Gabriel
  Scherer and Armaël Guéneau)

- #2053: allow unix, vmthreads and str not to be built.
  (David Allsopp, review by Sébastien Hinderer)

* #2059: stop defining OCAML_STDLIB_DIR in s.h.
  (Sébastien Hinderer, review by David Allsopp and Damien Doligez)

* #2066: remove the standard_runtime configuration variable.
  (Sébastien Hinderer, review by Xavier Leroy, Stephen Dolan and
  Damien Doligez)

* #2139: use autoconf to generate the compiler's configuration script
  (Sébastien Hinderer, review by Damien Doligez and David Allsopp)

- #2148: fix a parallel build bug involving CamlinternalLazy.
  (Stephen Dolan, review by Gabriel Scherer and Nicolás Ojeda Bär)

- #2264, #7904: the configure script now sets the Unicode handling mode
  under Windows according to the value of the variable WINDOWS_UNICODE_MODE. If
  WINDOWS_UNICODE_MODE is "ansi" then it is assumed to be the current code page
  encoding. If WINDOWS_UNICODE_MODE is "compatible" or empty or not set at all,
  then encoding is UTF-8 with code page fallback.
  (Nicolás Ojeda Bär, review by Sébastien Hinderer and David Allsopp)

- #2266: ensure Cygwin ports configure with `EXE=.exe`, or the compiler is
  unable to find the camlheader files (subtle regression of #2139/2041)
  (David Allsopp, report and review by Sébastien Hinderer)

- #7919, #2311: Fix assembler detection in configure
  (Sébastien Hinderer, review by David Allsopp)

- #2295: Restore support for bytecode target XLC/AIX/Power
  (Konstantin Romanov, review by Sébastien Hinderer and David Allsopp)

- #8528: get rid of the direct call to the C preprocessor in the testsuite
  (Sébastien Hinderer, review by David Allsopp)

- #7938, #8532: Fix alignment detection for ints on 32-bits platforms
  (Sébastien Hinderer, review by Xavier Leroy)

* #8533: Remove some unused configure tests
  (Stephen Dolan, review by David Allsopp and Sébastien Hinderer)

- #2207, #8604: Add opam files to allow pinning
  (Leo White, Greta Yorsh, review by Gabriel Radanne)

- #8616: configure: use variables rather than arguments for a few options
  (Sébastien Hinderer, review by David Allsopp, Gabriel Scherer and
  Damien Doligez)

- #8632: Correctly propagate flags for --with-pic in configure.
  (David Allsopp, review by Sébastien Hinderer and Damien Doligez)

- #8673: restore SpaceTime and libunwind support in configure script
  (Sébastien Hinderer, review by Damien Doligez)

### Internal/compiler-libs changes:

- #7918, #1703, #1944, #2213, #2257: Add the module
  Compile_common, which factorizes the common part in Compile and
  Optcompile. This also makes the pipeline more modular.
  (Gabriel Radanne, help from Gabriel Scherer and Valentin
   Gatien-Baron, review by Mark Shinwell and Gabriel Radanne,
   regression spotted by Clément Franchini)

- #292: use Menhir as the parser generator for the OCaml parser.
  Satellite GPRs: #1844, #1846, #1853, #1850, #1934, #2151,
  #2174
  (Gabriel Scherer, Nicolás Ojeda Bär, Frédéric Bour, Thomas Refis
   and François Pottier,
   review by Nicolás Ojeda Bär, Leo White and David Allsopp)

- #374: use Misc.try_finally for resource cleanup in the compiler
  codebase. This should fix the problem of catch-and-reraise `try .. with`
  blocks destroying backtrace information -- in the compiler.
  (François Bobot, help from Gabriel Scherer and Nicolás Ojeda Bär,
   review by Gabriel Scherer)

- #1148, #1287, #1288, #1874: significant improvements
  of the tools/check-typo script used over the files of the whole repository;
  contributors are now expected to check that check-typo passes on their
  pull requests; see CONTRIBUTING.md for more details.
  (David Allsopp, review by Damien Doligez and Sébastien Hinderer)

- #1610, #2252: Remove positions from paths
  (Leo White, review by Frédéric Bour and Thomas Refis)

- #1745: do not generalize the type of every sub-pattern,
  only of variables. (preliminary work for GADTs in or-patterns)
  (Thomas Refis, review by Leo White)

- #1909: unsharing pattern types (preliminary work for GADTs in or-patterns)
  (Thomas Refis, with help from Leo White, review by Jacques Garrigue)

- #1748: do not error when instantiating polymorphic fields in patterns.
  (Thomas Refis, review by Gabriel Scherer)

- #2317: type_let: be more careful generalizing parts of the pattern
  (Thomas Refis and Leo White, review by Jacques Garrigue)

- #1746: remove unreachable error variant: Make_seltype_nongen.
  (Florian Angeletti, review by Gabriel Radanne)

- #1747: type_cases: always propagate (preliminary work
  for GADTs in or-patterns)
  (Thomas Refis, review by Jacques Garrigue)

- #1811: shadow the polymorphic comparison in the middle-end
  (Xavier Clerc, review by Pierre Chambart)

- #1833: allow non-val payloads in CMM Ccatch handlers
  (Simon Fowler, review by Xavier Clerc)

- #1866: document the release process
  (Damien Doligez and Gabriel Scherer, review by Sébastien Hinderer,
   Perry E. Metzger, Xavier Leroy and David Allsopp)

- #1886: move the Location.absname reference to Clflags.absname
  (Armaël Guéneau, review by Jérémie Dimino)

- #1894: generalize highlight_dumb in location.ml to handle highlighting
  several locations
  (Armaël Guéneau, review by Gabriel Scherer)

- #1903: parsetree, add locations to all nodes with attributes
  (Gabriel Scherer, review by Thomas Refis)

- #1905: add check-typo-since to check the files changed
  since a given git reference
  (Gabriel Scherer, review by David Allsopp)

- #1910: improve the check-typo use of .gitattributes
  (Gabriel Scherer, review by David Allsopp and Damien Doligez)

- #1938: always check ast invariants after preprocessing
  (Florian Angeletti, review by Alain Frisch and Gabriel Scherer)

- #1941: refactor the command line parsing of ocamlcp and ocamloptp
  (Valentin Gatien-Baron, review by Florian Angeletti)

- #1948: Refactor Stdlib.Format. Notably, use Stdlib.Stack and Stdlib.Queue,
  and avoid exceptions for control flow.
  (Vladimir Keleshev, review by Nicolás Ojeda Bär and Gabriel Scherer)

* #1952: refactor the code responsible for displaying errors and warnings
  `Location.report_error` is removed, use `Location.print_report` instead
  (Armaël Guéneau, review by Thomas Refis)

- #7835, #1980, #8548, #8586: separate scope from stamp in idents and explicitly
  rescope idents when substituting signatures.
  (Thomas Refis, review by Jacques Garrigue and Leo White)

- #1996: expose Pprintast.longident to help compiler-libs users print
  Longident.t values.
  (Gabriel Scherer, review by Florian Angeletti and Thomas Refis)

- #2030: makefile targets to build AST files of sources
  for parser testing. See parsing/HACKING.adoc.
  (Gabriel Scherer, review by Nicolás Ojeda Bär)

* #2041: add a cache for looking up files in the load path
  (Jérémie Dimino, review by Alain Frisch and David Allsopp)

- #2047, #2269: a new type for unification traces
  (Florian Angeletti, report by Leo White (#2269),
   review by Thomas Refis and Gabriel Scherer)

- #2055: Add [Linearize.Lprologue].
  (Mark Shinwell, review by Pierre Chambart)

- #2056: Use [Backend_var] rather than [Ident] from [Clambda] onwards;
  use [Backend_var.With_provenance] for variables in binding position.
  (Mark Shinwell, review by Pierre Chambart)

- #2060: "Phantom let" support for the Clambda language.
  (Mark Shinwell, review by Vincent Laviron)

- #2065: Add [Proc.destroyed_at_reloadretaddr].
  (Mark Shinwell, review by Damien Doligez)

- #2070: "Phantom let" support for the Cmm language.
  (Mark Shinwell, review by Vincent Laviron)

- #2072: Always associate a scope to a type
  (Thomas Refis, review by Jacques Garrigue and Leo White)

- #2074: Correct naming of record field inside [Ialloc] terms.
  (Mark Shinwell, review by Jérémie Dimino)

- #2076: Add [Targetint.print].
  (Mark Shinwell)

- #2080: Add [Proc.dwarf_register_numbers] and
  [Proc.stack_ptr_dwarf_register_number].
  (Mark Shinwell, review by Bernhard Schommer)

- #2088: Add [Clambda.usymbol_provenance].
  (Mark Shinwell, review by Damien Doligez)

- #2152, #2517: refactorize the fixpoint to compute type-system
  properties of mutually-recursive type declarations.
  (Gabriel Scherer and Rodolphe Lepigre, review by Armaël Guéneau)

- #2156: propagate more type information through Lambda and Clambda
  intermediate language, as a preparation step for more future optimizations
  (Pierre Chambart and Alain Frisch, cross-reviewed by themselves)

- #2160: restore --disable-shared support and ensure testsuite runs correctly
  when compiled without shared library support.
  (David Allsopp, review by Damien Doligez and Sébastien Hinderer)

* #2173: removed TypedtreeMap
  (Thomas Refis, review by Gabriel Scherer)

- #7867: Fix #mod_use raising an exception for filenames with no
  extension.
  (Geoff Gole)

- #2100: Fix Unix.getaddrinfo when called on strings containing
  null bytes; it would crash the GC later on.
  (Armaël Guéneau, report and fix by Joe, review by Sébastien Hinderer)

- #7847, #2019: Fix an infinite loop that could occur when the
  (Menhir-generated) parser encountered a syntax error in a certain
  specific state.
  (François Pottier, report by Stefan Muenzel,
  review by Frédéric Bour, Thomas Refis, Gabriel Scherer)

- #1626: Do not allow recursive modules in `with module`
  (Leo White, review by Gabriel Radanne)

- #7726, #1676: Recursive modules, equi-recursive types and stack overflow
  (Jacques Garrigue, report by Jeremy Yallop, review by Leo White)

- #7723, #1698: Ensure `with module` and `with type` do not weaken
  module aliases.
  (Leo White, review by Gabriel Radanne and Jacques Garrigue)

- #1719: fix Pervasives.LargeFile functions under Windows.
  (Alain Frisch)

- #1739: ensure ocamltest waits for child processes to terminate on Windows.
  (David Allsopp, review by Sébastien Hinderer)

- #7554, #1751: Lambda.subst: also update debug event environments
  (Thomas Refis, review by Gabriel Scherer)

- #7238, #1825: in Unix.in_channel_of_descr and Unix.out_channel_of_descr,
  raise an error if the given file description is not suitable for
  character-oriented I/O, for example if it is a block device or a
  datagram socket.
  (Xavier Leroy, review by Jérémie Dimino and Perry E. Metzger)

- #7799, #1820: fix bug where Scanf.format_from_string could fail when
  the argument string contained characters that require escaping.
  (Gabriel Scherer and Nicolás Ojeda Bär, report by Guillaume Melquiond, review
  by Gabriel Scherer)

- #1843: ocamloptp was doing the wrong thing with option -inline-max-unroll.
  (Github user @poechsel, review by Nicolás Ojeda Bär).

- #1890: remove last use of Ctype.unroll_abbrev
  (Thomas Refis, report by Leo White, review by Jacques Garrigue)

- #1893: dev-branch only, warning 40(name not in scope) triggered spurious
  warnings 49(missing cmi) with -no-alias-deps.
  (Florian Angeletti, report by Valentin Gatien-Baron,
  review by Gabriel Scherer)

- #1912: Allow quoted strings, octal/unicode escape sequences and identifiers
  containing apostrophes in ocamllex actions and comments.
  (Pieter Goetschalckx, review by Damien Doligez)

- #7828, #1935: correct the conditions that generate warning 61,
  Unboxable_type_in_prim_decl
  (Stefan Muenzel)

- #1958: allow [module M(_:S) = struct end] syntax
  (Hugo Heuzard, review by Gabriel Scherer)

- #1970: fix order of floatting documentation comments in classes
  (Hugo Heuzard, review by Nicolás Ojeda Bär)

- #1977: [@@ocaml.warning "..."] attributes attached to type declarations are
  no longer ignored.
  (Nicolás Ojeda Bär, review by Gabriel Scherer)

- #7830, #1987: fix ocamldebug crash when printing a value in the scope of
  an `open` statement for which the `.cmi` is not available.
  (Nicolás Ojeda Bär, report by Jocelyn Sérot, review by Gabriel Scherer)

- #7854, #2062: fix an issue where the wrong locale may be used when using
  the legacy ANSI encoding under Windows.
  (Nicolás Ojeda Bär, report by Tiphaine Turpin)

- #2083: Fix excessively aggressive float unboxing and introduce similar fix
  as a preventative measure for boxed int unboxing.
  (Thomas Refis, Mark Shinwell, Leo White)

- #2130: fix printing of type variables with a quote in their name
  (Alain Frisch, review by Armaël Guéneau and Gabriel Scherer,
  report by Hugo Heuzard)

- #2131: fix wrong calls to Env.normalize_path on non-module paths
  (Alain Frisch, review by Jacques Garrigue)

- #2175: Apply substitution to all modules when packing
  (Leo White, review by Gabriel Scherer)

- #2220: Remove duplicate process management code in
  otherlibs/threads/unix.ml
  (Romain Beauxis, review by Gabriel Scherer and Alain Frisch)

- #2231: Env: always freshen persistent signatures before using them
  (Thomas Refis and Leo White, review by Gabriel Radanne)

- #7851, #8570: Module type of allows to transform a malformed
  module type into a vicious signature, breaking soundness
  (Jacques Garrigue, review by Leo White)

- #7923, #2259: fix regression in FlexDLL bootstrapped build caused by
  refactoring the root Makefile for Dune in #2093)
  (David Allsopp, report by Marc Lasson)

- #7929, #2261: Subst.signature: call cleanup_types exactly once
  (Thomas Refis, review by Gabriel Scherer and Jacques Garrigue,
  report by Daniel Bünzli and Jon Ludlam)

- #8550, #8552: Soundness issue with class generalization
  (Jacques Garrigue, review by Leo White and Thomas Refis,
  report by Jeremy Yallop)

OCaml 4.07.1 (4 October 2018)
-----------------------------

### Bug fixes:

- #7815, #1896: major GC crash with first-fit policy
  (Stephen Dolan and Damien Doligez, report by Joris Giovannangeli)

* #7818, #2051: Remove local aliases in functor argument types,
  to prevent the aliasing of their target.
  (Jacques Garrigue, report by mandrykin, review by Leo White)

- #7820, #1897: Fix Array.of_seq. This function used to apply a circular
  permutation of one cell to the right on the sequence.
  (Thierry Martinez, review by Nicolás Ojeda Bär)

- #7821, #1908: make sure that the compilation of extension
  constructors doesn't cause the compiler to load more cmi files
  (Jérémie Dimino, review by Gabriel Scherer)

- #7824, #1914: subtype_row: filter out absent fields when row is closed
  (Leo White and Thomas Refis, report by talex, review by Jacques Garrigue)

- #1915: rec_check.ml is too permissive for certain class declarations.
  (Alban Reynaud with Gabriel Scherer, review by Jeremy Yallop)

- #7833, #1946: typecore: only 1k existential per match, not 100k
  (Thomas Refis, report by Jerome Simeon, review by Jacques Garrigue)

- #7838: -principal causes assertion failure in type checker
  (Jacques Garrigue, report by Markus Mottl, review by Thomas Refis)

OCaml 4.07.0 (10 July 2018)
---------------------------

(Changes that can break existing programs are marked with a "*")

### Language features:

- #6023, #1648: Allow type-based selection of GADT constructors.
  (Thomas Refis and Leo White, review by Jacques Garrigue and Gabriel Scherer)

- #1546: Allow empty variants.
